Package: S7
Title: An Object Oriented System Meant to Become a Successor to S3 and
        S4
Version: 0.2.2
Authors@R: c(
    person("Object-Oriented Programming Working Group", role = "cph"),
    person("Davis", "Vaughan", role = "aut"),
    person("Jim", "Hester", role = "aut",
           comment = c(ORCID = "0000-0002-2739-7082")),
    person("Tomasz", "Kalinowski", role = "aut"),
    person("Will", "Landau", role = "aut"),
    person("Michael", "Lawrence", role = "aut"),
    person("Martin", "Maechler", role = "aut",
           comment = c(ORCID = "0000-0002-8685-9910")),
    person("Luke", "Tierney", role = "aut"),
    person("Hadley", "Wickham", , "hadley@posit.co", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0003-4757-117X"))
  )
Description: A new object oriented programming system designed to be a
    successor to S3 and S4. It includes formal class, generic, and method
    specification, and a limited form of multiple dispatch. It has been
    designed and implemented collaboratively by the R Consortium
    Object-Oriented Programming Working Group, which includes
    representatives from R-Core, 'Bioconductor', 'Posit'/'tidyverse', and
    the wider R community.
License: MIT + file LICENSE
URL: https://rconsortium.github.io/S7/,
        https://github.com/RConsortium/S7
BugReports: https://github.com/RConsortium/S7/issues
Depends: R (>= 3.5.0)
Imports: utils
Suggests: bench, callr, covr, knitr, methods, rmarkdown, testthat (>=
        3.2.0), tibble
VignetteBuilder: knitr
Config/build/compilation-database: true
Config/Needs/website: sloop
Config/testthat/edition: 3
Config/testthat/parallel: TRUE
Config/testthat/start-first: external-generic
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2026-04-20 21:37:20 UTC; hadleywickham
Author: Object-Oriented Programming Working Group [cph],
  Davis Vaughan [aut],
  Jim Hester [aut] (ORCID: <https://orcid.org/0000-0002-2739-7082>),
  Tomasz Kalinowski [aut],
  Will Landau [aut],
  Michael Lawrence [aut],
  Martin Maechler [aut] (ORCID: <https://orcid.org/0000-0002-8685-9910>),
  Luke Tierney [aut],
  Hadley Wickham [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-4757-117X>)
Maintainer: Hadley Wickham <hadley@posit.co>
Repository: CRAN
Date/Publication: 2026-04-22 11:00:10 UTC

Package: t2
Title: What the Package Does (One Line, Title Case)
Version: 0.0.0.9000
Authors@R:
    c(person(given = "Jim",
             family = "Hester",
             role = c("aut", "cre"),
             email = "james.f.hester@gmail.com",
             comment = c(ORCID = "0000-0002-2739-7082")),
      person(given = "RStudio",
             role = c("cph", "fnd")))
Description: What the package does (one paragraph).
Imports: S7, t0
Suggests: t1
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2

<!-- README.md is generated from README.Rmd. Please edit that file -->

# S7

<!-- badges: start -->

[![Lifecycle:
experimental](https://img.shields.io/badge/lifecycle-experimental-orange.svg)](https://lifecycle.r-lib.org/articles/stages.html#experimental)
[![R-CMD-check](https://github.com/RConsortium/S7/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/RConsortium/S7/actions/workflows/R-CMD-check.yaml)
[![Codecov test
coverage](https://codecov.io/gh/RConsortium/S7/branch/main/graph/badge.svg)](https://app.codecov.io/gh/RConsortium/S7?branch=main)
<!-- badges: end -->

The S7 package is a new OOP system designed to be a successor to S3 and
S4. It has been designed and implemented collaboratively by the R
Consortium Object-Oriented Programming Working Group, which includes
representatives from R-Core, Bioconductor, the tidyverse/Posit, and the
wider R community.

S7 is somewhat experimental; we are confident in the design but it has
relatively little usage in the wild currently. We hope to avoid any
major breaking changes, but reserve the right if we discover major
problems.

## Installation

The long-term goal of this project is to merge S7 in to base R. For now,
you can experiment by installing it from CRAN:

``` r
install.packages("S7")
```

## Usage

This section gives a very brief overview of the entirety of S7. Learn
more of the basics in `vignette("S7")`, generics and methods in
`vignette("generics-methods")`, classes and objects in
`vignette("classes-objects")`, and compatibility with S3 and S4 in
`vignette("compatibility")`.

``` r
library(S7)
```

### Classes and objects

S7 classes have a formal definition, which includes a list of properties
and an optional validator. Use `new_class()` to define a class:

``` r
range <- new_class("range",
  properties = list(
    start = class_double,
    end = class_double
  ),
  validator = function(self) {
    if (length(self@start) != 1) {
      "@start must be length 1"
    } else if (length(self@end) != 1) {
      "@end must be length 1"
    } else if (self@end < self@start) {
      "@end must be greater than or equal to @start"
    }
  }
)
```

`new_class()` returns the class object, which is also the constructor
you use to create instances of the class:

``` r
x <- range(start = 1, end = 10)
x
#> <range>
#>  @ start: num 1
#>  @ end  : num 10
```

### Properties

The data possessed by an object is called its **properties**. Use `@` to
get and set properties:

``` r
x@start
#> [1] 1
x@end <- 20
x
#> <range>
#>  @ start: num 1
#>  @ end  : num 20
```

Properties are automatically validated against the type declared in
`new_class()` (`double` in this case), and with the class **validator**:

``` r
x@end <- "x"
#> Error: <range>@end must be <double>, not <character>
x@end <- -1
#> Error: <range> object is invalid:
#> - @end must be greater than or equal to @start
```

### Generics and methods

Like S3 and S4, S7 uses **functional OOP** where methods belong to
**generic** functions, and method calls look like all other function
calls: `generic(object, arg2, arg3)`. This style is called functional
because from the outside it looks like a regular function call, and
internally the components are also functions.

Use `new_generic()` to create a new generic: the first argument is the
generic name (used in error messages) and the second gives the arguments
used for dispatch. The third, and optional argument, supplies the body
of the generic. This is only needed if your generic has additional
arguments that aren’t used for method dispatch.

``` r
inside <- new_generic("inside", "x")
```

Once you have a generic, you can define a method for a specific class
with `method<-`:

``` r
# Add a method for our class
method(inside, range) <- function(x, y) {
  y >= x@start & y <= x@end
}

inside(x, c(0, 5, 10, 15))
#> [1] FALSE  TRUE  TRUE  TRUE
```

You can use `method<-` to register methods for base types on S7
generics, and S7 classes on S3 or S4 generics. See
`vignette("compatibility")` for more details.

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(S7)

## ----performance, cache = FALSE-----------------------------------------------
Text <- new_class("Text", parent = class_character)
Number <- new_class("Number", parent = class_double)

x <- Text("hi")
y <- Number(1)

foo_S7 <- new_generic("foo_S7", "x")
method(foo_S7, Text) <- function(x, ...) paste0(x, "-foo")

foo_S3 <- function(x, ...) {
  UseMethod("foo_S3")
}

foo_S3.Text <- function(x, ...) {
  paste0(x, "-foo")
}

library(methods)
setOldClass(c("Number", "numeric", "S7_object"))
setOldClass(c("Text", "character", "S7_object"))

setGeneric("foo_S4", function(x, ...) standardGeneric("foo_S4"))
setMethod("foo_S4", c("Text"), function(x, ...) paste0(x, "-foo"))

# Measure performance of single dispatch
bench::mark(foo_S7(x), foo_S3(x), foo_S4(x))

bar_S7 <- new_generic("bar_S7", c("x", "y"))
method(bar_S7, list(Text, Number)) <- function(x, y, ...) paste0(x, "-", y, "-bar")

setGeneric("bar_S4", function(x, y, ...) standardGeneric("bar_S4"))
setMethod("bar_S4", c("Text", "Number"), function(x, y, ...) paste0(x, "-", y, "-bar"))

# Measure performance of double dispatch
bench::mark(bar_S7(x, y), bar_S4(x, y))

## ----performance-2, message = FALSE, R.options = list(width = 120), cache = TRUE--------------------------------------
library(S7)

gen_character <- function (n, min = 5, max = 25, values = c(letters, LETTERS, 0:9)) {
  lengths <- sample(min:max, replace = TRUE, size = n)
  values <- sample(values, sum(lengths), replace = TRUE)
  starts <- c(1, cumsum(lengths)[-n] + 1)
  ends <- cumsum(lengths)
  mapply(function(start, end) paste0(values[start:end], collapse=""), starts, ends)
}

bench::press(
  num_classes = c(3, 5, 10, 50, 100),
  class_nchar = c(15, 100),
  {
    # Construct a class hierarchy with that number of classes
    Text <- new_class("Text", parent = class_character)
    parent <- Text
    classes <- gen_character(num_classes, min = class_nchar, max = class_nchar)
    env <- new.env()
    for (x in classes) {
      assign(x, new_class(x, parent = parent), env)
      parent <- get(x, env)
    }

    # Get the last defined class
    cls <- parent

    # Construct an object of that class
    x <- do.call(cls, list("hi"))

    # Define a generic and a method for the last class (best case scenario)
    foo_S7 <- new_generic("foo_S7", "x")
    method(foo_S7, cls) <- function(x, ...) paste0(x, "-foo")

    # Define a generic and a method for the first class (worst case scenario)
    foo2_S7 <- new_generic("foo2_S7", "x")
    method(foo2_S7, S7_object) <- function(x, ...) paste0(x, "-foo")

    bench::mark(
      best = foo_S7(x),
      worst = foo2_S7(x)
    )
  }
)

## ----performance-3, message = FALSE, R.options = list(width = 120), cache = TRUE--------------------------------------
bench::press(
  num_classes = c(3, 5, 10, 50, 100),
  class_nchar = c(15, 100),
  {
    # Construct a class hierarchy with that number of classes
    Text <- new_class("Text", parent = class_character)
    parent <- Text
    classes <- gen_character(num_classes, min = class_nchar, max = class_nchar)
    env <- new.env()
    for (x in classes) {
      assign(x, new_class(x, parent = parent), env)
      parent <- get(x, env)
    }

    # Get the last defined class
    cls <- parent

    # Construct an object of that class
    x <- do.call(cls, list("hi"))
    y <- do.call(cls, list("ho"))

    # Define a generic and a method for the last class (best case scenario)
    foo_S7 <- new_generic("foo_S7", c("x", "y"))
    method(foo_S7, list(cls, cls)) <- function(x, y, ...) paste0(x, y, "-foo")

    # Define a generic and a method for the first class (worst case scenario)
    foo2_S7 <- new_generic("foo2_S7", c("x", "y"))
    method(foo2_S7, list(S7_object, S7_object)) <- function(x, y, ...) paste0(x, y, "-foo")

    bench::mark(
      best = foo_S7(x, y),
      worst = foo2_S7(x, y)
    )
  }
)

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(S7)

## -----------------------------------------------------------------------------
Range <- new_class("Range",
  properties = list(
    start = class_double,
    end = class_double
  ),
  validator = function(self) {
    if (length(self@start) != 1) {
      "@start must be length 1"
    } else if (length(self@end) != 1) {
      "@end must be length 1"
    } else if (self@end < self@start) {
      sprintf(
        "@end (%i) must be greater than or equal to @start (%i)",
        self@end,
        self@start
      )
    }
  }
)

## ----error = TRUE-------------------------------------------------------------
try({
x <- Range(1, 2:3)
x <- Range(10, 1)

x <- Range(1, 10)
x@start <- 20
})

## ----error = TRUE-------------------------------------------------------------
try({
x <- Range(1, 2)
attr(x, "start") <- 3
validate(x)
})

## -----------------------------------------------------------------------------
shift <- function(x, shift) {
  x@start <- x@start + shift
  x@end <- x@end + shift
  x
}
shift(Range(1, 10), 1)

## ----error = TRUE-------------------------------------------------------------
try({
shift(Range(1, 10), 10)
})

## -----------------------------------------------------------------------------
shift <- function(x, shift) {
  props(x) <- list(
    start = x@start + shift,
    end = x@end + shift
  )
  x
}
shift(Range(1, 10), 10)

## -----------------------------------------------------------------------------
Range <- new_class("Range",
  properties = list(
    start = new_property(class_double),
    end = new_property(class_double)
  )
)

## ----error = TRUE-------------------------------------------------------------
try({
prop_number <- new_property(
  class = class_double,
  validator = function(value) {
    if (length(value) != 1L) "must be length 1"
  }
)

Range <- new_class("Range",
  properties = list(
    start = prop_number,
    end = prop_number
  ),
  validator = function(self) {
    if (self@end < self@start) {
      sprintf(
        "@end (%i) must be greater than or equal to @start (%i)",
        self@end,
        self@start
      )
    }
  }
)

Range(start = c(1.5, 3.5))
Range(end = c(1.5, 3.5))
})

## -----------------------------------------------------------------------------
Empty <- new_class("Empty",
  properties = list(
    x = class_double,
    y = class_character,
    z = class_logical
  ))
Empty()

## -----------------------------------------------------------------------------
Empty <- new_class("Empty",
  properties = list(
    x = new_property(class_numeric, default = 0),
    y = new_property(class_character, default = ""),
    z = new_property(class_logical, default = NA)
  )
)
Empty()

## -----------------------------------------------------------------------------
Stopwatch <- new_class("Stopwatch", properties = list(
  start_time = new_property(
    class = class_POSIXct,
    default = quote(Sys.time())
  ),
  elapsed = new_property(
    getter = function(self) {
      difftime(Sys.time(), self@start_time, units = "secs")
    }
  )
))
args(Stopwatch)
round(Stopwatch()@elapsed)
round(Stopwatch(Sys.time() - 1)@elapsed)

## -----------------------------------------------------------------------------
Range <- new_class("Range",
  properties = list(
    start = class_double,
    end = class_double,
    length = new_property(
      getter = function(self) self@end - self@start
    )
  )
)

x <- Range(start = 1, end = 10)
x

## ----error = TRUE-------------------------------------------------------------
try({
x@length <- 20
})

## -----------------------------------------------------------------------------
Range <- new_class("Range",
  properties = list(
    start = class_double,
    end = class_double,
    length = new_property(
      class = class_double,
      getter = function(self) self@end - self@start,
      setter = function(self, value) {
        if (!length(value)) {
          # Do nothing if called with the constructor default
          # value for this property, a zero-length double vector.
          return(self)
        }
        self@end <- self@start + value
        self
      }
    )
  )
)

x <- Range(start = 1, end = 10)
x

x@length <- 5
x

## -----------------------------------------------------------------------------
Person <- new_class("Person", properties = list(
 first_name = class_character,
 firstName = new_property(
    class_character,
    default = quote(first_name),
    getter = function(self) {
      warning("@firstName is deprecated; please use @first_name instead", call. = FALSE)
      self@first_name
    },
    setter = function(self, value) {
      if (identical(value, self@first_name)) {
        return(self)
      }
      warning("@firstName is deprecated; please use @first_name instead", call. = FALSE)
      self@first_name <- value
      self
    }
  )
))

args(Person)

hadley <- Person(firstName = "Hadley")

hadley <- Person(first_name = "Hadley") # no warning

hadley@firstName

hadley@firstName <- "John"

hadley@first_name  # no warning

## -----------------------------------------------------------------------------
Person <- new_class("Person", properties = list(
 name = new_property(
   class_character,
   validator = function(value) {
     if (length(value) != 1 || is.na(value) || value == "")
       "must be a non-empty string"
   }
 )
))

try(Person())

try(Person(1)) # class_character$validator() is also checked.

Person("Alice")

## -----------------------------------------------------------------------------
Person <- new_class("Person", properties = list(
 name = new_property(
   class_character,
   default = quote(stop("@name is required")))
))

try(Person())

Person("Alice")

## -----------------------------------------------------------------------------
Person <- new_class("Person", properties = list(
 birth_date = new_property(
   class_Date,
   setter = function(self, value) {
     if(!is.null(self@birth_date)) {
       stop("@birth_date is read-only", call. = FALSE)
     }
     self@birth_date <- as.Date(value)
     self
   }
)))

person <- Person("1999-12-31")

try(person@birth_date <- "2000-01-01")

## -----------------------------------------------------------------------------
Range@constructor

## -----------------------------------------------------------------------------
Range <- new_class("Range",
  properties = list(
    start = class_numeric,
    end = class_numeric
  ),
  constructor = function(x) {
    new_object(S7_object(),
               start = min(x, na.rm = TRUE),
               end = max(x, na.rm = TRUE))
  }
)

Range(c(10, 5, 0, 2, 5, 7))

#' Validate an S7 object
#'
#' @description
#' `validate()` ensures that an S7 object is valid by calling the `validator`
#' provided in [new_class()]. This is done automatically when constructing new
#' objects and when modifying properties.
#'
#' `valid_eventually()` disables validation, modifies the object, then
#' revalidates. This is useful when a sequence of operations would otherwise
#' lead an object to be temporarily invalid, or when repeated property
#' modification causes a performance bottleneck because the validator is
#' relatively expensive.
#'
#' `valid_implicitly()` does the same but does not validate the object at the
#' end. It should only be used rarely, and in performance critical code where
#' you are certain a sequence of operations cannot produce an invalid object.
#' @param object An S7 object
#' @param fun A function to call on the object before validation.
#' @param recursive If `TRUE`, calls validator of parent classes recursively.
#' @param properties If `TRUE`, the default, checks property types before
#'   executing the validator.
#' @returns Either `object` invisibly if valid, otherwise an error.
#' @export
#' @examples
#' # A range class might validate that the start is less than the end
#' Range <- new_class("Range",
#'   properties = list(start = class_double, end = class_double),
#'   validator = function(self) {
#'     if (self@start >= self@end) "start must be smaller than end"
#'   }
#' )
#' # You can't construct an invalid object:
#' try(Range(1, 1))
#'
#' # And you can't create an invalid object with @<-
#' r <- Range(1, 2)
#' try(r@end <- 1)
#'
#' # But what if you want to move a range to the right?
#' rightwards <- function(r, x) {
#'   r@start <- r@start + x
#'   r@end <- r@end + x
#'   r
#' }
#' # This function doesn't work because it creates a temporarily invalid state
#' try(rightwards(r, 10))
#'
#' # This is the perfect use case for valid_eventually():
#' rightwards <- function(r, x) {
#'   valid_eventually(r, function(object) {
#'     object@start <- object@start + x
#'     object@end <- object@end + x
#'     object
#'   })
#' }
#' rightwards(r, 10)
#'
#' # Alternatively, you can set multiple properties at once using props<-,
#' # which validates once at the end
#' rightwards <- function(r, x) {
#'   props(r) <- list(start = r@start + x, end = r@end + x)
#'   r
#' }
#' rightwards(r, 20)
validate <- function(object, recursive = TRUE, properties = TRUE) {
  check_is_S7(object)

  if (!is.null(attr(object, ".should_validate"))) {
    return(invisible(object))
  }

  class <- S7_class(object)

  # First, check property types - if these are incorrect, the validator
  # is likely to return spurious errors
  if (properties) {
    errors <- validate_properties(object, class)
    if (length(errors) > 0) {
      bullets <- paste0("- ", errors, collapse = "\n")
      msg <- sprintf("%s object properties are invalid:\n%s", obj_desc(object), bullets)
      stop(msg, call. = FALSE)
    }
  }

  # Next, recursively validate the object
  errors <- character()
  repeat {
    error <- class_validate(class, object)
    if (is.null(error)) {

    } else if (is.character(error)) {
      append(errors) <- error
    } else {
      stop(sprintf(
        "%s validator must return NULL or a character, not <%s>.",
        obj_desc(class), typeof(error)
      ))
    }
    if (!is_class(class) || !recursive) break
    class <- class@parent
  }

  # If needed, report errors
  if (length(errors) > 0) {
    bullets <- paste0("- ", errors, collapse = "\n")
    msg <- sprintf("%s object is invalid:\n%s", obj_desc(object), bullets)
    stop(msg, call. = FALSE)
  }

  invisible(object)
}

validate_properties <- function(object, class) {
  errors <- character()

  for (prop_obj in class@properties) {
    # Don't validate dynamic properties
    if (!is.null(prop_obj$getter)) {
      next
    }

    value <- prop(object, prop_obj$name)
    errors <- c(errors, prop_validate(prop_obj, value))
  }

  errors
}

#' @rdname validate
#' @export
valid_eventually <- function(object, fun) {
  old <- attr(object, ".should_validate")
  attr(object, ".should_validate") <- FALSE
  out <- fun(object)
  attr(out, ".should_validate") <- old
  validate(out)

  out
}

#' @rdname validate
#' @export
valid_implicitly <- function(object, fun) {
  old <- attr(object, ".should_validate")
  attr(object, ".should_validate") <- FALSE
  out <- fun(object)
  attr(out, ".should_validate") <- old

  out
}

#' Dispatch on a missing argument
#'
#' Use `class_missing` to dispatch when the user has not supplied an argument,
#' i.e. it's missing in the sense of [missing()], not in the sense of
#' [is.na()].
#'
#' @export
#' @return Sentinel objects used for special types of dispatch.
#' @format NULL
#' @examples
#' foo <- new_generic("foo", "x")
#' method(foo, class_numeric) <- function(x) "number"
#' method(foo, class_missing) <- function(x) "missing"
#' method(foo, class_any) <- function(x) "fallback"
#'
#' foo(1)
#' foo()
#' foo("")
class_missing <- structure(list(), class = "S7_missing")

is_class_missing <- function(x) inherits(x, "S7_missing")

#' @export
print.S7_missing <- function(x, ...) {
  cat("<S7_missing>\n")
  invisible(x)
}
#' @export
str.S7_missing <- function(object, ..., nest.lev = 0) {
  cat(if (nest.lev > 0) " ")
  print(object)
}

#' Dispatch on any class
#'
#' Use `class_any` to register a default method that is called when no other
#' methods are matched.
#'
#' @export
#' @format NULL
#' @examples
#' foo <- new_generic("foo", "x")
#' method(foo, class_numeric) <- function(x) "number"
#' method(foo, class_any) <- function(x) "fallback"
#'
#' foo(1)
#' foo("x")
class_any <- structure(list(), class = "S7_any")

is_class_any <- function(x) inherits(x, "S7_any")

#' @export
print.S7_any <- function(x, ...) {
  cat("<S7_any>\n")
  invisible(x)
}
#' @export
str.S7_any <- function(object, ..., nest.lev = 0) {
  cat(if (nest.lev > 0) " ")
  print(object)
}

#' Base S7 class
#'
#' The base class from which all S7 classes eventually inherit from.
#'
#' @keywords internal
#' @export
#' @return The base S7 object.
#' @examples
#'
#' S7_object
S7_object <- new_class(
  name = "S7_object",
  package = NULL,
  parent = NULL,
  constructor = function() {
    .Call(S7_object_)
  },
  validator = function(self) {
    if (!is_S7_type(self)) {
      "Underlying data is corrupt"
    }
  }
)
methods::setOldClass("S7_object")

.S7_type <- NULL
# Defined onLoad because it depends on R version
on_load_define_S7_type <- function() {
  .S7_type <<- typeof(.Call(S7_object_))
}
is_S7_type <- function(x) {
  typeof(x) == .S7_type
}

#' @export
`$.S7_object` <- function(x, name) {
  if (typeof(x) %in% c("list", "environment")) {
    NextMethod()
  } else {
    msg <- sprintf(
      "Can't get S7 properties with `$`. Did you mean `%s@%s`?",
      deparse1(substitute(x)),
      name
    )
    stop(msg, call. = FALSE)
  }
}
#' @export
`$<-.S7_object` <- function(x, name, value) {
  if (typeof(x) %in% c("list", "environment")) {
    NextMethod()
  } else {
    msg <- sprintf(
      "Can't set S7 properties with `$`. Did you mean `...@%s <- %s`?",
      name,
      deparse1(substitute(value))
    )
    stop(msg, call. = FALSE)
  }
}

#' @export
`[.S7_object` <- function(x, ..., drop = TRUE) {
  check_subsettable(x)
  NextMethod()
}
#' @export
`[<-.S7_object` <- function(x, ..., value) {
  check_subsettable(x)
  NextMethod()
}

#' @export
`[[.S7_object` <- function(x, ...) {
  check_subsettable(x, allow_env = TRUE)
  NextMethod()
}
#' @export
`[[<-.S7_object` <- function(x, ..., value) {
  check_subsettable(x, allow_env = TRUE)
  NextMethod()
}

check_subsettable <- function(x, allow_env = FALSE) {
  allowed_types <- c("list", "language", "pairlist", if (allow_env) "environment")
  if (!typeof(x) %in% allowed_types) {
    stop("S7 objects are not subsettable.")
  }
  invisible(TRUE)
}

S7_generic <- NULL

on_load_define_S7_generic <- function() {
  # we do this in .onLoad() because dynlib `prop_` symbol
  # is not available at pkg build time, and new_class()
  # errors if `@` is not usable.
  S7_generic <<- new_class(
    name = "S7_generic",
    package = NULL,
    properties = list(
      name = class_character,
      methods = class_environment,
      dispatch_args = class_character
    ),
    parent = class_function
  )
}

methods::setOldClass(c("S7_generic", "function", "S7_object"))
is_S7_generic <- function(x) inherits(x, "S7_generic")


S7_method <- NULL

on_load_define_S7_method <- function() {
  S7_method <<- new_class(
    "S7_method",
    package = NULL,
    parent = class_function,
    properties = list(generic = S7_generic, signature = class_list)
  )
}
methods::setOldClass(c("S7_method", "function", "S7_object"))

# hooks -------------------------------------------------------------------

.onAttach <- function(libname, pkgname) {
  env <- as.environment(paste0("package:", pkgname))
  if (getRversion() < "4.3.0") {
    env[[".conflicts.OK"]] <- TRUE
  }
}

.onLoad <- function(...) {
  activate_backward_compatiblility()

  on_load_define_S7_generic()
  on_load_define_S7_method()
  on_load_make_convert_generic()
  on_load_define_ops()
  on_load_define_or_methods()
  on_load_define_S7_type()
  on_load_define_union_classes()
}

new_base_class <- function(name, constructor_name = name) {
  force(name)

  constructor <- new_function(
    args = list(.data = base_default(name)),
    body = quote(.data),
    env = baseenv()
  )

  validator <- function(object) {
    if (base_class(object) != name) {
      sprintf("Underlying data must be <%s> not <%s>",
              name, base_class(object))
    }
  }

  validator <- utils::removeSource(validator)

  out <- list(
    class = name,
    constructor_name = constructor_name,
    constructor = constructor,
    validator = validator
  )
  class(out) <- "S7_base_class"
  out
}

#' @rawNamespace if (getRversion() >= "4.3.0") S3method(nameOfClass,S7_base_class)
nameOfClass.S7_base_class <- function(x) {
  x[["class"]]
}

base_default <- function(type) {
  switch(type,
    logical = logical(),
    integer = integer(),
    double = double(),
    complex = complex(),
    character = character(),
    raw = raw(),
    list = list(),
    expression = expression(),
    name = quote(quote(x)),
    call = quote(quote({})),

    `function` = quote(function() NULL),
    environment = quote(new.env(parent = emptyenv()))
)}


is_base_class <- function(x) inherits(x, "S7_base_class")

#' @export
print.S7_base_class <- function(x, ...) {
  cat("<S7_base_class>: ", class_desc(x), "\n", sep = "")
  invisible(x)
}

#' @export
str.S7_base_class <- function(object, ..., nest.lev = 0) {
  cat(if (nest.lev > 0) " ")
  print(object, ..., nest.lev = nest.lev)
}

#' S7 wrappers for base types
#'
#' @description
#' The following S7 classes represent base types allowing them to be used
#' within S7:
#'
#' * `class_logical`
#' * `class_integer`
#' * `class_double`
#' * `class_complex`
#' * `class_character`
#' * `class_raw`
#' * `class_list`
#' * `class_expression`
#' * `class_name`
#' * `class_call`
#' * `class_function`
#' * `class_environment` (can only be used for properties)
#'
#' We also include three union types to model numerics, atomics, and vectors
#' respectively:
#'
#' * `class_numeric` is a union of `class_integer` and `class_double`.
#' * `class_atomic` is a union of `class_logical`, `class_numeric`,
#'   `class_complex`, `class_character`, and `class_raw`.
#' * `class_vector` is a union of `class_atomic`, `class_list`, and
#'   `class_expression`.
#' * `class_language` is a union of `class_name` and `class_call`.
#'
#' @order 0
#' @name base_classes
#' @return S7 classes wrapping around common base types and S3 classes.
#' @examples
#'
#' class_integer
#' class_numeric
#' class_factor
NULL

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_logical <- new_base_class("logical")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_integer <- new_base_class("integer")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_double <- new_base_class("double")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_complex <- new_base_class("complex")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_character <- new_base_class("character")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_raw <- new_base_class("raw")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_list <- new_base_class("list")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_expression <- new_base_class("expression")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_name <- new_base_class("name")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_call <- new_base_class("call")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_function <- new_base_class("function", "fun")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 1
class_environment <- new_base_class("environment")

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 2
class_numeric <- NULL

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 2
class_atomic <- NULL

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 2
class_vector <- NULL

#' @export
#' @rdname base_classes
#' @format NULL
#' @order 2
class_language <- NULL

# Define onload to avoid dependencies between files
on_load_define_union_classes <- function() {
  class_numeric <<- new_union(class_integer, class_double)
  class_atomic <<- new_union(class_logical, class_numeric, class_complex, class_character, class_raw)
  class_vector <<- new_union(class_atomic, class_expression, class_list)
  class_language <<- new_union(class_name, class_call)
}

#' Does this object inherit from an S7 class?
#'
#' * `S7_inherits()` returns `TRUE` or `FALSE`.
#' * `check_is_S7()` throws an error if `x` isn't the specified `class`.
#'
#' @param x An object
#' @param class An S7 class or `NULL`. If `NULL`, tests whether `x` is an
#'   S7 object without testing for a specific class.
#' @param arg Argument name used in error message.
#' @returns
#' * `S7_inherits()` returns a single `TRUE` or `FALSE`.
#' * `check_is_S7()` returns nothing; it's called for its side-effects.
#'
#' @note Starting with \R 4.3.0, `base::inherits()` can accept an S7 class as
#' the second argument, supporting usage like `inherits(x, Foo)`.
#' @export
#' @examples
#' Foo1 <- new_class("Foo1")
#' Foo2 <- new_class("Foo2")
#'
#' S7_inherits(Foo1(), Foo1)
#' check_is_S7(Foo1())
#' check_is_S7(Foo1(), Foo1)
#'
#' S7_inherits(Foo1(), Foo2)
#' try(check_is_S7(Foo1(), Foo2))
#'
#' if (getRversion() >= "4.3.0")
#'   inherits(Foo1(), Foo1)
S7_inherits <- function(x, class = NULL) {
  if (!(is.null(class) || inherits(class, "S7_class"))) {
    stop("`class` must be an <S7_class> or NULL")
  }

  inherits(x, "S7_object") &&
    (is.null(class) || inherits(x, S7_class_name(class)))
}

#' @export
#' @rdname S7_inherits
# called from src/prop.c
check_is_S7 <- function(x, class = NULL, arg = deparse(substitute(x))) {
  if (S7_inherits(x, class)) {
    return(invisible())
  }

  msg <- sprintf(
    "`%s` must be %s, not a %s",
    arg,
    if (is.null(class)) "an <S7_object>" else paste0("a ", class_desc(class)),
    obj_desc(x)
  )
  stop(msg, call. = FALSE)
}

#' Define a class union
#'
#' @description
#' A class union represents a list of possible classes. You can create it
#' with `new_union(a, b, c)` or `a | b | c`. Unions can be used in two
#' places:
#'
#' * To allow a property to be one of a set of classes,
#'   `new_property(class_integer | Range)`. The default `default` value for the
#'   property will be the constructor of the first object in the union.
#'   This means if you want to create an "optional" property (i.e. one that
#'   can be `NULL` or of a specified type), you'll need to write (e.g.)
#'   `NULL | class_integer`.
#'
#' * As a convenient short-hand to define methods for multiple classes.
#'   `method(foo, X | Y) <- f` is short-hand for
#'   `method(foo, X) <- f; method(foo, Y) <- foo`
#'
#' S7 includes built-in unions for "numeric" (integer and double vectors),
#' "atomic" (logical, numeric, complex, character, and raw vectors) and
#' "vector" (atomic vectors, lists, and expressions).
#'
#' @param ... The classes to include in the union. See [as_class()] for
#'   details.
#' @return An S7 union, i.e. a list with class `S7_union`.
#' @export
#' @examples
#' logical_or_character <- new_union(class_logical, class_character)
#' logical_or_character
#' # or with shortcut syntax
#' logical_or_character <- class_logical | class_character
#'
#' Foo <- new_class("Foo", properties = list(x = logical_or_character))
#' Foo(x = TRUE)
#' Foo(x = letters[1:5])
#' try(Foo(1:3))
#'
#' bar <- new_generic("bar", "x")
#' # Use built-in union
#' method(bar, class_atomic) <- function(x) "Hi!"
#' bar
#' bar(TRUE)
#' bar(letters)
#' try(bar(NULL))
new_union <- function(...) {
  classes <- class_flatten(list(...))
  out <- list(classes = classes)
  class(out) <- "S7_union"
  out
}

#' @export
`|.S7_class` <- function(e1, e2) {
  new_union(e1, e2)
}
# Register remaining methods onLoad so that their pointers are identical,
# working around a bug that was fixed in R 4.1:
# https://github.com/wch/r-source/commit/b41344e3d0da7d78fd
on_load_define_or_methods <- function() {
  registerS3method("|", "S7_union", `|.S7_class`)
  registerS3method("|", "S7_base_class", `|.S7_class`)
  registerS3method("|", "S7_S3_class", `|.S7_class`)
  registerS3method("|", "S7_any", `|.S7_class`)
  registerS3method("|", "S7_missing", `|.S7_class`)
  registerS3method("|", "classGeneratorFunction", `|.S7_class`)
  registerS3method("|", "ClassUnionRepresentation", `|.S7_class`)
  registerS3method("|", "classRepresentation", `|.S7_class`)
}

is_union <- function(x) inherits(x, "S7_union")

#' @export
print.S7_union <- function(x, ...) {
  cat("<S7_union>: ", class_desc(x), "\n", sep = "")
  invisible(x)
}

#' @export
str.S7_union <- function(object, ..., nest.lev = 0) {
  cat(if (nest.lev > 0) " ")
  print(object)
}

class_flatten <- function(x) {
  x <- lapply(x, as_class)

  # Flatten unions
  is_union <- vlapply(x, is_union)
  x[!is_union] <- lapply(x[!is_union], list)
  x[is_union] <- lapply(x[is_union], function(x) x$classes)

  unique(unlist(x, recursive = FALSE, use.names = FALSE))
}

# See .onLoad() for definition
base_unions <- list()

#' Define a new property
#'
#' @description
#' A property defines a named component of an object. Properties are
#' typically used to store (meta) data about an object, and are often
#' limited to a data of a specific `class`.
#'
#' By specifying a `getter` and/or `setter`, you can make the property
#' "dynamic" so that it's computed when accessed or has some non-standard
#' behaviour when modified. Dynamic properties are not included as an argument
#' to the default class constructor.
#'
#' See the "Properties: Common Patterns" section in `vignette("class-objects")`
#' for more examples.
#'
#' @param class Class that the property must be an instance of.
#'   See [as_class()] for details.
#' @param getter An optional function used to get the value. The function
#'   should take `self` as its sole argument and return the value. If you
#'   supply a `getter`, you are responsible for ensuring that it returns
#'   an object of the correct `class`; it will not be validated automatically.
#'
#'   If a property has a getter but doesn't have a setter, it is read only.
#' @param setter An optional function used to set the value. The function
#'   should take `self` and `value` and return a modified object.
#' @param validator A function taking a single argument, `value`, the value
#'   to validate.
#'
#'   The job of a validator is to determine whether the property value is valid.
#'   It should return `NULL` if the object is valid, or if it's not valid,
#'   a single string describing the problem. The message should not include the
#'   name of the property as this will be automatically appended to the
#'   beginning of the message.
#'
#'   The validator will be called after the `class` has been verified, so
#'   your code can assume that `value` has known type.
#' @param default When an object is created and the property is not supplied,
#'   what should it default to? If `NULL`, it defaults to the "empty" instance
#'   of `class`. This can also be a quoted call, which then becomes a standard
#'   function promise in the default constructor, evaluated at the time the
#'   object is constructed.
#' @param name Property name, primarily used for error messages. Generally
#'   don't need to set this here, as it's more convenient to supply as 
#'   the element name when defining a list of properties. If both `name`
#'   and a list-name are supplied, the list-name will be used.
#' @returns An S7 property, i.e. a list with class `S7_property`.
#' @export
#' @examples
#' # Simple properties store data inside an object
#' Pizza <- new_class("Pizza", properties = list(
#'   slices = new_property(class_numeric, default = 10)
#' ))
#' my_pizza <- Pizza(slices = 6)
#' my_pizza@slices
#' my_pizza@slices <- 5
#' my_pizza@slices
#'
#' your_pizza <- Pizza()
#' your_pizza@slices
#'
#' # Dynamic properties can compute on demand
#' Clock <- new_class("Clock", properties = list(
#'   now = new_property(getter = function(self) Sys.time())
#' ))
#' my_clock <- Clock()
#' my_clock@now; Sys.sleep(1)
#' my_clock@now
#' # This property is read only, because there is a 'getter' but not a 'setter'
#' try(my_clock@now <- 10)
#'
#' # Because the property is dynamic, it is not included as an
#' # argument to the default constructor
#' try(Clock(now = 10))
#' args(Clock)
new_property <- function(class = class_any,
                         getter = NULL,
                         setter = NULL,
                         validator = NULL,
                         default = NULL,
                         name = NULL) {
  class <- as_class(class)
  check_prop_default(default, class)

  if (!is.null(getter)) {
    check_function(getter, alist(self = ))
  }
  if (!is.null(setter)) {
    check_function(setter, alist(self = , value = ))
  }
  if (!is.null(validator)) {
    check_function(validator, alist(value = ))
  }

  out <- list(
    name = name,
    class = class,
    getter = getter,
    setter = setter,
    validator = validator,
    default = default
  )
  class(out) <- "S7_property"

  out
}

check_prop_default <- function(default, class, error_call = sys.call(-1)) {
  if (is.null(default)) {
    return() # always valid.
  }

  if (is.call(default)) {
    # A promise default; delay checking until constructor called.
    return()
  }

  if (is.symbol(default)) {
    if (identical(default, quote(...))) {
      # The meaning of a `...` prop default needs discussion
      stop(simpleError("`default` cannot be `...`", error_call))
    }
    if (identical(default, quote(expr =))) {
      # The meaning of a missing prop default needs discussion
      stop(simpleError("`default` cannot be missing", error_call))
    }

    # other symbols are treated as promises
    return()
  }

  if (class_inherits(default, class))
    return()

  msg <- sprintf("`default` must be an instance of %s, not a %s",
                 class_desc(class), obj_desc(default))

  stop(simpleError(msg, error_call))
}

stop.parent <- function(..., call = sys.call(-2)) {
  stop(simpleError(.makeMessage(...), call))
}

is_property <- function(x) inherits(x, "S7_property")

#' @export
print.S7_property <- function(x, ...) {
  cat("<S7_property> \n")
  str_nest(x, "$", ...)
}

#' @export
str.S7_property <- function(object, ..., nest.lev = 0) {
  cat(if (nest.lev > 0) " ")
  print(object, ..., nest.lev = nest.lev)
}

prop_default <- function(prop, envir, package) {
  prop$default %||% class_construct_expr(prop$class, envir, package)
}

#' Get/set a property
#'
#' - `prop(x, "name")` / `prop@name` get the value of the a property,
#'   erroring if it the property doesn't exist.
#' - `prop(x, "name") <- value` / `prop@name <- value` set the value of
#'   a property.
#'
#' @param object An object from a S7 class
#' @param name The name of the parameter as a character. Partial matching
#'   is not performed.
#' @param value A new value for the property. The object is automatically
#'   checked for validity after the replacement is done.
#' @return `prop()` and `@` return the value of the property.
#'   `prop<-()` and `@<-` are called for their side-effects and return
#'    the modified object, invisibly.
#' @export
#' @examples
#' Horse <- new_class("Horse", properties = list(
#'   name = class_character,
#'   colour = class_character,
#'   height = class_numeric
#' ))
#' lexington <- Horse(colour = "bay", height = 15, name = "Lex")
#' lexington@colour
#' prop(lexington, "colour")
#'
#' lexington@height <- 14
#' prop(lexington, "height") <- 15
prop <- function(object, name) {
  .Call(prop_, object, name)
}

propr <- function(object, name) {
  # reference implementation of `prop()` implemented in R
  check_is_S7(object)

  if (!prop_exists(object, name)) {
    stop(prop_error_unknown(object, name), call. = FALSE)
  } else {
    prop_val(object, name)
  }
}

signal_prop_error_unknown <- function(object, name) {
  stop(prop_error_unknown(object, name), call. = FALSE)
}

# Internal helper that assumes the property exists
prop_val <- function(object, name) {
  val <- attr(object, name, exact = TRUE)
  if (is.null(val)) {
    prop <- prop_obj(object, name)
    if (!is.null(prop$getter)) {
      val <- prop$getter(object)
    }
  }
  val
}

# Get underlying property object from class
prop_obj <- function(object, name) {
  class <- S7_class(object)
  attr(class, "properties")[[name]]
}

#' @rdname prop
#' @param check If `TRUE`, check that `value` is of the correct type and run
#'   [validate()] on the object before returning.
#' @export
`prop<-` <- function(object, name, check = TRUE, value) {
  .Call(prop_set_, object, name, check, value)
}

`propr<-` <- local({
    # reference implementation of `prop<-()` implemented in R
  # This flag is used to avoid infinite loops if you are assigning a property from a setter function
  setter_property <- NULL

  function(object, name, check = TRUE, value) {
    check_is_S7(object)

    prop <- prop_obj(object, name)
    if (is.null(prop)) {
      stop(prop_error_unknown(object, name), call. = FALSE)
    }

    if (!is.null(prop$getter) && is.null(prop$setter)) {
      msg <- sprintf("Can't set read-only property %s@%s", obj_desc(object), name)
      stop(msg, call. = FALSE)
    }

    if (!is.null(prop$setter) && !identical(setter_property, name)) {
      setter_property <<- name
      on.exit(setter_property <<- NULL, add = TRUE)
      object <- prop$setter(object, value)
    } else {
      if (isTRUE(check)) {
        error <- prop_validate(prop, value, object)
        if (!is.null(error)) {
          stop(error, call. = FALSE)
        }
      }

      attr(object, name) <- value
    }

    if (isTRUE(check) && is.null(setter_property)) {
      validate(object, properties = FALSE)
    }

    invisible(object)
  }
})

# called from src/prop.c
signal_prop_error <- function(fmt, object, name) {
  msg <- sprintf(fmt, obj_desc(object), name)
  stop(msg, call. = FALSE)
}

# called from src/prop.c
signal_error <- function(msg) {
  stop(msg, call. = FALSE)
}


prop_error_unknown <- function(object, prop_name) {
  sprintf("Can't find property %s@%s", obj_desc(object), prop_name)
}


# called from src/prop.c
prop_validate <- function(prop, value, object = NULL) {
  if (!class_inherits(value, prop$class)) {
    return(sprintf("%s must be %s, not %s",
      prop_label(object, prop$name),
      class_desc(prop$class),
      obj_desc(value)
    ))
  }

  if (is.null(validator <- prop$validator)) {
    return(NULL)
  }

  val <- validator(value)
  if (is.null(val)) {
    return(NULL)
  }

  if (is.character(val)) {
    if (length(val)) {
      return(paste0(prop_label(object, prop$name), " ", val))
    } else {
      return(NULL)
    }
  }

  stop(sprintf(
    "%s validator must return NULL or a character, not <%s>.",
    prop_label(object, prop$name), typeof(val)
  ))
}

prop_label <- function(object, name) {
  sprintf("%s@%s", if (!is.null(object)) obj_desc(object) else "", name)
}

# Note: we need to explicitly refer to base with "base::`@`" in the
# namespace directive to ensure the method is registered in the correct place.
# Otherwise, loadNamespace()/registerS3method() gets confused by the
# presence of a closure w/ the name of the generic (`@`) in the R7 namespace,
# and incorrectly assumes that R7::`@` is the generic and registers the
# method in the package namespace instead of base::.__S3MethodsTable__.
#' @usage object@name
#' @rawNamespace if (getRversion() >= "4.3.0") S3method(base::`@`, S7_object)
#' @name prop
`@.S7_object` <- prop

#' @rawNamespace S3method("@<-",S7_object)
`@<-.S7_object` <- `prop<-`


#' Property introspection
#'
#' - `prop_names(x)` returns the names of the properties
#' - `prop_exists(x, "prop")` returns `TRUE` iif `x` has property `prop`.
#'
#' @inheritParams prop
#' @returns `prop_names()` returns a character vector; `prop_exists()` returns
#'   a single `TRUE` or `FALSE`.
#' @export
#' @examples
#' Foo <- new_class("Foo", properties = list(a = class_character, b = class_integer))
#' f <- Foo()
#'
#' prop_names(f)
#' prop_exists(f, "a")
#' prop_exists(f, "c")
prop_names <- function(object) {
  check_is_S7(object)

  if (inherits(object, "S7_class")) {
    # S7_class isn't a S7_class (somewhat obviously) so we fake the property names
    c("name", "parent", "package", "properties", "abstract", "constructor", "validator")
  } else {
    class <- S7_class(object)
    props <- attr(class, "properties", exact = TRUE)
    if (length(props) == 0) {
      character()
    } else {
      names(props)
    }
  }
}

# .AtNames not exported on r-devel yet, causes installation failure
#' @rawNamespace if (getRversion() >= "4.3.0" && !is.null(asNamespace("utils")$.AtNames)) S3method(utils::.AtNames,S7_object)
.AtNames.S7_object <- function(x, pattern = "") {
  # utils::findMatches gives `R CMD check` warning on current r-devel
  asNamespace("utils")$findMatches(pattern, prop_names(x))
}

#' @rdname prop_names
#' @export
prop_exists <- function(object, name) {
  check_is_S7(object)
  name %in% prop_names(object)
}

#' Get/set multiple properties
#'
#' - `props(x)` returns all properties.
#' - `props(x) <- list(name1 = val1, name2 = val2)` modifies an existing object
#'   by setting multiple properties simultaneously.
#' - `set_props(x, name1 = val1, name2 = val2)` creates a copy of an existing
#'   object with new values for the specified properties.
#'
#' @importFrom stats setNames
#' @inheritParams prop
#' @param names A character vector of property names to retrieve. Default is all
#'   properties.
#' @returns A named list of property values.
#' @export
#' @examples
#' Horse <- new_class("Horse", properties = list(
#'   name = class_character,
#'   colour = class_character,
#'   height = class_numeric
#' ))
#' lexington <- Horse(colour = "bay", height = 15, name = "Lex")
#'
#' props(lexington)
#' props(lexington) <- list(height = 14, name = "Lexington")
#' lexington
props <- function(object, names = prop_names(object)) {
  check_is_S7(object)
  if (length(names) == 0) {
    structure(list(), names = character(0))
  } else {
    setNames(lapply(names, prop, object = object), names)
  }
}
#' @rdname props
#' @export
#' @param value A named list of values. The object is checked for validity
#'   only after all replacements are performed.
#' @param check,.check If `TRUE`, run [validate()] on the object
#'   before returning.
`props<-` <- function(object, check = TRUE, value) {
  if (check) {
    check_is_S7(object)
    stopifnot(is.list(value))
  }

  for (name in names(value)) {
    prop(object, name, check = FALSE) <- value[[name]]
  }

  if (check) {
    validate(object)
  }

  object
}

#' @export
#' @param ... Name-value pairs given property to modify and new value.
#' @rdname props
set_props <- function(object, ..., .check = TRUE) {
  props(object, check = .check) <- list(...)
  object
}

as_properties <- function(x) {
  if (length(x) == 0) {
    return(list())
  }

  if (!is.list(x)) {
    stop("`properties` must be a list", call. = FALSE)
  }

  out <- Map(as_property, x, names2(x), seq_along(x))
  names(out) <- vapply(out, function(x) x$name, FUN.VALUE = character(1))

  if (anyDuplicated(names(out))) {
    stop("`properties` names must be unique", call. = FALSE)
  }

  out
}

as_property <- function(x, name, i) {

  if (is_property(x)) {
    if (name == "") {
      if (is.null(x$name)) {
        msg <- sprintf("`properties[[%i]]` must have a name or be named.", i)
        stop(msg, call. = FALSE)
      }
    } else {
      x$name <- name
    }
    x
  } else {
    if (name == "") {
      msg <- sprintf("`properties[[%i]]` must be named.", i)
      stop(msg, call. = FALSE)
    }

    class <- as_class(x, arg = paste0("property$", name))
    new_property(x, name = name)
  }
}

prop_is_read_only <- function(prop) {
  is.function(prop$getter) && !is.function(prop$setter)
}

prop_has_setter <- function(prop) is.function(prop$setter)

prop_is_dynamic <- function(prop) is.function(prop$getter)

describe("property retrieval", {
  it("retrieves the properties that exist & errors otherwise", {
    foo <- new_class("foo", properties = list(xyz = class_double), package = NULL)
    obj <- foo(1)
    expect_equal(prop(obj, "xyz"), 1)
    expect_equal(obj@xyz, 1)

    expect_snapshot_error(prop(obj, "x"))
    expect_snapshot_error(obj@x)
  })
  it("evalutes dynamic properties", {
    foo <- new_class("foo", properties = list(
      x = new_property(getter = function(self) 1)
    ))
    obj <- foo()
    expect_equal(prop(obj, "x"), 1)
    expect_equal(obj@x, 1)
  })

  it("falls back to `base::@` for non-S7 objects", {
    expect_error("foo"@blah, 'object of.+class.+"character"')
    expect_error(NULL@blah, 'object of.+class.+"NULL"')
  })
})

describe("prop setting", {
  it("can set a property", {
    foo <- new_class("foo", properties = list(xyz = class_double))
    obj <- foo(1)

    prop(obj, "xyz") <- 2
    expect_equal(obj@xyz, 2)

    obj@xyz <- 3
    expect_equal(obj@xyz, 3)
  })

  it("can set dynamic properties", {
    foo <- new_class("foo", properties = list(
      x = new_property(setter = function(self, value) {
        self@x <- value * 2
        self
      })
    ))
    obj <- foo()
    obj@x <- 1
    expect_equal(obj@x, 2)
  })

  it("can't set read-only properties", {
    foo <- new_class("foo", package = NULL, properties = list(
      x = new_property(getter = function(self) 1
    )))
    obj <- foo()
    expect_snapshot(obj@x <- 1, error = TRUE)
  })

  it("errors if the property doesn't exist or is wrong class", {
    foo <- new_class("foo", properties = list(x = class_double), package = NULL)
    expect_snapshot(error = TRUE, {
      obj <- foo(123)
      obj@foo <- 10
      obj@x <- "x"
    })
  })

  it("validates all attributes if custom setter", {
    foo <- new_class("foo", package = NULL, properties = list(
      x = new_property(
        class_double,
        setter = function(self, value) {
          self@x <- 123
          self@y <- value
          self
        }
      ),
      y = new_property(class_double)
    ))
    expect_snapshot(error = TRUE, {
      obj <- foo(y = 123, x = 123)
      obj@x <- "x"
    })
  })

  it("validates once after custom setter", {
    times_validated <- 0L;  `add<-` <- `+`
    custom_setter <- function(self, value) {
      self@x <- as.double(value)
      self
    }
    foo2 <- new_class(
      "foo2",
      properties = list(x = new_property(class_double, setter = custom_setter)),
      validator = function(self) {
        add(times_validated) <<- 1L
        character()
      }
    )
    obj <- foo2("123")
    expect_equal(times_validated, 1)
    obj@x <- "456"
    expect_equal(times_validated, 2)
  })

  it("validates once with recursive property setters", {
    times_validated <- 0L;  `add<-` <- `+`
    foo <- new_class(
      "foo",
      properties = list(
        x = new_property(setter = function(self, value) {
          self@x <- value
          self@y <- paste0(value, "_set_by_x_setter")
          self
        }),
        y = new_property(setter = function(self, value) {
          self@y <- value
          self@z <- paste0(value, "_set_by_y_setter")
          self
        }),
        z = new_property(class_character)
      ),
      validator = function(self) { add(times_validated) <<- 1L; NULL }
    )
    out <- foo()
    expect_equal(times_validated, 1L)

    out@x <- "VAL"
    expect_equal(times_validated, 2L)
    expect_equal(out@z, "VAL_set_by_x_setter_set_by_y_setter")
  })

  it("does not run the check or validation functions if check = FALSE", {
    foo <- new_class("foo", properties = list(x = class_double))
    obj <- foo(123)
    prop(obj, "x", check = FALSE) <- "foo"
    expect_equal(obj@x, "foo")
  })

  it("falls back to `base::@` for non-S7 objects", {
    x <- "foo"
    expect_error(x@blah <- "bar", "is not a slot in class")
  })
})

describe("props<-", {
  it("validates after setting all properties", {
    foo <- new_class("foo",
      properties = list(x = class_double, y = class_double),
      validator = function(self) if (self@x > self@y) "bad"
    )

    obj <- foo(1, 2)
    props(obj) <- list(x = 5, y = 10)
    expect_equal(obj@x, 5)
    expect_equal(obj@y, 10)
  })

  it("`check = FALSE` skip validation", {
    foo <- new_class("foo",
      properties = list(x = class_double, y = class_double),
      validator = function(self) if (self@x > self@y) "bad"
    )

    obj <- foo(1, 2)
    props(obj, check = FALSE) <- list(x = 2, y = 1)
    expect_equal(obj@x, 2)
    expect_equal(obj@y, 1)
    expect_snapshot(validate(obj), error = TRUE)
  })

  it("has ordinary syntax in set_props()", {
    foo <- new_class("foo", properties = list(x = class_double))
    obj1 <- foo(1)
    obj2 <- set_props(obj1, x = 2)

    expect_equal(obj1@x, 1)
    expect_equal(obj2@x, 2)
  })

  it("set_props() skip validation with `.check = FALSE`", {
    foo <- new_class("foo",
      properties = list(x = class_double, y = class_double),
      validator = function(self) if (self@x > self@y) "bad"
    )

    obj <- foo(1, 2)
    obj2 <- set_props(obj, x = 2, y = 1, .check = FALSE)
    expect_equal(obj2@x, 2)
    expect_equal(obj2@y, 1)
    expect_snapshot(validate(obj2), error = TRUE)
  })
})

describe("property access", {
  it("access en masse", {
    foo <- new_class("foo", properties = list(x = class_numeric, y = class_numeric))
    x <- foo(x = 1, y = 2)
    expect_equal(prop_names(x), c("x", "y"))
    expect_equal(props(x), list(x = 1, y = 2))
    expect_true(prop_exists(x, "x"))
    expect_true(prop_exists(x, "y"))
    expect_false(prop_exists(x, "z"))
  })

  it("can access dynamic properties", {
    foo <- new_class("foo", properties = list(
      x = new_property(getter = function(self) 10),
      y = new_property()
    ))
    x <- foo(y = 2)
    expect_equal(props(x), list(x = 10, y = 2))
  })

  it("can with property-less object", {
    x <- new_class("x")()
    expect_equal(prop_names(x), character())
    expect_equal(props(x), named_list())
    expect_equal(prop_exists(x, "y"), FALSE)
  })

  it("ignore attributes that are not properties", {
    x <- new_class("x")()
    attr(x, "extra") <- 1

    expect_equal(prop_names(x), character())
    expect_equal(props(x), named_list())
    expect_false(prop_exists(x, "extra"))
  })
})


test_that("properties can be NULL", {
  foo <- new_class("foo", properties = list(x = class_any))
  x <- foo(x = NULL)
  expect_equal(x@x, NULL)
  x@x <- 1
  expect_equal(x@x, 1)
  x@x <- NULL
  expect_equal(x@x, NULL)
  expect_equal(prop_names(x), "x")
  expect_equal(props(x), list(x = NULL))
})

describe("new_property()", {
  it("validates getter and settor", {
    expect_snapshot(error = TRUE, {
      new_property(getter = function(x) {})
      new_property(setter = function(x, y, z) {})
    })
  })

  it("validates default", {
    expect_snapshot(error = TRUE, {
      new_property(class_integer, default = "x")
    })
  })

  it("displays nicely", {
    x <- new_property(class_integer, name = "foo")
    expect_snapshot({
      print(x)
      str(list(x))
    })
  })
})

test_that("properties can be base, S3, S4, S7, or S7 union", {
  class_S7 <- new_class("class_S7", package = NULL)
  class_S4 <- methods::setClass("class_S4", slots = c(x = "numeric"))

  my_class <- new_class("my_class",
    package = NULL,
    properties = list(
      anything = class_any,
      null = NULL,
      base = class_integer,
      S3 = class_factor,
      S4 = class_S4,
      S7 = class_S7,
      S7_union = new_union(class_integer, class_logical)
    )
  )
  expect_snapshot(my_class)
  my_obj <- my_class(
    anything = TRUE,
    null = NULL,
    base = 1L,
    S3 = factor(),
    S4 = class_S4(x = 1),
    S7 = class_S7(),
    S7_union = 1L
  )

  # First check that we can set with out error
  expect_error(my_obj@base <- 2L, NA)
  expect_error(my_obj@S3 <- factor("x"), NA)
  expect_error(my_obj@S4 <- class_S4(x = 2), NA)
  expect_error(my_obj@S7 <- class_S7(), NA)
  expect_error(my_obj@S7_union <- 2L, NA)
  expect_error(my_obj@S7_union <- TRUE, NA)

  # Then capture the error messages for human inspection
  expect_snapshot(error = TRUE, {
    my_obj@null <- "x"
    my_obj@base <- "x"
    my_obj@S3 <- "x"
    my_obj@S4 <- "x"
    my_obj@S7 <- "x"
    my_obj@S7_union <- "x"
  })
})

test_that("as_properties normalises properties", {
  expect_equal(as_properties(NULL), list())
  expect_equal(
    as_properties(list(x = class_numeric)),
    list(x = new_property(class_numeric, name = "x")
  ))
  expect_equal(
    as_properties(list(x = new_property(class = class_numeric))),
    list(x = new_property(class_numeric, name = "x")
  ))
  expect_equal(
    as_properties(list(new_property(name = "y"))),
    list(y = new_property(name = "y")
  ))

  # list name wins
  expect_equal(
    as_properties(list(x = new_property(name = "y"))),
    list(x = new_property(name = "x")
  ))
})

test_that("as_properties() gives useful error messages", {
  expect_snapshot(error = TRUE, {
    as_properties(1)
    as_properties(list(1))
    as_properties(list(new_property(class_character)))
    as_properties(list(x = 1))
    as_properties(list(x = class_character, x = class_character))
  })
})

test_that("can validate with custom validator", {
  validate_scalar <- function(value) {
    if (length(value) != 1) {
      "must be length 1"
    }
  }
  prop <- new_property(class_integer, validator = validate_scalar)
  foo <- new_class("foo", package = NULL, properties = list(x = prop))
  expect_snapshot(error = TRUE, {
    f <- foo(x = 1L)
    f@x <- 1:2

    foo(x = 1:2)
  })
})

test_that("prop<- won't infinitly recurse on a custom setter", {
  chattily_sync_ab <- function(self, value) {
    cat("Starting syncup with value:", value, "\n")
    a_value <- paste0("a_", value)
    b_value <- paste0("b_", value)

    cat(sprintf('setting @a <- "%s"\n', a_value))
    self@a <- a_value

    cat(sprintf('setting @b <- "%s"\n', b_value))
    self@b <- b_value

    self
  }

  foo <- new_class("foo", properties = list(
    a = new_property(setter = chattily_sync_ab),
    b = new_property(setter = chattily_sync_ab)
  ))

  expect_snapshot({
    obj <- foo()
    obj@a <- "val"
  })
})

test_that("custom setters can invoke setters on non-self objects", {

  Transmitter <- new_class("Transmitter", properties = list(
    message = new_property(setter = function(self, value) {
      cat("[tx] sending: ", value, "\n")
      receiver@message <<- value
      cat("[tx] saving last sent message.\n")
      self@message <- value
      cat("[tx] finished transmitting.\n")
      self
    })
  ))

  Receiver <- new_class("Receiver", properties = list(
    message = new_property(setter = function(self, value) {
      cat("[rx] receiving: ", value, "\n")
      self@message <- value
      cat("[rx] finished receiving.\n")
      self
    })
  ))

  expect_snapshot({
    receiver <- Receiver()
    transmitter <- Transmitter()

    transmitter@message <- "hello"
    expect_equal(receiver@message, "hello")

    transmitter@message <- "goodbye"
    expect_equal(receiver@message, "goodbye")
  })

})


test_that("custom getters don't infinitely recurse", {
  # https://github.com/RConsortium/S7/issues/403

  someclass <- new_class("someclass", properties = list(
    someprop = new_property(
      class_character,
      getter = function(self) self@someprop,
      setter = function(self, value) {
        self@someprop <- toupper(value)
        self
      }
    )
  ))

  expect_equal(someclass("foo")@someprop, "FOO")
  x <- someclass()
  expect_equal(x@someprop, character())
  x@someprop <- "foo"
  expect_equal(x@someprop, "FOO")

})


test_that("custom setters can call custom getters", {
  # https://github.com/RConsortium/S7/issues/403

  someclass <- new_class("someclass", properties = list(
    someprop = new_property(
      class_character,
      getter = function(self) self@someprop,
      setter = function(self, value) {
        self@someprop <- paste0(self@someprop, toupper(value))
        self
      }
    )
  ))

  x <- someclass("foo")
  expect_equal(x@someprop, "FOO")

  x <- someclass()
  expect_equal(x@someprop, character())

  x@someprop <- "foo"
  expect_equal(x@someprop, "FOO")

  x@someprop <- "foo"
  expect_equal(x@someprop, "FOOFOO")

})


test_that("custom getters don't evaulate call objects", {
  QuotedCall :=  new_class(class_call, properties = list(
    name = new_property(getter = function(self) {
      stopifnot(is.call(self))
      as.character(self[[1]])
    }),
    args = new_property(getter = function(self) {
      stopifnot(is.call(self))
      as.list(self)[-1]
    })
  ), constructor = function(x) {
    new_object(substitute(x))
  })

  cl <- QuotedCall(stop("boom"))
  expect_equal(cl@name, "stop")
  expect_equal(cl@args, list("boom"))

})


test_that("custom setters don't evaulate call objects", {

  Call :=  new_class(class_call, properties = list(
    name = new_property(
      getter = function(self) {
        stopifnot(is.call(self))
        as.character(self[[1]])
      },
      setter = function(self, value) {
        stopifnot(is.call(self), is.name(value))
        self[[1]] <- value
        self
      }
    ),
    args = new_property(
      getter = function(self) {
        stopifnot(is.call(self))
        as.list(self)[-1]
      },
      setter = function(self, value) {
        stopifnot(is.call(self), is.list(value) || is.pairlist(value))
        # self[seq(2, length.out = length(value))] <- value
        # names(self) <- c("", names(value))
        # self
        out <- as.call(c(self[[1]], value))
        attributes(out) <- attributes(self)
        out
      })
  ), constructor = function(name, ...) {
    new_object(as.call(c(as.name(name), ...)))
  })

  cl <- Call("stop", "boom")
  expect_identical(cl@name, "stop")
  expect_identical(cl@args, list("boom"))

  abort <- stop
  cl@name <- quote(abort)
  expect_identical(cl@name, "abort")
  expect_identical(cl[[1]], quote(abort))

  cl@args <- pairlist("boom2")
  expect_identical(cl[[2]], "boom2")
  expect_identical(cl@args, list("boom2"))
  expect_identical(drop_attributes(cl), quote(abort("boom2")))

  cl@args <- alist(msg = "boom3", foo = bar, baz)
  expect_identical(cl@args, alist(msg = "boom3", foo = bar, baz))

  expect_identical(drop_attributes(cl),
                   quote(abort(msg = "boom3", foo = bar, baz)))

})

# Called from C
method_lookup_error <- function(name, args) {
  types <- vcapply(args, obj_desc)
  msg <- method_lookup_error_message(name, types)
  cnd <- errorCondition(msg, class = c("S7_error_method_not_found", "error"))
  stop(cnd)
}

method_lookup_error_message <- function(name, types) {
  if (length(types) == 1) {
    sprintf("Can't find method for `%s(%s)`.", name, types)
  } else {
    arg_names <- paste0(names(types), collapse = ", ")
    types <- paste0("- ", format(names(types)), ": ", types, collapse = "\n")
    sprintf("Can't find method for generic `%s(%s)`:\n%s", name, arg_names, types)
  }
}

#' @rdname new_generic
#' @order 2
#' @export
S7_dispatch <- function() {
  .External2(method_call_, sys.function(-1L), sys.frame(-1L))
}

#' Force method dispatch to use a superclass
#'
#' @description
#' `super(from, to)` causes the dispatch for the next generic to use the method
#' for the superclass `to` instead of the actual class of `from`. It's needed
#' when you want to implement a method in terms of the implementation of its
#' superclass.
#'
#' ## S3 & S4
#' `super()` performs a similar role to [NextMethod()] in S3 or
#' [methods::callNextMethod()] in S4, but is much more explicit:
#'
#' * The super class that `super()` will use is known when write `super()`
#'   (i.e. statically) as opposed to when the generic is called
#'   (i.e. dynamically).
#'
#' * All arguments to the generic are explicit; they are not automatically
#'   passed along.
#'
#' This makes `super()` more verbose, but substantially easier to
#' understand and reason about.
#'
#' ## `super()` in S3 generics
#'
#' Note that you can't use `super()` in methods for an S3 generic.
#' For example, imagine that you have made a subclass of "integer":
#'
#' ```{r}
#' MyInt <- new_class("MyInt", parent = class_integer, package = NULL)
#' ```
#'
#' Now you go to write a custom print method:
#'
#' ```{r}
#' method(print, MyInt) <- function(x, ...) {
#'    cat("<MyInt>")
#'    print(super(x, to = class_integer))
#' }
#'
#' MyInt(10L)
#' ```
#'
#' This doesn't work because `print()` isn't an S7 generic so doesn't
#' understand how to interpret the special object that `super()` produces.
#' While you could resolve this problem with [NextMethod()] (because S7 is
#' implemented on top of S3), we instead recommend using [S7_data()] to extract
#' the underlying base object:
#'
#' ```{r}
#' method(print, MyInt) <- function(x, ...) {
#'    cat("<MyInt>")
#'    print(S7_data(x))
#' }
#'
#' MyInt(10L)
#' ```
#'
#' @param from An S7 object to cast.
#' @param to An S7 class specification, passed to [as_class()]. Must be a
#'   superclass of `object`.
#' @returns An `S7_super` object which should always be passed
#'   immediately to a generic. It has no other special behavior.
#' @export
#' @examples
#' Foo1 <- new_class("Foo1", properties = list(x = class_numeric, y = class_numeric))
#' Foo2 <- new_class("Foo2", Foo1, properties = list(z = class_numeric))
#'
#' total <- new_generic("total", "x")
#' method(total, Foo1) <- function(x) x@x + x@y
#'
#' # This won't work because it'll be stuck in an infinite loop:
#' method(total, Foo2) <- function(x) total(x) + x@z
#'
#' # We could write
#' method(total, Foo2) <- function(x) x@x + x@y + x@z
#' # but then we'd need to remember to update it if the implementation
#' # for total(<Foo1>) ever changed.
#'
#' # So instead we use `super()` to call the method for the parent class:
#' method(total, Foo2) <- function(x) total(super(x, to = Foo1)) + x@z
#' total(Foo2(1, 2, 3))
#'
#' # To see the difference between convert() and super() we need a
#' # method that calls another generic
#'
#' bar1 <- new_generic("bar1", "x")
#' method(bar1, Foo1) <- function(x) 1
#' method(bar1, Foo2) <- function(x) 2
#'
#' bar2 <- new_generic("bar2", "x")
#' method(bar2, Foo1) <- function(x) c(1, bar1(x))
#' method(bar2, Foo2) <- function(x) c(2, bar1(x))
#'
#' obj <- Foo2(1, 2, 3)
#' bar2(obj)
#' # convert() affects every generic:
#' bar2(convert(obj, to = Foo1))
#' # super() only affects the _next_ call to a generic:
#' bar2(super(obj, to = Foo1))
super <- function(from, to) {
  check_is_S7(from)

  to <- as_class(to)
  check_can_inherit(to)
  if (!class_inherits(from, to)) {
    msg <- sprintf(
      "%s doesn't inherit from %s",
      obj_desc(from),
      class_desc(to)
    )
    stop(msg)
  }

  # Must not change order of these fields as C code indexes by position
  structure(
    list(
      object = from,
      dispatch = class_dispatch(to)
    ),
    class = "S7_super"
  )
}

#' @export
print.S7_super <- function(x, ...) {
  str(x, ...)
  invisible(x)
}
#' @export
str.S7_super <- function(object, ..., nest.lev = 0) {
  cat(if (nest.lev > 0) " ")
  cat("super(", obj_desc(object$object), ", <", object$dispatch[[1]], ">)", sep = "")
}

# Where needed, attach an environment containing @ that works with S7
activate_backward_compatiblility <- function() {
  if (getRversion() < "4.3.0" && !"S7_at" %in% search()) {
    args <- list(list("@" = `@`), name = "S7_at", warn.conflicts = FALSE)
    do.call("attach", args)
  }
  invisible()
}

#' @aliases @
#' @usage NULL
#' @rawNamespace if (getRversion() < "4.3.0") export(`@`)
#' @name prop
`@` <- function(object, name) {
  if (inherits(object, "S7_object")) {
    name <- as.character(substitute(name))
    prop(object, name)
  } else {
    name <- substitute(name)
    do.call(base::`@`, list(object, name))
  }
}

#' Standard class specifications
#'
#' This is used as the interface between S7 and R's other OO systems, allowing
#' you to use S7 classes and methods with base types, informal S3 classes, and
#' formal S4 classes.
#'
#' @param x A class specification. One of the following:
#'   * An S7 class (created by [new_class()]).
#'   * An S7 union (created by [new_union()]).
#'   * An S3 class (created by [new_S3_class()]).
#'   * An S4 class (created by [methods::getClass()] or [methods::new()]).
#'   * A base class, like [class_logical], [class_integer], or [class_double].
#'   * A "special", either [class_missing] or [class_any].
#' @param arg Argument name used when generating errors.
#' @keywords internal
#' @export
#' @return A standardised class: either `NULL`, an S7 class, an S7 union,
#'   as [new_S3_class], or a S4 class.
#' @examples
#' as_class(class_logical)
#' as_class(new_S3_class("factor"))
as_class <- function(x, arg = deparse(substitute(x))) {
  error_base <- sprintf("Can't convert `%s` to a valid class. ", arg)

  if (is_foundation_class(x)) {
    x
  } else if (is.null(x)) {
    # NULL is handled specially because you can't assign a class to it,
    # so it can't be wrapped in new_base_class
    x
  } else if (isS4(x)) {
    S4_to_S7_class(x, error_base)
  } else {
    msg <- sprintf("Class specification must be an S7 class object, the result of `new_S3_class()`, an S4 class object, or a base class, not a %s.", obj_desc(x))
    stop(paste0(error_base, msg), call. = FALSE)
  }
}

is_foundation_class <- function(x) {
  is_class(x) ||
    is_union(x) ||
    is_base_class(x) ||
    is_S3_class(x) ||
    is_class_missing(x) ||
    is_class_any(x)
}

class_type <- function(x) {
  if (is.null(x)) {
    "NULL"
  } else if (is_class_missing(x)) {
    "missing"
  } else if (is_class_any(x)) {
    "any"
  } else if (is_base_class(x)) {
    "S7_base"
  } else if (is_class(x)) {
    "S7"
  } else if (is_union(x)) {
    "S7_union"
  } else if (is_S3_class(x)) {
    "S7_S3"
  } else if (is_S4_class(x)) {
    "S4"
  } else {
    stop("`x` is not standard S7 class", call. = FALSE)
  }
}

class_friendly <- function(x) {
  switch(class_type(x),
    NULL = "NULL",
    missing = "a missing argument",
    any = "any type",
    S4 = "an S4 class",
    S7 = "an S7 class",
    S7_base = "a base type",
    S7_union = "an S7 union",
    S7_S3 = "an S3 class",
  )
}

class_construct <- function(.x, ...) {
  class_constructor(.x)(...)
}


class_construct_expr <- function(.x, envir = NULL, package = NULL) {
  f <- class_constructor(.x)

  # For S7 class constructors with a non-NULL @package property
  # Instead of inlining the full class definition, use either
  # `pkgname::classname()` or `classname()`
  if (is_class(f) && !is.null(f@package)) {
    # Check if the class can be resolved as a bare symbol without pkgname::
    # Note: During package build, using pkg::class for a package's own symbols
    # will raise an error from `::`.
    if (identical(package, f@package)) {
      return(call(f@name))
    } else {
      # namespace the pkgname::classname() call
      cl <- as.call(list(quote(`::`), as.name(f@package), as.name(f@name)))

      # check the call evaluates to f.
      # This will error if package is not installed or object is not exported.
      f2 <- eval(cl, baseenv())
      if (!identical(f, f2)) {
        msg <- sprintf(
          "`%s::%s` is not identical to the class with the same @package and @name properties",
          f@package, f@name
        )
        stop(msg, call. = FALSE)
      }
      return(as.call(list(cl)))
    }
  }

  # If the constructor is a closure wrapping a simple expression, try
  # to extract the expression
  # (mostly for nicer printing and introspection.)

  # can't unwrap if the closure is potentially important
  # (this can probably be relaxed to allow additional environments)
  fe <- environment(f)
  if (!identical(fe, baseenv())) {
    return(as.call(list(f)))
  }

  # special case for `class_missing`
  if (identical(body(f) -> fb, quote(expr =))) {
    return(quote(expr =))
  }

  # `new_object()` must be called from the class constructor, can't
  # be safely unwrapped
  if ("new_object" %in% all.names(fb)) {
    return(as.call(list(f)))
  }

  # maybe unwrap body if it is a single expression wrapped in `{`
  if (length(fb) == 2L && identical(fb[[1L]], quote(`{`)))
    fb <- fb[[2L]]

  # If all the all the work happens in the promise to the `.data` arg,
  # return the `.data` expression.
  ff <- formals(f)
  if ((identical(fb, quote(.data))) &&
      identical(names(ff), ".data")) {
    return(ff$.data)
  }

  # if all the work happens in the function body, return the body.
  if (is.null(ff)) {
    return(fb)
  }

  #else, return a call to the constructor
  as.call(list(f))
}

class_constructor <- function(.x) {
  switch(class_type(.x),
         any = ,
         NULL = new_function(env = baseenv()),
         missing = new_function(, quote(expr =), baseenv()),
         S4 = function(...) methods::new(.x, ...),
         S7 = .x,
         S7_base = .x$constructor,
         S7_union = class_constructor(.x$classes[[1]]),
         S7_S3 = .x$constructor,
         stop(sprintf("Can't construct %s", class_friendly(.x)), call. = FALSE)
  )
}

class_validate <- function(class, object) {
  validator <- switch(class_type(class),
    S4 = methods::validObject,
    S7 = class@validator,
    S7_base = class$validator,
    S7_S3 = class$validator,
    NULL
  )

  if (is.null(validator)) {
    NULL
  } else {
    validator(object)
  }
}

class_desc <- function(x) {
  switch(class_type(x),
    NULL = "<NULL>",
    missing = "<MISSING>",
    any = "<ANY>",
    S4 = paste0("S4<", x@className, ">"),
    S7 = paste0("<", S7_class_name(x), ">"),
    S7_base = paste0("<", x$class, ">"),
    S7_union = oxford_or(unlist(lapply(x$classes, class_desc))),
    S7_S3 = paste0("S3<", paste0(x$class, collapse = "/"), ">"),
  )
}

# Vector of class names; used in method introspection
class_dispatch <- function(x) {
  if (is_class(x) && x@name == "S7_object") {
    return("S7_object")
  }

  switch(class_type(x),
    NULL = "NULL",
    missing = "MISSING",
    any = character(),
    S4 = S4_class_dispatch(methods::extends(x)),
    S7 = c(S7_class_name(x), class_dispatch(x@parent)),
    S7_base = c(x$class, "S7_object"),
    S7_S3 = c(x$class, "S7_object"),
    stop("Unsupported")
  )
}

# Class name when registering an S7 method
class_register <- function(x) {
  switch(class_type(x),
    NULL = "NULL",
    missing = "MISSING",
    any = "ANY",
    S4 = S4_class_name(x),
    S7 = S7_class_name(x),
    S7_base = x$class,
    S7_S3 = x$class[[1]],
    stop("Unsupported")
  )
}

# Used when printing method signature to generate executable code
class_deparse <- function(x) {
  switch(class_type(x),
    "NULL" = "NULL",
    missing = "class_missing",
    any = "class_any",
    S4 = as.character(x@className),
    S7 = S7_class_name(x),
    S7_base = paste0("class_", x$class),
    S7_union = {
      classes <- vcapply(x$classes, class_deparse)
      paste0("new_union(", paste(classes, collapse = ", "), ")")
    },
    S7_S3 = paste0("new_S3_class(", deparse1(x$class), ")"),
  )
}

class_inherits <- function(x, what) {
  switch(class_type(what),
    "NULL" = is.null(x),
    missing = FALSE,
    any = TRUE,
    S4 = isS4(x) && methods::is(x, what),
    S7 = inherits(x, "S7_object") && inherits(x, S7_class_name(what)),
    S7_base = what$class == base_class(x),
    S7_union = any(vlapply(what$classes, class_inherits, x = x)),
    # This is slightly too crude as we really want them to be in the same
    # order and contiguous, but it's probably close enough for practical
    # purposes
    S7_S3 = !isS4(x) && all(what$class %in% class(x)),
  )
}

obj_type <- function(x) {
  if (identical(x, quote(expr = ))) {
    "missing"
  } else if (inherits(x, "S7_object")) {
    "S7"
  } else if (isS4(x)) {
    "S4"
  } else if (is.object(x)) {
    "S3"
  } else {
    "base"
  }
}
obj_desc <- function(x) {
  switch(obj_type(x),
    missing = "MISSING",
    base = paste0("<", typeof(x), ">"),
    S3 = paste0("S3<", paste(class(x), collapse = "/"), ">"),
    S4 = paste0("S4<", class(x), ">"),
    S7 = paste0("<", class(x)[[1]], ">")
  )
}
obj_dispatch <- function(x) {
  switch(obj_type(x),
    missing = "MISSING",
    base = base_class(x),
    S3 = class(x),
    S4 = S4_class_dispatch(methods::getClass(class(x))),
    S7 = class(x) # = class_dispatch(S7_class(x))
  )
}

base_class <- function(x) {
  switch(typeof(x),
    closure = "function",
    special = "function",
    builtin = "function",
    language = "call",
    symbol = "name",
    typeof(x)
  )
}

# helpers -----------------------------------------------------------------

# Suppress @className false positive
globalVariables("className")

#' Define a new S7 class
#'
#' @description
#' A class specifies the properties (data) that each of its objects will
#' possess. The class, and its parent, determines which method will be used
#' when an object is passed to a generic.
#'
#' Learn more in `vignette("classes-objects")`
#'
#' @param name The name of the class, as a string. The result of calling
#'   `new_class()` should always be assigned to a variable with this name,
#'   i.e. `Foo <- new_class("Foo")`.
#' @param parent The parent class to inherit behavior from.
#'   There are three options:
#'
#'   * An S7 class, like [S7_object].
#'   * An S3 class wrapped by [new_S3_class()].
#'   * A base type, like [class_logical], [class_integer], etc.
#' @param package Package name. This is automatically resolved if the class is
#'   defined in a package, and `NULL` otherwise.
#'
#'   Note, if the class is intended for external use, the constructor should be
#'   exported. Learn more in `vignette("packages")`.
#' @param abstract Is this an abstract class? An abstract class can not be
#'   instantiated.
#' @param constructor The constructor function. In most cases, you can rely
#'   on the default constructor, which will generate a function with one
#'   argument for each property.
#'
#'   A custom constructor should call `new_object()` to create the S7 object.
#'   The first argument, `.data`, should be an instance of the parent class
#'   (if used). The subsequent arguments are used to set the properties.
#' @param validator A function taking a single argument, `self`, the object
#'   to validate.
#'
#'   The job of a validator is to determine whether the object is valid,
#'   i.e. if the current property values form an allowed combination. The
#'   types of the properties are always automatically validated so the job of
#'   the validator is to verify that the _values_ of individual properties are
#'   ok (i.e. maybe a property should have length 1, or should always be
#'   positive), or that the _combination_ of values of multiple properties is ok.
#'   It is called after construction and whenever any property is set.
#'
#'   The validator should return `NULL` if the object is valid. If not, it
#'   should return a character vector where each element describes a single
#'   problem, using `@prop_name` to describe where the problem lies.
#'
#'   See `validate()` for more details, examples, and how to temporarily
#'   suppress validation when needed.
#' @param properties A named list specifying the properties (data) that
#'   belong to each instance of the class. Each element of the list can
#'   either be a type specification (processed by [as_class()]) or a
#'   full property specification created [new_property()].
#' @return A object constructor, a function that can be used to create objects
#'   of the given class.
#' @export
#' @examples
#' # Create an class that represents a range using a numeric start and end
#' Range <- new_class("Range",
#'   properties = list(
#'     start = class_numeric,
#'     end = class_numeric
#'   )
#' )
#' r <- Range(start = 10, end = 20)
#' r
#' # get and set properties with @
#' r@start
#' r@end <- 40
#' r@end
#'
#' # S7 automatically ensures that properties are of the declared types:
#' try(Range(start = "hello", end = 20))
#'
#' # But we might also want to use a validator to ensure that start and end
#' # are length 1, and that start is < end
#' Range <- new_class("Range",
#'   properties = list(
#'     start = class_numeric,
#'     end = class_numeric
#'   ),
#'   validator = function(self) {
#'     if (length(self@start) != 1) {
#'       "@start must be a single number"
#'     } else if (length(self@end) != 1) {
#'       "@end must be a single number"
#'     } else if (self@end < self@start) {
#'       "@end must be great than or equal to @start"
#'     }
#'   }
#' )
#' try(Range(start = c(10, 15), end = 20))
#' try(Range(start = 20, end = 10))
#'
#' r <- Range(start = 10, end = 20)
#' try(r@start <- 25)
new_class <- function(
    name,
    parent = S7_object,
    package = topNamespaceName(parent.frame()),
    properties = list(),
    abstract = FALSE,
    constructor = NULL,
    validator = NULL) {

  check_name(name)

  parent <- as_class(parent)

  # Don't check arguments for S7_object
  if (!is.null(parent)) {
    check_can_inherit(parent)
    if (!is.null(package)) {
      check_name(package)
    }
    if (!is.null(constructor)) {
      check_S7_constructor(constructor)
    }
    if (!is.null(validator)) {
      check_function(validator, alist(self = ))
    }
    if (abstract && (!is_class(parent) || !(parent@abstract || parent@name == "S7_object"))) {
      stop("Abstract classes must have abstract parents")
    }
  }

  # Combine properties from parent, overriding as needed
  all_props <- attr(parent, "properties", exact = TRUE) %||% list()
  new_props <- as_properties(properties)
  check_prop_names(new_props)
  all_props[names(new_props)] <- new_props

  if (is.null(constructor)) {
    constructor <- new_constructor(parent, all_props,
                                   envir = parent.frame(),
                                   package = package)
  }

  object <- constructor
  # Must synchronise with prop_names
  attr(object, "name") <- name
  attr(object, "parent") <- parent
  attr(object, "package") <- package
  attr(object, "properties") <- all_props
  attr(object, "abstract") <- abstract
  attr(object, "constructor") <- constructor
  attr(object, "validator") <- validator
  class(object) <- c("S7_class", "S7_object")

  global_variables(names(all_props))
  object
}
globalVariables(c("name", "parent", "package", "properties", "abstract", "constructor", "validator"))

#' @rawNamespace if (getRversion() >= "4.3.0") S3method(nameOfClass, S7_class, S7_class_name)
S7_class_name <- function(x) {
  paste(c(x@package, x@name), collapse = "::")
}

check_S7_constructor <- function(constructor) {
  if (!is.function(constructor)) {
    stop("`constructor` must be a function", call. = FALSE)
  }

  method_call <- find_call(body(constructor), quote(new_object), packageName())
  if (is.null(method_call)) {
    stop("`constructor` must contain a call to `new_object()`", call. = FALSE)
  }
}

#' @export
print.S7_class <- function(x, ...) {
  props <- x@properties
  if (length(props) > 0) {
    prop_names <- format(names(props))
    prop_types <- format(vcapply(props, function(x) class_desc(x$class)))
    prop_fmt <- paste0(" $ ", prop_names, ": ", prop_types, "\n", collapse = "")
  } else {
    prop_fmt <- ""
  }

  cat(
    sprintf(
      paste0(
        "%s%s class\n",
        "@ parent     : %s\n",
        "@ constructor: %s\n",
        "@ validator  : %s\n",
        "@ properties :\n%s"
      ),
      class_desc(x),
      if (x@abstract) " abstract" else "",
      class_desc(x@parent),
      show_function(x@constructor, constructor = TRUE),
      if (!is.null(x@validator)) show_function(x@validator) else "<NULL>",
      prop_fmt
    ),
    sep = ""
  )
  invisible(x)
}

#' @export
str.S7_class <- function(object, ..., nest.lev = 0) {
  cat(if (nest.lev > 0) " ")
  cat("<", paste0(class_dispatch(object), collapse = "/"), "> constructor", sep = "")
  cat("\n")

  if (nest.lev == 0) {
    str_nest(props(object), "@", ..., nest.lev = nest.lev)
  }
}

#' @export
c.S7_class <- function(...) {
  msg <- "Can not combine S7 class objects"
  stop(msg, call. = FALSE)
}

can_inherit <- function(x) is_base_class(x) || is_S3_class(x) || is_class(x)

check_can_inherit <- function(x, arg = deparse(substitute(x))) {
  if (!can_inherit(x)) {
    msg <- sprintf(
      "`%s` must be an S7 class, S3 class, or base type, not %s.",
      arg,
      class_friendly(x)
    )
    stop(msg, call. = FALSE)
  }

  if (is_base_class(x) && x$class == "environment") {
    stop("Can't inherit from an environment.", call. = FALSE)
  }
}

is_class <- function(x) inherits(x, "S7_class")

# Object ------------------------------------------------------------------

#' @param .parent,... Parent object and named properties used to construct the
#'   object.
#' @rdname new_class
#' @export
new_object <- function(.parent, ...) {
  class <- sys.function(-1)
  if (!inherits(class, "S7_class")) {
    stop("`new_object()` must be called from within a constructor")
  }
  if (class@abstract) {
    msg <- sprintf("Can't construct an object from abstract class <%s>", class@name)
    stop(msg)
  }

  # force .parent before ...
  # TODO: Some type checking on `.parent`?
  object <- .parent

  args <- list(...)
  if ("" %in% names2(args)) {
    stop("All arguments to `...` must be named")
  }

  has_setter <- vlapply(class@properties[names(args)], prop_has_setter)

  attrs <- c(
    list(class = class_dispatch(class), S7_class = class),
    args[!has_setter],
    attributes(object)
  )
  attrs <- attrs[!duplicated(names(attrs))]
  attributes(object) <- attrs

  # invoke custom property setters
  prop_setter_vals <- args[has_setter]
  for (name in names(prop_setter_vals))
    prop(object, name, check = FALSE) <- prop_setter_vals[[name]]

  # Don't need to validate if parent class already validated,
  # i.e. it's a non-abstract S7 class
  parent_validated <- inherits(class@parent, "S7_object") && !class@parent@abstract
  validate(object, recursive = !parent_validated)

  object
}

#' @export
print.S7_object <- function(x, ...) {
  str(x, ...)
  invisible(x)
}
#' @export
str.S7_object <- function(object, ..., nest.lev = 0) {
  cat(if (nest.lev > 0) " ")
  cat(obj_desc(object))

  if (!is_S7_type(object)) {
    if (!typeof(object) %in% c("numeric", "integer", "character", "double"))
      cat(" ")

    attrs <- attributes(object)
    if (is.environment(object)) {
      attributes(object) <- NULL
    } else {
      attributes(object) <- list(names = names(object), dim = dim(object))
    }

    str(object, nest.lev = nest.lev)
    attributes(object) <- attrs
  } else {
    cat("\n")
  }

  str_nest(props(object), "@", ..., nest.lev = nest.lev)
}

#' Retrieve the S7 class of an object
#'
#' Given an S7 object, find it's class.
#'
#' @param object The S7 object
#' @returns An [S7 class][new_class].
#' @export
#' @examples
#' Foo <- new_class("Foo")
#' S7_class(Foo())
S7_class <- function(object) {
  attr(object, "S7_class", exact = TRUE)
}


check_prop_names <- function(properties, error_call = sys.call(-1L)) {
  # these attributes have special C handlers in base R
  forbidden <- c("names", "dim", "dimnames", "class",
                 "tsp", "comment", "row.names", "...")
  forbidden <- intersect(forbidden, names(properties))
  if (length(forbidden)) {
    msg <- paste0("property can't be named: ",
                  paste0(forbidden, collapse = ", "))
    stop(simpleError(msg, error_call))
  }
}

test_that("base::inherits() accepts S7 objects", {
  skip_if(getRversion() < "4.3")

  ClassA <- new_class("ClassA")
  ClassBA <- new_class("ClassBA", parent = ClassA)
  ClassX <- new_class("ClassX")

  expect_no_error(stopifnot(exprs = {
    isTRUE(inherits(ClassA(), ClassA))
    isTRUE(inherits(ClassBA(), ClassA))
    isTRUE(inherits(ClassBA(), ClassBA))

    isFALSE(inherits(ClassX(), ClassA))
    isFALSE(inherits(ClassX(), ClassBA))
  }))
})


test_that("base::`@` accesses S7 properties", {
  skip_if(getRversion() < "4.3")

  range <- new_class(
    "range",
    properties = list(start = class_double, end = class_double),
    validator = function(self) {
      if (length(self@start) != 1) {
        "@start must be length 1"
      } else if (length(self@end) != 1) {
        "@end must be length 1"
      } else if (self@end < self@start) {
        "@end must be greater than or equal to @start"
      }
    }
  )

  obj <- range(3, 4)

  expect_no_error(stopifnot(exprs = {
    identical(obj@start, 3)
    identical(obj@end, 4)
  }))

  local({
    `@` <- base::`@`
    expect_no_error(stopifnot(exprs = {
      identical(obj@start, 3)
      identical(obj@end, 4)
    }))
  })
})

test_that("dput(<S7_object>) works", {
  skip_if(getRversion() < "4.4")

  expect_no_error(capture.output(dput(new_class("Foo")())))
  expect_no_error(capture.output(dput(new_class("Foo"))))
})

global_variables <- function(names) {
  env <- topenv(parent.frame())
  if (exists(".__global__", envir = env) && bindingIsLocked(".__global__", env = env)) {
    get("unlockBinding", baseenv())(".__global__", env = env)
    on.exit(lockBinding(".__global__", env = env))
  }
  current <- get0(".__global__", envir = env, ifnotfound = character())
  current <- unique(c(current, names))
  assign(".__global__", current, envir = env)
}

vlapply <- function(X, FUN, ...) vapply(X = X, FUN = FUN, FUN.VALUE = logical(1), ...)
vcapply <- function(X, FUN, ...) vapply(X = X, FUN = FUN, FUN.VALUE = character(1), ...)

method_signature <- function(generic, signature) {
  single <- length(generic@dispatch_args) == 1
  if (single) {
    signature <- class_deparse(signature[[1]])
  } else {
    classes <- vcapply(signature, class_deparse)
    signature <- paste0("list(", paste0(classes, collapse = ", "), ")")
  }

  sprintf("method(%s, %s)", generic@name, signature)
}

names2 <- function(x) {
  nms <- names(x)
  if (is.null(nms)) {
    rep("", length(x))
  } else {
    nms
  }
}

is_prefix <- function(x, y) {
  length(x) <= length(y) && identical(unclass(x), unclass(y)[seq_along(x)])
}

oxford_or <- function (x)  {
  n <- length(x)
  if (n == 1) {
    x
  } else if (n == 2) {
    paste0(x[[1]], " or ", x[[2]])
  } else if (n >= 2) {
    x <- c(x[seq(1, n - 2, by = 1)], paste0(x[[n - 1]], ", or ", x[[n]]))
    paste0(x, collapse = ", ")
  }
}

str_nest <- function(
    object,
    prefix,
    ...,
    nest.lev = 0,
    indent.str = paste(rep.int(" ", max(0, nest.lev + 1)), collapse = "..")
) {

  names <- format(names(object))

  for (i in seq_along(object)) {
    cat(indent.str, prefix, " ", names[[i]], ":", sep = "")

    xi <- object[[i]]
    if (is.function(xi)) {
      str_function(xi, nest.lev = nest.lev + 1)
    } else {
      str(xi, ..., nest.lev = nest.lev + 1)
    }
  }
}

str_function <- function(object, ..., nest.lev = 0) {
  attr(object, "srcref") <- NULL
  if (identical(class(object), "function")) {
    cat(" ")
  }
  str(object, ..., nest.lev = nest.lev)
}

check_name <- function(name, arg = deparse(substitute(name))) {
  if (length(name) != 1 || !is.character(name)) {
    msg <- sprintf("`%s` must be a single string", arg)
    stop(msg, call. = FALSE)
  }
  if (is.na(name) || name == "") {
    msg <- sprintf("`%s` must not be \"\" or NA", arg)
    stop(msg, call. = FALSE)
  }
}

check_function <- function(f, args, arg = deparse(substitute(f))) {
  if (!is.function(f)) {
    msg <- sprintf("`%s` must be a function", arg)
    stop(msg, call. = FALSE)
  }

  args <- as.pairlist(args)
  if (!identical(formals(f), args)) {
    msg <- sprintf(
      "`%s` must be %s, not %s",
      arg,
      show_args(args),
      show_args(formals(f))
    )
    stop(msg, call. = FALSE)
  }
}

show_function <- function(x, constructor = FALSE) {
  args <- formals(x)

  if (constructor) {
    # don't show the defaults arg values in the constructor, keep it compact
    # TODO: do show the default values next to properties in class printouts.
    args <- lapply(args, function(q) quote(expr =))
  }

  show_args(args, suffix = " {...}")
}

show_args <- function(x, name = "function", suffix = "") {
  if (length(x) == 0) {
    args <- ""
  } else {
    val <- vcapply(x, deparse1)
    args <- paste0(names(x), ifelse(val == "", "", " = "), val, collapse = ", ")
  }

  paste0(name, "(", args, ")", suffix)
}

modify_list <- function (x, new_vals) {
  stopifnot(is.list(x) || is.pairlist(x), all(nzchar(names2(x))))

  if (length(new_vals)) {
    nms <- names2(new_vals)
    if (!all(nzchar(nms)))
      stop("all elements in `new_vals` must be named")
    if (is.null(x))
      x <- list()
    x[nms] <- new_vals
  }

  x
}

deparse_trunc <- function(x, width, collapse = "\n") {
  x <- deparse1(x, collapse)
  if (nchar(x) > width)
    x <- sprintf("%s....", substr(x, 0, width-4))
  x
}


# For older versions of R ----------------------------------------------------
deparse1 <- function(expr, collapse = " ", width.cutoff = 500L, ...) {
  paste(deparse(expr, width.cutoff, ...), collapse = collapse)
}

list2DF <- function(x = list(), nrow = 0L) {
  stopifnot(is.list(x), is.null(nrow) || nrow >= 0L)
  if (n <- length(x)) {
    if (length(nrow <- unique(lengths(x))) > 1L) {
      stop("all variables should have the same length")
    }
  } else {
    if (is.null(nrow)) {
      nrow <- 0L
    }
  }
  if (is.null(names(x))) {
    names(x) <- character(n)
  }
  class(x) <- "data.frame"
  attr(x, "row.names") <- .set_row_names(nrow)
  x
}

#' Register an S7 class with S4
#'
#' If you want to use [method<-] to register an method for an S4 generic with
#' an S7 class, you need to call `S4_register()` once.
#'
#' @param class An S7 class created with [new_class()].
#' @param env Expert use only. Environment where S4 class will be registered.
#' @returns Nothing; the function is called for its side-effect.
#' @export
#' @examples
#' methods::setGeneric("S4_generic", function(x) {
#'   standardGeneric("S4_generic")
#' })
#'
#' Foo <- new_class("Foo")
#' S4_register(Foo)
#' method(S4_generic, Foo) <- function(x) "Hello"
#'
#' S4_generic(Foo())
S4_register <- function(class, env = parent.frame()) {
  if (!is_class(class)) {
    msg <- sprintf("`class` must be an S7 class, not a %s", obj_desc(class))
  }

  methods::setOldClass(class_dispatch(class), where = topenv(env))
  invisible()
}

is_S4_class <- function(x) inherits(x, "classRepresentation")

S4_to_S7_class <- function(x, error_base = "") {
  # Silence R CMD check false positives
  distance <- subClass <- className <- package <- NULL

  # Convert generator function to class
  if (methods::is(x, "classGeneratorFunction")) {
    return(S4_to_S7_class(methods::getClass(as.character(x@className)), error_base))
  }

  if (methods::is(x, "ClassUnionRepresentation")) {
    subclasses <- Filter(function(y) y@distance == 1, x@subclasses)
    subclasses <- lapply(subclasses, function(x) methods::getClass(x@subClass))
    do.call("new_union", subclasses)
  } else if (methods::is(x, "classRepresentation")) {
    if (x@package == "methods") {
      basic_classes <- S4_basic_classes()
      if (hasName(basic_classes, x@className)) {
        return(basic_classes[[x@className]])
      }
    }
    if (methods::extends(x, "oldClass")) {
      new_S3_class(as.character(x@className))
    } else {
      x
    }
  } else {
    msg <- sprintf(
      "Unsupported S4 object: must be a class generator or a class definition, not a %s.",
      obj_desc(x)
    )
    stop(paste0(error_base, msg), call. = FALSE)
  }
}

S4_basic_classes <- function() {
  list(
    NULL = NULL,
    logical = class_logical,
    integer = class_integer,
    double = class_double,
    numeric = class_numeric,
    character = class_character,
    complex = class_complex,
    raw = class_raw,
    list = class_list,
    expression = class_expression,
    vector = class_vector,
    `function` = class_function,
    environment = class_environment,
    name = class_name,
    call = class_call,
    data.frame = class_data.frame,
    Date = class_Date,
    factor = class_factor,
    POSIXct = class_POSIXct,
    POSIXlt = class_POSIXlt,
    POSIXt = class_POSIXt,
    # matrix = class_matrix,
    # array = class_array,
    formula = class_formula
  )
}

S4_class_dispatch <- function(x) {
  x <- methods::getClass(x)
  self <- S4_class_name(x)

  # Find class objects for super classes
  extends <- unname(methods::extends(x, fullInfo = TRUE))
  extends <- Filter(function(x) methods::is(x, "SClassExtension"), extends)
  classes <- lapply(extends, function(x) methods::getClass(x@superClass))

  # Remove unions: S7 handles them in method registration, not dispatch.
  classes <- Filter(function(x) !methods::is(x, "ClassUnionRepresentation"), classes)
  # Remove specially named union base classes
  classes <- Filter(function(x) !x@className %in% c("oldClass", "vector"), classes)

  c(self, vcapply(classes, S4_class_name))
}

is_oldClass <- function(x) {
  x@virtual && methods::extends(x, "oldClass") && x@className != "oldClass"
}

S4_class_name <- function(x) {
  if (is_oldClass(x)) {
    return(x@className)
  }

  class <- x@className
  package <- x@package %||% attr(class, "package")

  if (identical(package, "methods") && class %in% names(S4_basic_classes())) {
    class
  } else if (is.null(package) || identical(package, ".GlobalEnv")) {
    paste0("S4/", class)
  } else {
    paste0("S4/", package, "::", class)
  }
}

S4_remove_classes <- function(classes, where = parent.frame()) {
  for (class in classes) {
    suppressWarnings(methods::removeClass(class, topenv(where)))
  }
}

globalVariables(c("superClass", "virtual"))

new_constructor <- function(parent, properties,
                            envir = asNamespace("S7"), package = NULL) {
  properties <- as_properties(properties)
  arg_info <- constructor_args(parent, properties, envir, package)
  self_args <- as_names(names(arg_info$self), named = TRUE)

  if (identical(parent, S7_object) || (is_class(parent) && parent@abstract)) {
    new_object_call <-
      if (has_S7_symbols(envir, "new_object", "S7_object")) {
        bquote(new_object(S7_object(), ..(self_args)), splice = TRUE)
      } else {
        bquote(S7::new_object(S7::S7_object(), ..(self_args)), splice = TRUE)
      }

    return(new_function(
      args = arg_info$self,
      body = as.call(c(quote(`{`),
        # Force all promises here so that any errors are signaled from
        # the constructor() call instead of the new_object() call.
        unname(self_args),
        new_object_call
      )),
      env = envir
    ))
  }

  if (is_class(parent)) {
    parent_name <- parent@name
    parent_fun <- parent
    args <- modify_list(arg_info$parent, arg_info$self)
  } else if (is_base_class(parent)) {
    parent_name <- parent$constructor_name
    parent_fun <- parent$constructor
    args <- modify_list(arg_info$parent, arg_info$self)
  } else if (is_S3_class(parent)) {
    parent_name <- paste0("new_", parent$class[[1]])
    parent_fun <- parent$constructor
    args <- formals(parent$constructor)
    args[names(arg_info$self)] <- arg_info$self
  } else {
    # user facing error in S7_class()
    stop("Unsupported `parent` type", call. = FALSE)
  }

  # ensure default value for `...` is empty
  if ("..." %in% names(args)) {
    args[names(args) == "..."] <- list(quote(expr = ))
  }

  parent_args <- as_names(names(arg_info$parent), named = TRUE)
  names(parent_args)[names(parent_args) == "..."] <- ""
  parent_call <- new_call(parent_name, parent_args)
  body <- new_call(
    if (has_S7_symbols(envir, "new_object")) "new_object" else c("S7", "new_object"),
    c(parent_call, self_args)
  )

  env <- new.env(parent = envir)
  env[[parent_name]] <- parent_fun

  new_function(args, body, env)
}

constructor_args <- function(parent, properties = list(),
                             envir = asNamespace("S7"), package = NULL) {
  parent_args <- formals(class_constructor(parent))

  # Remove read-only properties
  properties <- properties[!vlapply(properties, prop_is_read_only)]

  self_arg_nms <- names2(properties)

  if (is_class(parent) && !parent@abstract) {
    # Remove any parent properties; can't use parent_args() since the constructor
    # might automatically set some properties.
    self_arg_nms <- setdiff(self_arg_nms, names2(parent@properties))
  }

  self_args <- as.pairlist(lapply(
    setNames(, self_arg_nms),
    function(name) prop_default(properties[[name]], envir, package))
  )

  list(parent = parent_args,
       self = self_args)
}


# helpers -----------------------------------------------------------------

is_property_dynamic <- function(x) is.function(x$getter)

missing_args <- function(names) {
  lapply(setNames(, names), function(i) quote(class_missing))
}

new_call <- function(call, args) {
  if (is.character(call)) {
    call <- switch(length(call),
                   as.name(call),
                   as.call(c(quote(`::`), lapply(call, as.name))))
  }
  as.call(c(list(call), args))
}

as_names <- function(x, named = FALSE) {
  if (named) {
    names(x) <- x
  }
  lapply(x, as.name)
}

has_S7_symbols <- function(env, ...) {
  env <- topenv(env)
  if (identical(env, asNamespace("S7")))
    return (TRUE)
  if (!isNamespace(env))
    return (FALSE)
  imports <- getNamespaceImports(env)[["S7"]]
  symbols <- c(...) %||% getNamespaceExports("S7")
  all(symbols %in% imports)
}

#' Declare an S3 class
#'
#' To use an S3 class with S7, you must explicitly declare it using
#' `new_S3_class()` because S3 lacks a formal class definition.
#' (Unless it's an important base class already defined in [base_s3_classes].)
#'
#' # Method dispatch, properties, and unions
#' There are three ways of using S3 with S7 that only require the S3 class
#' vector:
#'
#' * Registering a S3 method for an S7 generic.
#' * Restricting an S7 property to an S3 class.
#' * Using an S3 class in an S7 union.
#'
#' This is easy, and you can usually include the `new_S3_class()`
#' call inline:
#'
#' ```R
#' method(my_generic, new_S3_class("factor")) <- function(x) "A factor"
#' new_class("MyClass", properties = list(types = new_S3_class("factor")))
#' new_union("character", new_S3_class("factor"))
#' ```
#'
#' # Extending an S3 class
#'
#' Creating an S7 class that extends an S3 class requires more work. You'll
#' also need to provide a constructor for the S3 class that follows S7
#' conventions. This means the first argument to the constructor should be
#' `.data`, and it should be followed by one argument for each attribute used
#' by the class.
#'
#' This can be awkward because base S3 classes are usually heavily wrapped for user
#' convenience and no low level constructor is available. For example, the
#' factor class is an integer vector with a character vector of `levels`, but
#' there's no base R function that takes an integer vector of values and
#' character vector of levels, verifies that they are consistent, then
#' creates a factor object.
#'
#' You may optionally want to also provide a `validator` function which will
#' ensure that [validate()] confirms the validity of any S7 classes that build
#' on this class. Unlike an S7 validator, you are responsible for validating
#' the types of the attributes.
#'
#' The following code shows how you might wrap the base Date class.
#' A Date is a numeric vector with class `Date` that can be constructed with
#' `.Date()`.
#'
#' ```R
#' S3_Date <- new_S3_class("Date",
#'   function(.data = integer()) {
#'     .Date(.data)
#'   },
#'   function(self) {
#'     if (!is.numeric(self)) {
#'       "Underlying data must be numeric"
#'     }
#'   }
#' )
#' ```
#'
#' @export
#' @param class S3 class vector (i.e. what `class()` returns). For method
#'   registration, you can abbreviate this to a single string, the S3 class
#'   name.
#' @param constructor An optional constructor that can be used to create
#'   objects of the specified class. This is only needed if you wish to
#'   have an S7 class inherit from an S3 class or to use the S3 class as a
#'   property without a default. It must be specified in the
#'   same way as a S7 constructor: the first argument should be `.data`
#'   (the base type whose attributes will be modified).
#'
#'   All arguments to the constructor should have default values so that
#'   when the constructor is called with no arguments, it returns returns
#'   an "empty", but valid, object.
#' @param validator An optional validator used by [validate()] to check that
#'   the S7 object adheres to the constraints of the S3 class.
#'
#'   A validator is a single argument function that takes the object to
#'   validate and returns `NULL` if the object is valid. If the object is
#'   invalid, it returns a character vector of problems.
#' @returns An S7 definition of an S3 class, i.e. a list with class
#'   `S7_S3_class`.
#' @examples
#' # No checking, just used for dispatch
#' Date <- new_S3_class("Date")
#'
#' my_generic <- new_generic("my_generic", "x")
#' method(my_generic, Date) <- function(x) "This is a date"
#'
#' my_generic(Sys.Date())
new_S3_class <- function(class, constructor = NULL, validator = NULL) {
  if (!is.character(class)) {
    stop("`class` must be a character vector", call. = FALSE)
  }
  if (!is.null(constructor)) {
    check_S3_constructor(constructor)
  } else {
    constructor <- function(.data) {
      stop(sprintf("S3 class <%s> doesn't have a constructor", class[[1]]), call. = FALSE)
    }
  }

  out <- list(
    class = class,
    constructor = constructor,
    validator = validator
  )
  class(out) <- "S7_S3_class"
  out
}

#' @export
print.S7_S3_class <- function(x, ...) {
  cat("<S7_S3_class>: ", class_desc(x), "\n", sep = "")
  invisible(x)
}

#' @export
str.S7_S3_class <- function(object, ..., nest.lev = 0) {
  cat(if (nest.lev > 0) " ")
  print(object, ..., nest.lev = nest.lev)
}

check_S3_constructor <- function(constructor) {
  arg_names <- names(formals(constructor))
  if (arg_names[[1]] != ".data") {
    stop("First argument to `constructor` must be .data", call. = FALSE)
  }
  if ("..." %in% arg_names) {
    stop("`constructor` can not use `...`", call. = FALSE)
  }
}

is_S3_class <- function(x) {
  inherits(x, "S7_S3_class")
}

# -------------------------------------------------------------------------
# Pull out validation functions so hit by code coverage

validate_factor <- function(self) {
  c(
    if (typeof(self) != "integer")
      "Underlying data must be an <integer>",
    if (!is.character(attr(self, "levels", TRUE)))
      "attr(, 'levels') must be a <character>",
    { rng <- range(0L, unclass(self)); NULL },
    if (rng[1] < 0L)
      "Underlying data must be all positive",
    if (rng[2] > length(attr(self, "levels", TRUE)))
      "Not enough 'levels' for underlying data"
  )
}

validate_date <- function(self) {
  c(
    if (mode(self) != "numeric")
      "Underlying data must be numeric",
    if (!inherits(self, "Date"))
      "Underlying data must have class 'Date'"
  )
}

validate_POSIXct <- function(self) {
  if (mode(self) != "numeric") {
    return("Underlying data must be numeric")
  }

  tz <- attr(self, "tz")
  if (!is.character(tz) || length(tz) != 1) {
    return("attr(, 'tz') must be a single string")
  }
}

validate_POSIXlt <- function(self) {
  tryCatch({
    format(self) # calls valid_POSIXlt() in C
    invisible(NULL)
  }, error = function(e) conditionMessage(e))
}

validate_data.frame <- function(self) {
  if (!is.list(self)) {
    return("Underlying data must be a <list>")
  }

  if (length(self) >= 1) {
    # Avoid materialising compact row names
    ns <- unique(c(lengths(self), .row_names_info(self, 2L)))
    if (length(ns) > 1) {
      return("All columns and row names must have the same length")
    }

    if (is.null(names(self))) {
      return("Underlying data must be named")
    }
  }
}

valid_dimnames <- function(self) {
  dn <- dimnames(self)
  if (is.null(dn))
    TRUE
  else if (!is.list(dn) || length(dn) != length(dim(self)))
    FALSE
  else for (i in seq_along(dimnames(self))) {
    if (is.null(dn[[i]]))
      next
    if (!is.character(dn[[i]]) || length(dn[[i]]) != dim(self)[[i]])
      return(FALSE)
  }
  TRUE
}

validate_matrix <- function(self) {
  if (!is.matrix(self)) {
    # is.matrix() methods should only return TRUE if valid
    "is.matrix(self) is FALSE"
  } else if (!is.integer(dim(self)) || length(dim(self)) != 2L || !all(dim(self) >= 0L)) {
    "dim(self) must be a non-negative integer vector of length 2"
  } else if (!valid_dimnames(self)) {
    "dimnames(self) must be NULL or a length 2 list of either NULL or a character vector of length equal to its corresponding dimension"
  }
}

validate_array <- function(self) {
  if (is.array(self)) # is.array() methods should only return TRUE if valid
    return(invisible(NULL))
  if (!is.integer(dim(self)) || length(dim(self)) == 0L || !all(dim(self) >= 0L))
    return("dim(self) must be a non-empty non-negative integer vector")
  if (!valid_dimnames(self))
    return("dimnames(self) must be NULL or a list of either NULL or a character vector of length equal to its corresponding dimension")
  "is.array(self) is FALSE"
}

validate_formula <- function(self) {
  if (is.null(environment(self)))
    return("environment(self) must be non-NULL")
  if (identical(self, stats::formula(NULL, environment(self)))) # weird NULL case
    return(invisible(NULL))
  if (!is.call(self) || !length(self) %in% 2:3 || unclass(self)[[1L]] != quote(`~`))
    return("must be a call to `~` of length 2 or 3")
}

#' S7 wrappers for key S3 classes
#'
#' @description
#' S7 bundles [S3 definitions][new_S3_class] for key S3 classes provided by
#' the base packages:
#'
#' * `class_data.frame` for data frames.
#' * `class_Date` for dates.
#' * `class_factor` for factors.
#' * `class_POSIXct`, `class_POSIXlt` and `class_POSIXt` for date-times.
# * `class_matrix` for matrices.
# * `class_array` for arrays.
#' * `class_formula` for formulas.

#'
#' @export
#' @name base_s3_classes
#' @format NULL
#' @order 3
class_factor <- new_S3_class("factor",
  constructor = function(.data = integer(), levels = NULL) {
    levels <- levels %||% attr(.data, "levels", TRUE) %||% character()
    structure(.data, levels = levels, class = "factor")
  },
  validator = validate_factor
)

#' @export
#' @rdname base_s3_classes
#' @format NULL
#' @order 3
class_Date <- new_S3_class("Date",
  constructor = function(.data = double()) {
    .Date(.data)
  },
  validator = validate_date
)

#' @export
#' @rdname base_s3_classes
#' @format NULL
#' @order 3
class_POSIXct <- new_S3_class(c("POSIXct", "POSIXt"),
  constructor = function(.data = double(), tz = "") {
    .POSIXct(.data, tz = tz)
  },
  validator = validate_POSIXct
)

#' @export
#' @rdname base_s3_classes
#' @format NULL
#' @order 3
class_POSIXlt <- new_S3_class(c("POSIXlt", "POSIXt"),
  constructor = function(.data = NULL, tz = "") {
    as.POSIXlt(.data, tz = tz)
  },
  validator = validate_POSIXlt
)

#' @export
#' @rdname base_s3_classes
#' @format NULL
#' @order 3
class_POSIXt <- new_S3_class("POSIXt") # abstract class

#' @export
#' @rdname base_s3_classes
#' @format NULL
#' @order 3
class_data.frame <- new_S3_class("data.frame",
  constructor = function(.data = list(), row.names = NULL) {
    if (is.null(row.names)) {
      list2DF(.data)
    } else {
      out <- list2DF(.data, length(row.names))
      attr(out, "row.names") <- row.names
      out
    }
  },
  validator = validate_data.frame
)

#  @export
#  @rdname base_s3_classes
#  @format NULL
#  @order 3
class_matrix <- new_S3_class("matrix",
  constructor = function(.data = logical(), nrow = NULL, ncol = NULL, byrow = FALSE, dimnames = NULL) {
    nrow <- nrow %||% NROW(.data)
    if(is.null(ncol)) {
      ncol <- NCOL(.data)
      if(length(.data) != (nrow * ncol)) {
        ncol <- length(.data) %/% nrow
      }
    }
    matrix(.data, nrow, ncol, byrow, dimnames)
  },
  validator = validate_matrix
)

#  @export
#  @rdname base_s3_classes
#  @format NULL
#  @order 3
class_array <- new_S3_class("array",
  constructor = function(.data = logical(),
                         dim = base::dim(.data) %||% length(.data),
                         dimnames = base::dimnames(.data)) {
    array(.data, dim, dimnames)
  },
  validator = validate_array
)

#' @export
#' @rdname base_s3_classes
#' @format NULL
#' @order 3
class_formula <- new_S3_class("formula",
  constructor = function(.data = NULL, env = parent.frame()) {
    stats::formula(.data, env = env)
  },
  validator = validate_formula
)

`%||%` <- function(x, y) if (is.null(x)) y else x

new_function <- function(args = NULL,
                         body = NULL,
                         env = asNamespace("S7")) {
  as.function.default(c(args, body) %||% list(NULL), env)
}


`append<-` <- function(x, after, value) {
  if (missing(after))
    c(x, value)
  else
    append(x, value, after = after)
}

`append1<-` <- function (x, value) {
  stopifnot(is.list(x) || identical(mode(x), mode(value)))
  x[[length(x) + 1L]] <- value
  x
}


topNamespaceName <- function(env = parent.frame()) {
  env <- topenv(env)
  if (!isNamespace(env)) {
    return() # print visible
  }

  as.character(getNamespaceName(env)) # unname
}

is_string <- function(x) {
  identical(class(x), "character") && length(x) == 1L && !is.na(x) && x != ""
}

#' Convert an object from one type to another
#'
#' @description
#' `convert(from, to)` is a built-in generic for converting an object from
#' one type to another. It is special in three ways:
#'
#' * It uses double-dispatch, because conversion depends on both `from` and
#'   `to`.
#'
#' * It uses non-standard dispatch because `to` is a class, not an object.
#'
#' * It doesn't use inheritance for the `to` argument. To understand
#'   why, imagine you have written methods to objects of various types to
#'   `classParent`. If you then create a new `classChild` that inherits from
#'   `classParent`, you can't expect the methods written for `classParent`
#'   to work because those methods will return `classParent` objects, not
#'   `classChild` objects.
#'
#' `convert()` provides two default implementations:
#'
#' 1. When `from` inherits from `to`, it strips any properties that `from`
#'    possesses that `to` does not (downcasting).
#' 2. When `to` is a subclass of `from`'s class, it creates a new object of
#'    class `to`, copying over existing properties from `from` and initializing
#'    new properties of `to` (upcasting).
#'
#' If you are converting an object solely for the purposes of accessing a method
#' on a superclass, you probably want [super()] instead. See its docs for more
#' details.
#'
#' ## S3 & S4
#'
#' `convert()` plays a similar role to the convention of defining `as.foo()`
#' functions/generics in S3, and to `as()`/`setAs()` in S4.
#'
#' @param from An S7 object to convert.
#' @param to An S7 class specification, passed to [as_class()].
#' @param ... Other arguments passed to custom `convert()` methods. For upcasting,
#'   these can be used to override existing properties or set new ones.
#' @return Either `from` coerced to class `to`, or an error if the coercion
#'   is not possible.
#' @export
#' @examples
#' Foo1 <- new_class("Foo1", properties = list(x = class_integer))
#' Foo2 <- new_class("Foo2", Foo1, properties = list(y = class_double))
#'
#' # Downcasting: S7 provides a default implementation for coercing an object
#' # to one of its parent classes:
#' convert(Foo2(x = 1L, y = 2), to = Foo1)
#'
#' # Upcasting: S7 also provides a default implementation for coercing an object
#' # to one of its child classes:
#' convert(Foo1(x = 1L), to = Foo2)
#' convert(Foo1(x = 1L), to = Foo2, y = 2.5)  # Set new property
#' convert(Foo1(x = 1L), to = Foo2, x = 2L, y = 2.5)  # Override existing and set new
#'
#' # For all other cases, you'll need to provide your own.
#' try(convert(Foo1(x = 1L), to = class_integer))
#'
#' method(convert, list(Foo1, class_integer)) <- function(from, to) {
#'   from@x
#' }
#' convert(Foo1(x = 1L), to = class_integer)
#'
#' # Note that conversion does not respect inheritance so if we define a
#' # convert method for integer to foo1
#' method(convert, list(class_integer, Foo1)) <- function(from, to) {
#'   Foo1(x = from)
#' }
#' convert(1L, to = Foo1)
#'
#' # Converting to Foo2 will still error
#' try(convert(1L, to = Foo2))
#' # This is probably not surprising because foo2 also needs some value
#' # for `@y`, but it definitely makes dispatch for convert() special
convert <- function(from, to, ...) {
  to <- as_class(to)
  check_can_inherit(to)

  dispatch <- list(obj_dispatch(from), class_register(to))
  convert <- .Call(method_, convert, dispatch, environment(), FALSE)

  if (!is.null(convert)) {
    convert(from, to, ...)
  } else if (class_inherits(from, to)) {
    from_class <- S7_class(from)
    if (is.null(from_class)) {
      from_props <- character()
    } else {
      from_props <- names(from_class@properties)
    }

    if (is_base_class(to)) {
      from <- zap_attr(from, c(from_props, "S7_class", "class"))
    } else if (is_S3_class(to)) {
      from <- zap_attr(from, c(from_props, "S7_class"))
      class(from) <- to$class
    } else if (is_class(to)) {
      from <- zap_attr(from, setdiff(from_props, names(to@properties)))
      attr(from, "S7_class") <- to
      class(from) <- class_dispatch(to)
    } else {
      stop("Unreachable")
    }
    from
  } else if (is_parent_instance(from, to)) {
    # We're up-casting, using `from` as a prototype/seed when constructing `to`.
    # Essentially, we copy over property values from `from` and supply them as
    # arguments to the `to` constructor.

    # Get properties of 'from' class
    from_props <- S7_class(from)@properties

    # Remove read-only properties
    from_props <- Filter(Negate(prop_is_read_only), from_props)
    from_prop_names <- names(from_props)

    # Check if 'to' constructor can accept all properties
    to_constructor_arg_names <- names(formals(to))
    if (!"..." %in% to_constructor_arg_names) {
      # If no ..., only use properties that match constructor arguments
      from_prop_names <- intersect(from_prop_names, to_constructor_arg_names)
    }

    # Remove properties that are overridden in user-supplied arguments
    user_args <- list(...)
    from_prop_names <- setdiff(from_prop_names, names(user_args))

    # Extract property values from 'from'
    from_prop_values <- props(from, from_prop_names)

    # Combine property values with user-supplied arguments
    constructor_args <- c(from_prop_values, user_args)

    # Create and return new object of class 'to'
    do.call(to, constructor_args)
  } else {
    msg <- paste0(
      "Can't find method for generic `convert()` with dispatch classes:\n",
      "- from: ", obj_desc(from), "\n",
      "- to  : ", class_desc(to), "\n"
    )
    stop(msg, call. = FALSE)
  }
}

# Converted to S7_generic onLoad in order to avoid dependency between files
on_load_make_convert_generic <- function() {
  convert <<- S7_generic(
    convert,
    name = "convert",
    dispatch_args = c("from", "to")
  )
}

is_parent_instance <- function(x, class) {
  inherits(x, setdiff(class_dispatch(class), "S7_object"))
}

#' Find a method for an S7 generic
#'
#' `method()` takes a generic and class signature and performs method dispatch
#' to find the corresponding method implementation. This is rarely needed
#' because you'll usually rely on the the generic to do dispatch for you (via
#' [S7_dispatch()]). However, this introspection is useful if you want to see
#' the implementation of a specific method.
#'
#' @seealso [method_explain()] to explain why a specific method was picked.
#' @inheritParams method<-
#' @returns Either a function with class `S7_method` or an error if no
#'   matching method is found.
#' @param class,object Perform introspection either with a `class`
#'   (processed with [as_class()]) or a concrete `object`. If `generic` uses
#'   multiple dispatch then both `object` and `class` must be a list of
#'   classes/objects.
#' @export
#' @examples
#' # Create a generic and register some methods
#' bizarro <- new_generic("bizarro", "x")
#' method(bizarro, class_numeric) <- function(x) rev(x)
#' method(bizarro, class_factor) <- function(x) {
#'   levels(x) <- rev(levels(x))
#'   x
#' }
#'
#' # Printing the generic shows the registered method
#' bizarro
#'
#' # And you can use method() to inspect specific implementations
#' method(bizarro, class = class_integer)
#' method(bizarro, object = 1)
#' method(bizarro, class = class_factor)
#'
#' # errors if method not found
#' try(method(bizarro, class = class_data.frame))
#' try(method(bizarro, object = "x"))
method <- function(generic, class = NULL, object = NULL) {
  check_is_S7(generic, S7_generic)
  dispatch <- as_dispatch(generic, class = class, object = object)

  method <- .Call(method_, generic, dispatch, environment(), FALSE)
  if (!is.null(method)) {
    return(method)
  }

  # can't rely on usual error mechanism because it involves looking up
  # argument values in the dispatch environment, which doesn't exist here
  types <- error_types(generic, class = class, object = object)
  msg <- method_lookup_error_message(generic@name, types)
  stop(msg, call. = FALSE)
}

#' Explain method dispatch
#'
#' @description
#' `method_explain()` shows all possible methods that a call to a generic
#' might use, which ones exist, and which one will actually be called.
#'
#' Note that method dispatch uses a string representation of each class in
#' the class hierarchy. Each class system uses a slightly different convention
#' to avoid ambiguity.
#'
#' * S7: `pkg::class` or `class`
#' * S4: `S4/pkg::class` or `S4/class`
#' * S3: `class`
#'
#' @inheritParams method
#' @return Nothing; this function is called for it's side effects.
#' @export
#' @examples
#' Foo1 <- new_class("Foo1")
#' Foo2 <- new_class("Foo2", Foo1)
#'
#' add <- new_generic("add", c("x", "y"))
#' method(add, list(Foo2, Foo1)) <- function(x, y) c(2, 1)
#' method(add, list(Foo1, Foo1)) <- function(x, y) c(1, 1)
#'
#' method_explain(add, list(Foo2, Foo2))
method_explain <- function(generic, class = NULL, object = NULL) {
  check_is_S7(generic, S7_generic)
  dispatch <- as_dispatch(generic, class = class, object = object)
  dispatch <- lapply(dispatch, c, "ANY")

  grid <- as.matrix(rev(do.call("expand.grid", rev(dispatch))))
  colnames(grid) <- generic@dispatch_args

  names <- paste0("[", grid, "]")
  dim(names) <- dim(grid)
  methods <- apply(names, 1, paste, collapse = ", ")

  has_method <- function(dispatches, env) {
    for (x in dispatches) {
      env <- env[[x]]
    }
    is.function(env)
  }
  exists <- apply(grid, 1, has_method, env = generic@methods)

  label <- ifelse(exists, "* ", "  ")
  if (any(exists)) {
    label[which(exists)[[1]]] <- "->"
  }

  cat(paste0(label, " ", generic@name, "(", methods, ")\n"), sep = "")
  invisible()
}


as_dispatch <- function(generic, class = NULL, object = NULL) {
  if (!is.null(class) && is.null(object)) {
    signature <- as_signature(class, generic)
    is_union <- vlapply(signature, is_union)
    if (any(is_union)) {
      stop("Can't dispatch on unions; must be a concrete type")
    }

    lapply(signature, class_dispatch)
  } else if (!is.null(object) && is.null(class)) {
    n <- generic_n_dispatch(generic)
    if (n == 1) {
      object <- list(object)
    } else {
      check_signature_list(object, n = n, arg = "object")
    }
    lapply(object, obj_dispatch)
  } else {
    stop("Must supply exactly one of `class` and `object`", call. = FALSE)
  }
}

error_types <- function(generic, class = NULL, object = NULL) {
  if (is.null(class)) {
    n <- generic_n_dispatch(generic)
    if (n == 1) {
      types <- list(obj_desc(object))
    } else {
      types <- vcapply(object, obj_desc)
    }
  } else {
    signature <- as_signature(class, generic)
    types <- vcapply(signature, class_desc)
  }
  names(types) <- generic@dispatch_args
  types
}

base_ops <- NULL
base_matrix_ops <- NULL

on_load_define_ops <- function() {
  base_ops <<- lapply(
    setNames(, group_generics()$Ops),
    new_generic,
    dispatch_args = c("e1", "e2")
  )
  base_matrix_ops <<- lapply(
    setNames(, group_generics()$matrixOps),
    new_generic,
    dispatch_args = c("x", "y")
  )
}

#' @export
Ops.S7_object <- function(e1, e2) {
  cnd <- tryCatch(
    return(base_ops[[.Generic]](e1, e2)),
    S7_error_method_not_found = function(cnd) cnd
  )

  if (S7_inherits(e1) && S7_inherits(e2)) {
    stop(cnd)
  } else {
    # Must call NextMethod() directly in the method, not wrapped in an
    # anonymous function.
    NextMethod()
  }
}

#' @rawNamespace if (getRversion() >= "4.3.0") S3method(chooseOpsMethod, S7_object)
chooseOpsMethod.S7_object <- function(x, y, mx, my, cl, reverse) TRUE

#' @rawNamespace if (getRversion() >= "4.3.0") S3method(matrixOps, S7_object)
matrixOps.S7_object <- function(x, y) {
  base_matrix_ops[[.Generic]](x, y)
}

#' @export
Ops.S7_super <- Ops.S7_object

#' @rawNamespace if (getRversion() >= "4.3.0") S3method(chooseOpsMethod, S7_super)
chooseOpsMethod.S7_super <- chooseOpsMethod.S7_object

#' @rawNamespace if (getRversion() >= "4.3.0") S3method(matrixOps, S7_super)
matrixOps.S7_super <- matrixOps.S7_object

#' Get/set underlying "base" data
#'
#' When an S7 class inherits from an existing base type, it can be useful
#' to work with the underlying object, i.e. the S7 object stripped of class
#' and properties.
#'
#' @inheritParams prop
#' @param value Object used to replace the underlying data.
#' @return `S7_data()` returns the data stored in the base object;
#'   `S7_data<-()` is called for its side-effects and returns `object`
#'   invisibly.
#' @export
#' @examples
#' Text <- new_class("Text", parent = class_character)
#' y <- Text(c(foo = "bar"))
#' y
#' S7_data(y)
#'
#' S7_data(y) <- c("a", "b")
#' y
S7_data <- function(object) {
  check_is_S7(object)

  zap_attr(object, c(prop_names(object), "class", "S7_class"))
}

#' @export
#' @rdname S7_data
`S7_data<-` <- function(object, check = TRUE, value) {
  attrs <- attributes(object)
  object <- value
  attributes(object) <- attrs
  if (isTRUE(check)) {
    validate(object)
  }
  return(invisible(object))
}


zap_attr <- function(x, names) {
  for (name in names) {
    attr(x, name) <- NULL
  }
  x
}

is_generic <- function(x) {
  is_S7_generic(x) || is_external_generic(x) || is_S3_generic(x) || is_S4_generic(x)
}

as_generic <- function(x) {
  if (is_generic(x)) {
    x
  } else if (is.function(x)) {
    as_S3_generic(x)
  } else {
    msg <- sprintf("`generic` must be a function, not a %s", obj_desc(x))
    stop(msg, call. = FALSE)
  }
}

as_S3_generic <- function(x) {
  use_method <- find_call(body(x), quote(UseMethod))
  if (!is.null(use_method)) {
    return(S3_generic(x, as.character(use_method[[2]])))
  } else {
    name <- find_base_name(x)
    if (name %in% names(base_ops)) {
      return(base_ops[[name]])
    } else if (name %in% names(base_matrix_ops)) {
      return(base_matrix_ops[[name]])
    } else if (!is.na(name) && is_internal_generic(name)) {
      return(S3_generic(x, name))
    }
  }

  stop("`generic` is a function, but not an S3 generic function: \n",
       deparse_trunc(x, 100), call. = FALSE)
}

S3_generic <- function(generic, name) {
  out <- list(generic = generic, name = name)
  class(out) <- "S7_S3_generic"
  out
}

is_S3_generic <- function(x) inherits(x, "S7_S3_generic")

is_S4_generic <- function(x) inherits(x, "genericFunction")

# Is the generic defined in the "current" package
is_local_generic <- function(generic, package) {
  if (is_external_generic(generic)) {
    return(FALSE)
  }

  generic_pkg <- package_name(generic)
  is.null(generic_pkg) || generic_pkg == package
}

package_name <- function(f) {
  env <- environment(f)
  if (is.null(env)) {
    "base"
  } else {
    (packageName(env))
  }
}

generic_n_dispatch <- function(x) {
  if (is_S7_generic(x)) {
    length(x@dispatch_args)
  } else if (is_external_generic(x)) {
    length(x$dispatch_args)
  } else if (is_S3_generic(x)) {
    1
  } else if (is_S4_generic(x)) {
    length(x@signature)
  } else {
    stop(sprintf("Invalid input %", obj_desc(x)), call. = FALSE)
  }
}

# Internal generics -------------------------------------------------------

find_base_name <- function(f, candidates = NULL) {
  env <- baseenv()
  candidates <- candidates %||% names(env)
  for (name in candidates) {
    if (identical(f, env[[name]])) {
      return(name)
    }
  }

  NA
}

is_internal_generic <- function(x) {
  x %in% internal_generics()
}

internal_generics <- function() {
  group <- unlist(group_generics(), use.names = FALSE)
  primitive <- .S3PrimitiveGenerics

  # Extracted from ?"internal generic"
  internal <- c("[", "[[", "$", "[<-", "[[<-", "$<-", "unlist",
    "cbind", "rbind", "as.vector")

  c(group, primitive, internal)
}

group_generics <- function() {
  # S3 group generics can be defined by combining S4 group generics
  groups <- list(
    Ops = c("Arith", "Compare", "Logic"),
    Math = c("Math", "Math2"),
    Summary = "Summary",
    Complex = "Complex"
  )

  out <- lapply(groups, function(x) unlist(lapply(x, methods::getGroupMembers)))
  if (getRversion() >= "4.3") {
    out$matrixOps <- c("%*%")
  }
  out
}

#' Define a new generic
#'
#' @description
#' A generic function uses different implementations (_methods_) depending on
#' the class of one or more arguments (the _signature_). Create a new generic
#' with `new_generic()` then use [method<-] to add methods to it.
#'
#' Method dispatch is performed by `S7_dispatch()`, which must always be
#' included in the body of the generic, but in most cases `new_generic()` will
#' generate this for you.
#'
#' Learn more in `vignette("generics-methods")`
#'
#' @section Dispatch arguments:
#' The arguments that are used to pick the method are called the **dispatch
#' arguments**. In most cases, this will be one argument, in which case the
#' generic is said to use **single dispatch**. If it consists of more than
#' one argument, it's said to use **multiple dispatch**.
#'
#' There are two restrictions on the dispatch arguments: they must be the first
#' arguments to the generic and if the generic uses `...`, it must occur
#' immediately after the dispatch arguments.
#'
#' @param name The name of the generic. This should be the same as the object
#'   that you assign it to.
#' @param dispatch_args A character vector giving the names of one or more
#'   arguments used to find the method.
#' @param fun An optional specification of the generic, which must call
#'  `S7_dispatch()` to dispatch to methods. This is usually generated
#'  automatically from the `dispatch_args`, but you may want to supply it if
#'  you want to add additional required arguments, omit `...`, or perform
#'  some standardised computation in the generic.
#'
#'  The `dispatch_args` must be the first arguments to `fun`, and, if present,
#'  `...` must immediately follow them.
#' @seealso [new_external_generic()] to define a method for a generic
#'  in another package without taking a strong dependency on it.
#' @export
#' @returns An S7 generic, i.e. a function with class `S7_generic`.
#' @order 1
#' @examples
#' # A simple generic with methods for some base types and S3 classes
#' type_of <- new_generic("type_of", dispatch_args = "x")
#' method(type_of, class_character) <- function(x, ...) "A character vector"
#' method(type_of, new_S3_class("data.frame")) <- function(x, ...) "A data frame"
#' method(type_of, class_function) <- function(x, ...) "A function"
#'
#' type_of(mtcars)
#' type_of(letters)
#' type_of(mean)
#'
#' # If you want to require that methods implement additional arguments,
#' # you can use a custom function:
#' mean2 <- new_generic("mean2", "x", function(x, ..., na.rm = FALSE) {
#'    S7_dispatch()
#' })
#'
#' method(mean2, class_numeric) <- function(x, ..., na.rm = FALSE) {
#'   if (na.rm) {
#'     x <- x[!is.na(x)]
#'   }
#'   sum(x) / length(x)
#' }
#'
#' # You'll be warned if you forget the argument:
#' method(mean2, class_character) <- function(x, ...) {
#'   stop("Not supported")
#' }
new_generic <- function(name, dispatch_args, fun = NULL) {
  check_name(name)

  dispatch_args <- check_dispatch_args(dispatch_args, fun)

  if (is.null(fun)) {
    args <- c(dispatch_args, "...")
    args <- setNames(lapply(args, function(i) quote(expr = )), args)
    fun <- new_function(args, quote(S7::S7_dispatch()), parent.frame())
  } else {
    check_generic(fun)
  }

  S7_generic(fun, name = name, dispatch_args = dispatch_args)
}

check_dispatch_args <- function(dispatch_args, fun = NULL) {
  if (!is.character(dispatch_args)) {
    stop("`dispatch_args` must be a character vector", call. = FALSE)
  }
  if (length(dispatch_args) == 0) {
    stop("`dispatch_args` must have at least one component", call. = FALSE)
  }
  if (anyDuplicated(dispatch_args)) {
    stop("`dispatch_args` must be unique", call. = FALSE)
  }
  if (any(is.na(dispatch_args) | dispatch_args == "")) {
    stop("`dispatch_args` must not be missing or the empty string")
  }
  if ("..." %in% dispatch_args) {
    stop("Can't dispatch on `...`", call. = FALSE)
  }

  if (!is.null(fun)) {
    arg_names <- names(formals(fun))

    if (!is_prefix(dispatch_args, arg_names)) {
      stop("`dispatch_args` must be a prefix of the generic arguments", call. = FALSE)
    }
  }

  dispatch_args
}

#' @export
print.S7_generic <- function(x, ...) {
  methods <- methods(x)
  formals <- show_args(formals(x), x@name)
  cat(sprintf("<S7_generic> %s with %i methods:\n", formals, length(methods)), sep = "")

  if (length(methods) > 0) {
    signatures <- lapply(methods, prop, "signature")
    msg <- vcapply(signatures, method_signature, generic = x)
    msg <- paste0(format(seq_along(signatures)), ": ", msg, "\n")
    cat(msg, sep = "")
  }

  invisible(x)
}

check_generic <- function(fun) {
  if (!is.function(fun)) {
    stop("`fun` must be a function", call. = FALSE)
  }

  dispatch_call <- find_call(body(fun), quote(S7_dispatch), packageName())
  if (is.null(dispatch_call)) {
    stop("`fun` must contain a call to `S7_dispatch()`", call. = FALSE)
  }
}

#' Recursively find a call (namespaced or plain)
#'
#' @param x An language object
#' @param name A name/symbol
#' @param ns A string. If `NULL` (the default), only unnamespaced calls are
#'   matched.  If a string, the call may also match a `ns`-qualified call.
#' @return `call` object if found; `NULL` otherwise.
#' @noRd
find_call <- function(x, name, ns = NULL) {
  if (!is.call(x)) {
    return(NULL)
  }

  # is namespaced `ns::name(...)` or plain `name(...)` call
  if (is_ns_call(x[[1]], name, ns) || identical(x[[1]], name)) {
    return(x)
  }

  # otherwise, recurse through arguments
  if (length(x) > 1) {
    for (i in seq(2, length(x))) {
      call <- find_call(x[[i]], name = name, ns = ns)
      if (!is.null(call)) {
        return(call)
      }
    }
  }
  NULL
}

is_ns_call <- function(x, name, ns = NULL) {
  if (is.null(ns)) return(FALSE)

  length(x) == 3 &&
    identical(x[[2]], as.symbol(ns)) &&
    identical(x[[1]], quote(`::`)) &&
    identical(x[[3]], name)
}

methods <- function(generic) {
  methods_rec(generic@methods, character())
}
methods_rec <- function(x, signature) {
  if (!is.environment(x)) {
    return(x)
  }

  # Recursively collapse environments to a list
  methods <- lapply(names(x), function(class) methods_rec(x[[class]], c(signature, class)))
  unlist(methods, recursive = FALSE)
}

generic_add_method <- function(generic, signature, method) {
  p_tbl <- generic@methods
  chr_signature <- vcapply(signature, class_register)

  if (is.null(attr(method, "name", TRUE)))
    attr(method, "name") <- as.name(method_signature(generic, signature))

  for (i in seq_along(chr_signature)) {
    class_name <- chr_signature[[i]]
    if (i != length(chr_signature)) {
      # Iterated dispatch, so create another nested environment
      tbl <- p_tbl[[class_name]]
      if (is.null(tbl)) {
        tbl <- new.env(hash = TRUE, parent = emptyenv())
        p_tbl[[class_name]] <- tbl
      }
      p_tbl <- tbl
    } else {
      if (!is.null(p_tbl[[class_name]])) {
        message("Overwriting method ", method_name(generic, signature))
      }
      p_tbl[[class_name]] <- method
    }
  }
}

#' Generics in other packages
#'
#' @description
#' You need an explicit external generic when you want to provide methods
#' for a generic (S3, S4, or S7) that is defined in another package, and you
#' don't want to take a hard dependency on that package.
#'
#' The easiest way to provide methods for generics in other packages is
#' import the generic into your `NAMESPACE`. This, however, creates a hard
#' dependency, and sometimes you want a soft dependency, only registering the
#' method if the package is already installed. `new_external_generic()` allows
#' you to provide the minimal needed information about a generic so that methods
#' can be registered at run time, as needed, using [methods_register()].
#'
#' Note that in tests, you'll need to explicitly call the generic from the
#' external package with `pkg::generic()`.
#'
#' @param package Package the generic is defined in.
#' @param name Name of generic, as a string.
#' @param dispatch_args Character vector giving arguments used for dispatch.
#' @param version An optional version the package must meet for the method to
#'   be registered.
#' @returns An S7 external generic, i.e. a list with class
#'   `S7_external_generic`.
#' @export
#' @examples
#' MyClass <- new_class("MyClass")
#'
#' your_generic <- new_external_generic("stats", "median", "x")
#' method(your_generic, MyClass) <- function(x) "Hi!"
new_external_generic <- function(package, name, dispatch_args, version = NULL) {
  out <- list(
    package = package,
    name = name,
    dispatch_args = dispatch_args,
    version = version
  )

  class(out) <- "S7_external_generic"
  out
}

as_external_generic <- function(x) {
  if (is_S7_generic(x)) {
    pkg <- package_name(x)
    new_external_generic(pkg, x@name, x@dispatch_args)
  } else if (is_external_generic(x)) {
    x
  } else if (is_S3_generic(x)) {
    pkg <- package_name(x$generic)
    new_external_generic(pkg, x$name, "__S3__")
  } else if (is_S4_generic(x)) {
    new_external_generic(x@package, as.vector(x@generic), x@signature)
  }
}

#' @export
print.S7_external_generic <- function(x, ...) {
  cat(
    "<S7_external_generic> ",
    x$package, "::", x$name, "(", paste(x$dispatch_args, collapse = ", "), ")",
    if (!is.null(x$version)) paste0(" (>= ", x$version, ")"),
    "\n",
    sep = ""
  )
  invisible(x)
}

is_external_generic <- function(x) {
  inherits(x, "S7_external_generic")
}

#' Register methods in a package
#'
#' When using S7 in a package you should always call `methods_register()` when
#' your package is loaded. This ensures that methods are registered as needed
#' when you implement methods for generics (S3, S4, and S7) in other packages.
#' (This is not strictly necessary if you only register methods for generics
#' in your package, but it's better to include it and not need it than forget
#' to include it and hit weird errors.)
#'
#' @importFrom utils getFromNamespace packageName
#' @export
#' @returns Nothing; called for its side-effects.
#' @examples
#' .onLoad <- function(...) {
#'   S7::methods_register()
#' }
methods_register <- function() {
  package <- packageName(parent.frame())
  ns <- topenv(parent.frame())
  # TODO?: check/enforce that methods_register() is being called from .onLoad()

  tbl <- S7_methods_table(package)

  for (x in tbl) {
    register <- registrar(x$generic, x$signature, x$method, ns)

    if (isNamespaceLoaded(x$generic$package)) {
      register()
    } else {
      setHook(packageEvent(x$generic$package, "onLoad"), register)
    }
  }

  invisible()
}

registrar <- function(generic, signature, method, env) {
  # Force all arguments
  generic; signature; method; env;

  function(...) {
    ns <- asNamespace(generic$package)
    if (is.null(generic$version) || getNamespaceVersion(ns) >= generic$version) {
      if (!exists(generic$name, envir = ns, inherits = FALSE)) {
        msg <- sprintf("[S7] Failed to find generic %s() in package %s", generic$name, generic$package)
        warning(msg, call. = FALSE)
      } else {
        generic_fun <- get(generic$name, envir = ns, inherits = FALSE)
        register_method(generic_fun, signature, method, env, package = NULL)
      }
    }
  }
}

external_methods_reset <- function(package) {
  S7_methods_table(package) <- list()
  invisible()
}

external_methods_add <- function(package, generic, signature, method) {
  tbl <- S7_methods_table(package)

  append1(tbl) <- list(generic = generic,
                       signature = signature,
                       method = method)

  S7_methods_table(package) <- tbl
  invisible()
}

# Store external methods in an attribute of the S3 methods table since
# this mutable object is present in all packages.

S7_methods_table <- function(package) {
  ns <- asNamespace(package)
  tbl <- ns[[".__S3MethodsTable__."]]
  attr(tbl, "S7methods") %||% list()
}
`S7_methods_table<-` <- function(package, value) {
  ns <- asNamespace(package)
  tbl <- ns[[".__S3MethodsTable__."]]
  attr(tbl, "S7methods") <- value
  invisible()
}

#' Register an S7 method for a generic
#'
#' @description
#' A generic defines the interface of a function. Once you have created a
#' generic with [new_generic()], you provide implementations for specific
#' signatures by registering methods with `method<-`.
#'
#' The goal is for `method<-` to be the single function you need when working
#' with S7 generics or S7 classes. This means that as well as registering
#' methods for S7 classes on S7 generics, you can also register methods for
#' S7 classes on S3 or S4 generics, and S3 or S4 classes on S7 generics.
#' But this is not a general method registration function: at least one of
#' `generic` and `signature` needs to be from S7.
#'
#' Note that if you are writing a package, you must call [methods_register()]
#' in your `.onLoad`. This ensures that all methods are dynamically registered
#' when needed.
#'
#' @param generic A generic function, i.e. an [S7 generic][new_generic],
#'   an [external generic][new_external_generic], an [S3 generic][UseMethod],
#'   or an [S4 generic][methods::setGeneric].
#' @param signature A method signature.
#'
#'   For S7 generics that use single dispatch, this must be one of the
#'   following:
#'
#'   * An S7 class (created by [new_class()]).
#'   * An S7 union (created by [new_union()]).
#'   * An S3 class (created by [new_S3_class()]).
#'   * An S4 class (created by [methods::getClass()] or [methods::new()]).
#'   * A base type like [class_logical], [class_integer], or [class_numeric].
#'   * A special type like [class_missing] or [class_any].
#'
#'   For S7 generics that use multiple dispatch, this must be a list of any of
#'   the above types.
#'
#'   For S3 generics, this must be a single S7 class.
#'
#'   For S4 generics, this must either be an S7 class, or a list that includes
#'   at least one S7 class.
#' @param value A function that implements the generic specification for the
#'   given `signature`.
#' @returns The `generic`, invisibly.
#' @export
#' @examples
#' # Create a generic
#' bizarro <- new_generic("bizarro", "x")
#' # Register some methods
#' method(bizarro, class_numeric) <- function(x) rev(x)
#' method(bizarro, new_S3_class("data.frame")) <- function(x) {
#'   x[] <- lapply(x, bizarro)
#'   rev(x)
#' }
#'
#' # Using a generic calls the methods automatically
#' bizarro(head(mtcars))
`method<-` <- function(generic, signature, value) {
  register_method(generic, signature, value, env = parent.frame())
  invisible(generic)
}

register_method <- function(generic,
                            signature,
                            method,
                            env = parent.frame(),
                            package = packageName(env)) {
  generic <- as_generic(generic)
  signature <- as_signature(signature, generic)


  if (is_external_generic(generic) && isNamespaceLoaded(generic$package)) {
    generic <- as_generic(getFromNamespace(generic$name, generic$package))
  }

  # Register in current session
  if (is_S7_generic(generic)) {
    check_method(method, generic, name = method_name(generic, signature))
    register_S7_method(generic, signature, method)
  } else if (is_S3_generic(generic)) {
    register_S3_method(generic, signature, method, env)
  } else if (is_S4_generic(generic)) {
    register_S4_method(generic, signature, method, env)
  }

  # if we're inside a package, we also need to be able register methods
  # when the package is loaded
  if (!is.null(package) && !is_local_generic(generic, package)) {
    generic <- as_external_generic(generic)
    external_methods_add(package, generic, signature, method)
  }

  invisible(generic)
}

register_S3_method <- function(generic, signature, method, envir = parent.frame()) {
  if (class_type(signature[[1]]) != "S7") {
    msg <- sprintf(
      "When registering methods for S3 generic %s(), signature must be an S7 class, not %s.",
      generic$name,
      class_friendly(signature[[1]])
    )
    stop(msg, call. = FALSE)
  }

  if (is_external_generic(external_generic <- get0(generic$name, envir = envir))) {
    envir <- asNamespace(external_generic$package)
  }

  class <- S7_class_name(signature[[1]])
  registerS3method(generic$name, class, method, envir)
}

register_S7_method <- function(generic, signature, method) {
  # Flatten out unions to individual signatures
  signatures <- flatten_signature(signature)

  # Register each method
  for (signature in signatures) {
    method <- S7_method(method, generic = generic, signature = signature)
    generic_add_method(generic, signature, method)
  }

  invisible()
}

flatten_signature <- function(signature) {
  # Unpack unions
  sig_is_union <- vlapply(signature, is_union)
  signature[sig_is_union] <- lapply(signature[sig_is_union], "[[", "classes")
  signature[!sig_is_union] <- lapply(signature[!sig_is_union], list)

  # Create grid of indices
  indx <- lapply(signature, seq_along)
  comb <- as.matrix(rev(do.call("expand.grid", rev(indx))))
  colnames(comb) <- NULL

  rows <- lapply(1:nrow(comb), function(i) comb[i, ])
  lapply(rows, function(row) Map("[[", signature, row))
}

as_signature <- function(signature, generic) {
  if (inherits(signature, "S7_signature")) {
    return(signature)
  }

  n <- generic_n_dispatch(generic)
  if (n == 1) {
    new_signature(list(as_class(signature, arg = "signature")))
  } else {
    check_signature_list(signature, n)
    for (i in seq_along(signature)) {
      signature[i] <- list(as_class(signature[[i]], arg = sprintf("signature[[%i]]", i)))
    }
    new_signature(signature)
  }
}

check_signature_list <- function(x, n, arg = "signature") {
  if (!is.list(x) || is.object(x)) {
    stop(sprintf("`%s` must be a list for multidispatch generics", arg), call. = FALSE)
  }
  if (length(x) != n) {
    stop(sprintf("`%s` must be length %i", arg, n), call. = FALSE)
  }
}

new_signature <- function(x) {
  class(x) <- "S7_signature"
  x
}

check_method <- function(method, generic, name = paste0(generic@name, "(???)")) {
  if (!is.function(method)) {
    stop(sprintf("%s must be a function", name), call. = FALSE)
  }

  generic_formals <- formals(args(generic))
  method_formals <- formals(method)
  generic_args <- names(generic_formals)
  method_args <- names(method_formals)

  if (!"..." %in% generic_args && !identical(generic_formals, method_formals)) {
    msg <- sprintf(
      "%s() generic lacks `...` so method formals must match generic formals exactly.",
      generic@name
    )
    bullets <- c(
      sprintf("- generic formals: %s", show_args(generic_formals, name = generic@name)),
      sprintf("- method formals:  %s", show_args(method_formals, name = generic@name))
    )
    msg <- paste0(c(msg, bullets), collapse = "\n")
    stop(msg, call. = FALSE)
  }

  n_dispatch <- length(generic@dispatch_args)
  has_dispatch <- length(method_formals) >= n_dispatch &&
    identical(method_args[1:n_dispatch], generic@dispatch_args)
  if (!has_dispatch) {
    msg <- sprintf(
      "%s() dispatches on %s, but %s has arguments %s",
      generic@name,
      arg_names(generic@dispatch_args),
      name,
      arg_names(method_args)
    )
    stop(msg, call. = FALSE)
  }

  empty_dispatch <- vlapply(method_formals[generic@dispatch_args], identical, quote(expr = ))
  if (any(!empty_dispatch)) {
    msg <- sprintf(
      "In %s, dispatch arguments (%s) must not have default values",
      name,
      arg_names(generic@dispatch_args)
    )
    stop(msg, call. = FALSE)
  }

  extra_args <- setdiff(names(generic_formals), c(generic@dispatch_args, "..."))
  for (arg in extra_args) {
    if (!arg %in% method_args) {
      warning(sprintf("%s doesn't have argument `%s`", name, arg), call. = FALSE)
    } else if (!identical(generic_formals[[arg]], method_formals[[arg]])) {
      msg <- sprintf(
        paste0(
          "In %s, default value of `%s` is not the same as the generic\n",
          "- Generic: %s\n",
          "- Method:  %s"
        ),
        name,
        arg,
        deparse1(generic_formals[[arg]]),
        deparse1(method_formals[[arg]])
      )
      warning(msg, call. = FALSE)
    }
  }

  invisible(TRUE)
}

register_S4_method <- function(generic, signature, method, env = parent.frame()) {
  S4_env <- topenv(env)
  S4_signature <- lapply(signature, S4_class, S4_env = S4_env)
  methods::setMethod(generic, S4_signature, method, where = S4_env)
}
S4_class <- function(x, S4_env) {
  if (is_base_class(x)) {
    x@name
  } else if (is_S4_class(x)) {
    x
  } else if (is_class(x) || is_S3_class(x)) {
    class <- tryCatch(methods::getClass(class_register(x)), error = function(err) NULL)
    if (is.null(class)) {
      msg <- sprintf(
        "Class has not been registered with S4; please call S4_register(%s)",
        class_deparse(x)
      )
      stop(msg, call. = FALSE)
    }
    class
  } else {
    stop("Unsupported")
  }
}

#' @export
print.S7_method <- function(x, ...) {
  signature <- method_signature(x@generic, x@signature)
  cat("<S7_method> ", signature, "\n", sep = "")

  attributes(x) <- NULL
  print(x)
}

arg_names <- function(x) {
  paste0(encodeString(x, quote = "`"), collapse = ", ")
}

method_name <- function(generic, signature) {
  method_args <- paste0(vcapply(signature, class_desc), collapse =", ")
  sprintf("%s(%s)", generic@name, method_args)
}

---
title: "Performance"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Performance}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
library(S7)
```

The dispatch performance should be roughly on par with S3 and S4, though as this is implemented in a package there is some overhead due to `.Call` vs `.Primitive`.

```{r performance, cache = FALSE}
Text <- new_class("Text", parent = class_character)
Number <- new_class("Number", parent = class_double)

x <- Text("hi")
y <- Number(1)

foo_S7 <- new_generic("foo_S7", "x")
method(foo_S7, Text) <- function(x, ...) paste0(x, "-foo")

foo_S3 <- function(x, ...) {
  UseMethod("foo_S3")
}

foo_S3.Text <- function(x, ...) {
  paste0(x, "-foo")
}

library(methods)
setOldClass(c("Number", "numeric", "S7_object"))
setOldClass(c("Text", "character", "S7_object"))

setGeneric("foo_S4", function(x, ...) standardGeneric("foo_S4"))
setMethod("foo_S4", c("Text"), function(x, ...) paste0(x, "-foo"))

# Measure performance of single dispatch
bench::mark(foo_S7(x), foo_S3(x), foo_S4(x))

bar_S7 <- new_generic("bar_S7", c("x", "y"))
method(bar_S7, list(Text, Number)) <- function(x, y, ...) paste0(x, "-", y, "-bar")

setGeneric("bar_S4", function(x, y, ...) standardGeneric("bar_S4"))
setMethod("bar_S4", c("Text", "Number"), function(x, y, ...) paste0(x, "-", y, "-bar"))

# Measure performance of double dispatch
bench::mark(bar_S7(x, y), bar_S4(x, y))
```

A potential optimization is caching based on the class names, but lookup should be fast without this.

The following benchmark generates a class hierarchy of different levels and lengths of class names and compares the time to dispatch on the first class in the hierarchy vs the time to dispatch on the last class.

We find that even in very extreme cases (e.g. 100 deep hierarchy 100 of character class names) the overhead is reasonable, and for more reasonable cases (e.g. 10 deep hierarchy of 15 character class names) the overhead is basically negligible.

```{r performance-2, message = FALSE, R.options = list(width = 120), cache = TRUE}
library(S7)

gen_character <- function (n, min = 5, max = 25, values = c(letters, LETTERS, 0:9)) {
  lengths <- sample(min:max, replace = TRUE, size = n)
  values <- sample(values, sum(lengths), replace = TRUE)
  starts <- c(1, cumsum(lengths)[-n] + 1)
  ends <- cumsum(lengths)
  mapply(function(start, end) paste0(values[start:end], collapse=""), starts, ends)
}

bench::press(
  num_classes = c(3, 5, 10, 50, 100),
  class_nchar = c(15, 100),
  {
    # Construct a class hierarchy with that number of classes
    Text <- new_class("Text", parent = class_character)
    parent <- Text
    classes <- gen_character(num_classes, min = class_nchar, max = class_nchar)
    env <- new.env()
    for (x in classes) {
      assign(x, new_class(x, parent = parent), env)
      parent <- get(x, env)
    }

    # Get the last defined class
    cls <- parent

    # Construct an object of that class
    x <- do.call(cls, list("hi"))

    # Define a generic and a method for the last class (best case scenario)
    foo_S7 <- new_generic("foo_S7", "x")
    method(foo_S7, cls) <- function(x, ...) paste0(x, "-foo")

    # Define a generic and a method for the first class (worst case scenario)
    foo2_S7 <- new_generic("foo2_S7", "x")
    method(foo2_S7, S7_object) <- function(x, ...) paste0(x, "-foo")

    bench::mark(
      best = foo_S7(x),
      worst = foo2_S7(x)
    )
  }
)
```

And the same benchmark using double-dispatch

```{r performance-3, message = FALSE, R.options = list(width = 120), cache = TRUE}
bench::press(
  num_classes = c(3, 5, 10, 50, 100),
  class_nchar = c(15, 100),
  {
    # Construct a class hierarchy with that number of classes
    Text <- new_class("Text", parent = class_character)
    parent <- Text
    classes <- gen_character(num_classes, min = class_nchar, max = class_nchar)
    env <- new.env()
    for (x in classes) {
      assign(x, new_class(x, parent = parent), env)
      parent <- get(x, env)
    }

    # Get the last defined class
    cls <- parent

    # Construct an object of that class
    x <- do.call(cls, list("hi"))
    y <- do.call(cls, list("ho"))

    # Define a generic and a method for the last class (best case scenario)
    foo_S7 <- new_generic("foo_S7", c("x", "y"))
    method(foo_S7, list(cls, cls)) <- function(x, y, ...) paste0(x, y, "-foo")

    # Define a generic and a method for the first class (worst case scenario)
    foo2_S7 <- new_generic("foo2_S7", c("x", "y"))
    method(foo2_S7, list(S7_object, S7_object)) <- function(x, y, ...) paste0(x, y, "-foo")

    bench::mark(
      best = foo_S7(x, y),
      worst = foo2_S7(x, y)
    )
  }
)
```

---
title: "S7 basics"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{S7 basics}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

The S7 package provides a new OOP system designed to be a successor to S3 and S4.
It has been designed and implemented collaboratively by the RConsortium Object-Oriented Programming Working Group, which includes representatives from R-Core, BioConductor, RStudio/tidyverse, and the wider R community.

This vignette gives an overview of the most important parts of S7: classes and objects, generics and methods, and the basics of method dispatch and inheritance.

```{r setup}
library(S7)
```

## Classes and objects

S7 classes have a formal definition that you create with `new_class()`.
There are two arguments that you'll use with almost every class:

-   The `name` of the class, supplied in the first argument.
-   The class `properties`, the data associated with each instance of the class. The easiest way to define properties is to supply a named list where the values define the valid types of the property.

The following code defines a simple `dog` class with two properties: a character `name` and a numeric `age`.

```{r}
Dog <- new_class("Dog", properties = list(
  name = class_character,
  age = class_numeric
))
Dog
```

S7 provides a number of built-in definitions that allow you to refer to existing base types that are not S7 classes.
You can recognize these definitions because they all start with `class_`.

Note that I've assigned the return value of `new_class()` to an object with the same name as the class.
This is important!
That object represents the class and is what you use to construct instances of the class:

```{r}
lola <- Dog(name = "Lola", age = 11)
lola
```

Once you have an S7 object, you can get and set properties using `@`:

```{r}
lola@age <- 12
lola@age
```

S7 automatically validates the type of the property using the type supplied in `new_class()`:

```{r, error = TRUE}
lola@age <- "twelve"
```

Given an object, you can retrieve its class `S7_class()`:

```{r}
S7_class(lola)
```

S7 objects also have an S3 `class()`.
This is used for compatibility with existing S3 generics and you can learn more about it in `vignette("compatibility")`.

```{r}
class(lola)
```

If you want to learn more about the details of S7 classes and objects, including validation methods and more details of properties, please see `vignette("classes-objects")`.

## Generics and methods

S7, like S3 and S4, is built around the idea of **generic functions,** or **generics** for short.
A generic defines an interface, which uses a different implementation depending on the class of one or more arguments.
The implementation for a specific class is called a **method**, and the generic finds that appropriate method by performing **method dispatch**.

Use `new_generic()` to create a S7 generic.
In its simplest form, it only needs two arguments: the name of the generic (used in error messages) and the name of the argument used for method dispatch:

```{r}
speak <- new_generic("speak", "x")
```

Like with `new_class()`, you should always assign the result of `new_generic()` to a variable with the same name as the first argument.

Once you have a generic, you can register methods for specific classes with `method(generic, class) <- implementation`.

```{r}
method(speak, Dog) <- function(x) {
  "Woof"
}
```

Once the method is registered, the generic will use it when appropriate:

```{r}
speak(lola)
```

Let's define another class, this one for cats, and define another method for `speak()`:

```{r}
Cat <- new_class("Cat", properties = list(
  name = class_character,
  age = class_double
))
method(speak, Cat) <- function(x) {
  "Meow"
}

fluffy <- Cat(name = "Fluffy", age = 5)
speak(fluffy)
```

You get an error if you call the generic with a class that doesn't have a method:

```{r, error = TRUE}
speak(1)
```

## Method dispatch and inheritance

The `cat` and `dog` classes share the same properties, so we could use a common parent class to extract out the duplicated specification.
We first define the parent class:

```{r}
Pet <- new_class("Pet",
  properties = list(
    name = class_character,
    age = class_numeric
  )
)
```

Then use the `parent` argument to `new_class:`

```{r}
Cat <- new_class("Cat", parent = Pet)
Dog <- new_class("Dog", parent = Pet)

Cat
Dog
```

Because we have created new classes, we need to recreate the existing `lola` and `fluffy` objects:

```{r}
lola <- Dog(name = "Lola", age = 11)
fluffy <- Cat(name = "Fluffy", age = 5)
```

Method dispatch takes advantage of the hierarchy of parent classes: if a method is not defined for a class, it will try the method for the parent class, and so on until it finds a method or gives up with an error.
This inheritance is a powerful mechanism for sharing code across classes.

```{r}
describe <- new_generic("describe", "x")
method(describe, Pet) <- function(x) {
  paste0(x@name, " is ", x@age, " years old")
}
describe(lola)
describe(fluffy)

method(describe, Dog) <- function(x) {
  paste0(x@name, " is a ", x@age, " year old dog")
}
describe(lola)
describe(fluffy)
```

You can define a fallback method for any S7 object by registering a method for `S7_object`:

```{r}
method(describe, S7_object) <- function(x) {
  "An S7 object"
}

Cocktail <- new_class("Cocktail",
  properties = list(
    ingredients = class_character
  )
)
martini <- Cocktail(ingredients = c("gin", "vermouth"))
describe(martini)
```

Printing a generic will show you which methods are currently defined:

```{r}
describe
```

And you can use `method()` to retrieve the implementation of one of those methods:

```{r}
method(describe, Pet)
```

Learn more about method dispatch in `vignette("generics-methods")`.

---
title: "S7 basics"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{S7 basics}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

The S7 package provides a new OOP system designed to be a successor to S3 and S4.
It has been designed and implemented collaboratively by the RConsortium Object-Oriented Programming Working Group, which includes representatives from R-Core, BioConductor, RStudio/tidyverse, and the wider R community.

This vignette gives an overview of the most important parts of S7: classes and objects, generics and methods, and the basics of method dispatch and inheritance.

```{r setup}
library(S7)
```

## Classes and objects

S7 classes have a formal definition that you create with `new_class()`.
There are two arguments that you'll use with almost every class:

-   The `name` of the class, supplied in the first argument.
-   The class `properties`, the data associated with each instance of the class. The easiest way to define properties is to supply a named list where the values define the valid types of the property.

The following code defines a simple `dog` class with two properties: a character `name` and a numeric `age`.

```{r}
Dog <- new_class("Dog", properties = list(
  name = class_character,
  age = class_numeric
))
Dog
```

S7 provides a number of built-in definitions that allow you to refer to existing base types that are not S7 classes.
You can recognize these definitions because they all start with `class_`.

Note that I've assigned the return value of `new_class()` to an object with the same name as the class.
This is important!
That object represents the class and is what you use to construct instances of the class:

```{r}
lola <- Dog(name = "Lola", age = 11)
lola
```

Once you have an S7 object, you can get and set properties using `@`:

```{r}
lola@age <- 12
lola@age
```

S7 automatically validates the type of the property using the type supplied in `new_class()`:

```{r, error = TRUE}
lola@age <- "twelve"
```

Given an object, you can retrieves its class `S7_class()`:

```{r}
S7_class(lola)
```

S7 objects also have an S3 `class()`.
This is used for compatibility with existing S3 generics and you can learn more about it in `vignette("compatibility")`.

```{r}
class(lola)
```

If you want to learn more about the details of S7 classes and objects, including validation methods and more details of properties, please see `vignette("classes-objects")`.

## Generics and methods

S7, like S3 and S4, is built around the idea of **generic functions,** or **generics** for short.
A generic defines an interface, which uses a different implementation depending on the class of one or more arguments.
The implementation for a specific class is called a **method**, and the generic finds that appropriate method by performing **method dispatch**.

Use `new_generic()` to create a S7 generic.
In its simplest form, it only needs two arguments: the name of the generic (used in error messages) and the name of the argument used for method dispatch:

```{r}
speak <- new_generic("speak", "x")
```

Like with `new_class()`, you should always assign the result of `new_generic()` to a variable with the same name as the first argument.

Once you have a generic, you can register methods for specific classes with `method(generic, class) <- implementation`.

```{r}
method(speak, Dog) <- function(x) {
  "Woof"
}
```

Once the method is registered, the generic will use it when appropriate:

```{r}
speak(lola)
```

Let's define another class, this one for cats, and define another method for `speak()`:

```{r}
Cat <- new_class("Cat", properties = list(
  name = class_character,
  age = class_double
))
method(speak, Cat) <- function(x) {
  "Meow"
}

fluffy <- Cat(name = "Fluffy", age = 5)
speak(fluffy)
```

You get an error if you call the generic with a class that doesn't have a method:

```{r, error = TRUE}
speak(1)
```

## Method dispatch and inheritance

The `cat` and `dog` classes share the same properties, so we could use a common parent class to extract out the duplicated specification.
We first define the parent class:

```{r}
Pet <- new_class("Pet",
  properties = list(
    name = class_character,
    age = class_numeric
  )
)
```

Then use the `parent` argument to `new_class:`

```{r}
Cat <- new_class("Cat", parent = Pet)
Dog <- new_class("Dog", parent = Pet)

Cat
Dog
```

Because we have created new classes, we need to recreate the existing `lola` and `fluffy` objects:

```{r}
lola <- Dog(name = "Lola", age = 11)
fluffy <- Cat(name = "Fluffy", age = 5)
```

Method dispatch takes advantage of the hierarchy of parent classes: if a method is not defined for a class, it will try the method for the parent class, and so on until it finds a method or gives up with an error.
This inheritance is a powerful mechanism for sharing code across classes.

```{r}
describe <- new_generic("describe", "x")
method(describe, Pet) <- function(x) {
  paste0(x@name, " is ", x@age, " years old")
}
describe(lola)
describe(fluffy)

method(describe, Dog) <- function(x) {
  paste0(x@name, " is a ", x@age, " year old dog")
}
describe(lola)
describe(fluffy)
```

You can define a fallback method for any S7 object by registering a method for `S7_object`:

```{r}
method(describe, S7_object) <- function(x) {
  "An S7 object"
}

Cocktail <- new_class("Cocktail",
  properties = list(
    ingredients = class_character
  )
)
martini <- Cocktail(ingredients = c("gin", "vermouth"))
describe(martini)
```

Printing a generic will show you which methods are currently defined:

```{r}
describe
```

And you can use `method()` to retrieve the implementation of one of those methods:

```{r}
method(describe, Pet)
```

Learn more about method dispatch in `vignette("generics-methods")`.

---
title: "Generics and methods"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Generics and methods}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

This vignette dives into the details of S7 generics and method dispatch, building on the basics discussed in `vignette("S7")`.
We'll first introduce the concept of generic-method compatibility, then discuss some of the finer details of creating a generic with `new_generic()`.
This vignette first discusses generic-method compatibility, and you might want to customize the body of the generic, and generics that live in suggested packages.
We'll then pivot to talk more details of method dispatch including `super()` and multiple dispatch.

```{r setup}
library(S7)
```

## Generic-method compatibility

When you register a method, S7 checks that your method is compatible with the generic.

The formal arguments of the generic and methods must agree.
This means that:

-   Any arguments that the generic has, the method must have too. In particular, the arguments of the method start with the arguments that the generic dispatches on, and those arguments must not have default arguments.
-   The method can contain arguments that the generic does not, as long as the generic includes `…` in the argument list.

### Generic with dots; method without dots

The default generic includes `…` but generally the methods should not.
That ensures that misspelled arguments won't be silently swallowed by the method.
This is an important difference from S3.
Take a very simple implementation of `mean()`:

```{r}
mean <- new_generic("mean", "x")
method(mean, class_numeric) <- function(x) sum(x) / length(x)
```

If we pass an additional argument in, we'll get an error:

```{r, error = TRUE, eval = FALSE}
mean(100, na.rm = TRUE)
```

But we can still add additional arguments if we desired:

```{r}
method(mean, class_numeric) <- function(x, na.rm = TRUE) {
  if (na.rm) {
    x <- x[!is.na(x)]
  }

  sum(x) / length(x)
}
mean(c(100, NA), na.rm = TRUE)
```

(We'll come back to the case of requiring that all methods implement a `na.rm = TRUE` argument shortly.)

### Generic and method with dots

There are cases where you do need to take `…` in a method, which is particularly problematic if you need to re-call the generic recursively.
For example, imagine a simple print method like this:

```{r}
simple_print <- new_generic("simple_print", "x")
method(simple_print, class_double) <- function(x, digits = 3) {}
method(simple_print, class_character) <- function(x, max_length = 100) {}
```

What if you want to print a list?

```{r}
method(simple_print, class_list) <- function(x, ...) {
  for (el in x) {
    simple_print(el, ...)
  }
}
```

It's fine as long as all the elements of the list are numbers, but as soon as we add a character vector, we get an error:

```{r, error = TRUE, eval = FALSE}
simple_print(list(1, 2, 3), digits = 3)
simple_print(list(1, 2, "x"), digits = 3)
```

To solve this situation, methods generally need to ignore arguments that they haven't been specifically designed to handle, i.e. they need to use `…`:

```{r}
method(simple_print, class_double) <- function(x, ..., digits = 3) {}
method(simple_print, class_character) <- function(x, ..., max_length = 100) {}

simple_print(list(1, 2, "x"), digits = 3)
```

In this case we really do want to silently ignore unknown arguments because they might apply to other methods.
There's unfortunately no easy way to avoid this problem without relying on fairly esoteric technology (as done by `rlang::check_dots_used()`).

```{r}
simple_print(list(1, 2, "x"), diggits = 3)
```

### Generic and method without dots

Occasional it's useful to create a generic without `…` because such functions have a useful property: if a call succeeds for one type of input, it will succeed for any type of input.
To create such a generic, you'll need to use the third argument to `new_generic()`: an optional function that powers the generic.
This function has one key property: it must call `S7_dispatch()` to actually perform dispatch.

In general, this property is only needed for very low-level functions with precisely defined semantics.
A good example of such a function is `length()`:

```{r, eval = FALSE}
length <- new_generic("length", "x", function(x) {
  S7_dispatch()
})
```

Omitting `…` from the generic signature is a strong restriction as it prevents methods from adding extra arguments.
For this reason, it should only be used in special situations.

## Customizing generics

In most cases, you'll supply the first two arguments to `new_generic()` and allow it to automatically generate the body of the generic:

```{r}
display <- new_generic("display", "x")
S7_data(display)
```

The most important part of the body is `S7_dispatch()`; this function finds the method that matches the arguments used for dispatch and calls it with the arguments supplied to the generic.

It can be useful to customize this body.
The previous section showed one case when you might want to supply the body yourself: dropping `…` from the formals of the generic.
There are three other useful cases:

-   To add required arguments.
-   To add optional arguments.
-   Perform some standard work.

A custom `fun` must always include a call to `S7_dispatch()`, which will usually be the last call.

### Add required arguments

To add required arguments that aren't dispatched upon, you just need to add additional arguments that lack default values:

```{r}
foo <- new_generic("foo", "x", function(x, y, ...) {
  S7_dispatch()
})
```

Now all methods will need to provide that `y` argument.
If not, you'll get a warning:

```{r}
method(foo, class_integer) <- function(x, ...) {
  10
}
```

This is a warning, not an error, because the generic might be defined in a different package and is in the process of changing interfaces.
You'll always want to address this warning when you see it.

### Add optional arguments

Adding an optional argument is similar, but it should generally come after `…`.
This ensures that the user must supply the full name of the argument when calling the function, which makes it easier to extend your function in the future.

```{r}
mean <- new_generic("mean", "x", function(x, ..., na.rm = TRUE) {
  S7_dispatch()
})
method(mean, class_integer) <- function(x, na.rm = TRUE) {
  if (na.rm) {
    x <- x[!is.na(x)]
  }
  sum(x) / length(x)
}
```

Forgetting the argument or using a different default value will again generate a warning.

```{r}
method(mean, class_double) <- function(x, na.rm = FALSE) {}
method(mean, class_logical) <- function(x) {}
```

### Do some work

If your generic has additional arguments, you might want to do some additional work to verify that they're of the expected type.
For example, our `mean()` function could verify that `na.rm` was correctly specified:

```{r}
mean <- new_generic("mean", "x", function(x, ..., na.rm = TRUE) {
  if (!identical(na.rm, TRUE) && !identical(na.rm = FALSE)) {
    stop("`na.rm` must be either TRUE or FALSE")
  }
  S7_dispatch()
})
```

The only downside to performing error checking is that you constraint the interface for all methods; if for some reason a method found it useful to allow `na.rm` to be a number or a string, it would have to provide an alternative argument.

## `super()`

Sometimes it's useful to define a method for a class that relies on the implementation for its superclass.
A good example of this is computing the mean of a date --- since dates represent the number of days since 1970-01-01, computing the mean is just a matter of computing the mean of the underlying numeric vector and converting it back to a date.

To demonstrate this idea, I'll first define a mean generic with a method for numbers:

```{r}
mean <- new_generic("mean", "x")
method(mean, class_numeric) <- function(x) {
  sum(x) / length(x)
}
mean(1:10)
```

And a Date class:

```{r}
date <- new_class("date", parent = class_double)
# Cheat by using the existing base .Date class
method(print, date) <- function(x) print(.Date(x))
date(c(1, 10, 100))
```

Now to compute a mean we write:

```{r}
method(mean, date) <- function(x) {
  date(mean(super(x, to = class_double)))
}
mean(date(c(1, 10, 100)))
```

Let's unpack this method from the inside out:

1.  First we call `super(x, to = class_double)` --- this will make the call to next generic treat `x` like it's a double, rather than a date.
2.  Then we call `mean()` which because of `super()` will call the `mean()` method we defined above.
3.  Finally, we take the number returned by mean and convert it back to a date.

If you're very familiar with S3 or S4 you might recognize that `super()` fills a similar role to `NextMethod()` or `callNextMethod()`.
However, it's much more explicit: you need to supply the name of the parent class, the generic to use, and all the arguments to the generic.
This explicitness makes the code easier to understand and will eventually enable certain performance optimizations that would otherwise be very difficult.

## Multiple dispatch

So far we have focused primarily on single dispatch, i.e. generics where `dispatch_args` is a single string.
It is also possible to supply a length 2 (or more!) vector `dispatch_args` to create a generic that performs multiple dispatch, i.e. it uses the classes of more than one object to find the appropriate method.

Multiple dispatch is a feature primarily of S4, although S3 includes some limited special cases for arithmetic operators.
Multiple dispatch is heavily used in S4; we don't expect it to be heavily used in S7, but it is occasionally useful.

### A simple example

Let's take our speak example from `vignette("S7")` and extend it to teach our pets how to speak multiple languages:

```{r}
Pet <- new_class("Pet")
Dog <- new_class("Dog", Pet)
Cat <- new_class("Cat", Pet)

Language <- new_class("Language")
English <- new_class("English", Language)
French <- new_class("French", Language)

speak <- new_generic("speak", c("x", "y"))
method(speak, list(Dog, English)) <- function(x, y) "Woof"
method(speak, list(Cat, English)) <- function(x, y) "Meow"
method(speak, list(Dog, French)) <- function(x, y) "Ouaf Ouaf"
method(speak, list(Cat, French)) <- function(x, y) "Miaou"

speak(Cat(), English())
speak(Dog(), French())

# This example was originally inspired by blog.klipse.tech/javascript/2021/10/03/multimethod.html
# which has unfortunately since disappeared.
```

### Special "classes"

There are two special classes that become particularly useful with multiple dispatch:

-   `class_any()` will match any class
-   `class_missing()` will match a missing argument (i.e. not `NA`, but an argument that was not supplied)

---
title: "Compatibility with S3 and S4"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Compatibility with S3 and S4}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

S7 is designed to be compatible with S3 and S4.
This vignette discusses the details.

```{r setup}
library(S7)
```

## S3

S7 objects *are* S3 objects, because S7 is implemented on top of S3.
There are two main differences between an S7 object and an S3 object:

-   As well as the `class` attribute possessed by S3 objects, S7 objects have an additional `S7_class` attribute that contains the object that defines the class.

-   S7 objects have properties; S3 objects have attributes.
    Properties are implemented on top of attributes, so you can access them directly with `attr` and friends.
    When working inside of S7, you should never use attributes directly, but it does mean that existing code will continue to work.

All up, this means most usage of S7 with S3 will just work.

-   S7 can register methods for:

    -   S7 class and S3 generic
    -   S3 class and S7 generic

-   S7 classes can extend S3 classes

-   S3 classes can extend S7 classes

### Methods

`method()` is designed to be the single tool for method registration that you need when working with S7 classes.
You can also register a method for an S7 class and S3 generic without using S7, because all S7 objects have S3 classes, and S3 dispatch will operate on them normally.

```{r}
Foo <- new_class("Foo")
class(Foo())

mean.Foo <- function(x, ...) {
  "mean of foo"
}

mean(Foo())
```

### Classes

It's possible to extend an S7 class with S3.
This is primarily useful because in many cases it allows you to change a class hierarchy from the inside out: you can provide a formal definition of an S3 class using S7, and its subclasses don't need to change.

### List classes

Many simple S3 classes are implemented as lists, e.g. rle.

```{r}
rle <- function(x) {
  if (!is.vector(x) && !is.list(x)) {
    stop("'x' must be a vector of an atomic type")
  }
  n <- length(x)
  if (n == 0L) {
    new_rle(integer(), x)
  } else {
    y <- x[-1L] != x[-n]
    i <- c(which(y | is.na(y)), n)
    new_rle(diff(c(0L, i)), x[i])
  }
}
new_rle <- function(lengths, values) {
  structure(
    list(
      lengths = lengths,
      values = values
    ),
    class = "rle"
  )
}
```

There are two ways to convert this to S7.
You could keep the structure exactly the same, using a `list` as the underlying data structure and using a constructor to enforce the structure:

```{r}
new_rle <- new_class("rle",
  parent = class_list,
  constructor = function(lengths, values) {
    new_object(list(lengths = lengths, values = values))
  }
)
rle(1:10)
```

Alternatively you could convert it to the most natural representation using S7:

```{r}
new_rle <- new_class("rle", properties = list(
  lengths = class_integer,
  values = class_atomic
))
```

To allow existing methods to work you'll need to override `$` to access properties instead of list elements:

```{r}
method(`$`, new_rle) <- prop
rle(1:10)
```

The chief disadvantage of this approach is any subclasses will need to be converted to S7 as well.

## S4

S7 properties are equivalent to S4 slots.
The chief difference is that they can be dynamic.

-   S7 classes can not extend S4 classes
-   S4 classes can extend S3 classes
-   S7 can register methods for:
    -   S7 class and S4 generic
    -   S4 class and S7 generic

### Unions

S4 unions are automatically converted to S7 unions.
There's an important difference in the way that class unions are handled in S4 and S7.
In S4, they're handled at method dispatch time, so when you create `setUnion("u1", c("class1", "class2"))`, `class1` and `class2` now extend `u1`.
In S7, unions are handled at method registration time so that registering a method for a union is just short-hand for registering a method for each of the classes.

```{r}
Class1 <- new_class("Class1")
Class2 <- new_class("Class2")
Union1 <- new_union(Class1, Class2)

foo <- new_generic("foo", "x")
method(foo, Union1) <- function(x) ""
foo
```

S7 unions allow you to restrict the type of a property in the same way that S4 unions allow you to restrict the type of a slot.

---
title: "Minutes 2022-02-12"
---

## Process check-in

Minor stuff I'm just doing.
Bigger changes I get Davis to review.
No semantic changes without discussion in issues

## Changes

-   Non S7 classes
    -   `as_class()` centralises all handling of classes (base types, S3, S4, and S7)
    -   Strings now only refer to base types (previously used for S3 + S7 class in parent frame) `new_class( parent = "function")`
    -   Numeric, atomic, and vector "types" as S7 unions.
        -   Should we provide some wrappers to base unions and consider if we could get rid of string representation altogether? (e.g. `base_atomic`)
    -   New `s3_class()` to define S3 classes.
        -   <https://github.com/RConsortium/S7/pull/148> makes it possible for S7 class to extend an S3 class
        -   Should we export the S3 class definitions for common base S3 classes? And then provide with `base_factor` etc.
    -   S4 unions converted to S7 unions
-   Method registration
    -   Clarify difference between registration and dispatch. Will flow into refactoring of C code in near future.
    -   Dispatch is base/S3/S4/S7 class with S7 generic.
    -   Registration is base/S3/S4/S7 class with S7 generic AND S7 class with S3/S4 generic.
    -   All combinations now tested.
    -   Thorough refactoring of method registration
-   Method dispatch
    -   In generic, `signature` -> `dispatch_args`.
    -   Simplified evaluation and restricted dispatch args (probably too much, but we relax as needed)
    -   Should we provide a default dispatch argument name? `x`
-   Validation
    -   Validate types, then call `validator()`
    -   Also call `validator()` for all super classes
    -   New `props<-` for multi-assignment. Only validates at end.
-   General QoL improvements to `print()` and `str()` methods

## Next up

-   Refactor method dispatch
-   Defaults for properties, to get to point where `constructor()` without any argument usually works
-   Dispatch on Missing/Any
-   Coercion (`cast()`)
-   Eliminate `next_method()` (`up_cast()`)
-   Documentation

## Discussion

-   Speak about at rstudio::conf or useR?
    -   Still need a real world application

    -   Hadley to submit proposals to useR + rstudio::conf; and determine speakers and topics closer to the time

    -   Next time we meet, we should discuss other ways to advertise
-   Ok to rename default branch from master to main? \~5 minutes work and unlikely to cause any problems.
-   Ok to eliminate `prop_safely()`? <https://github.com/RConsortium/S7/issues/156>
-   Convention for displaying class names: <https://github.com/RConsortium/S7/issues/133> / <https://github.com/RConsortium/S7/pull/161>
    -   Only show for S3/S4
-   Name of sentinel for missing/any dispatch: <https://github.com/RConsortium/S7/issues/67>
    -   `_arg` looks good
-   Coercion: <https://github.com/RConsortium/S7/issues/136>

---
title: "Minutes 2021-05-18"
---

**Present**: Michael Lawrence (chair), Hong Ooi, Luke Tierney, Hadley Wickham, Will Landau, Henrik Bengtsson

## Discussion

### Process (ML)

-   Active discussion in GitHub issues: <https://github.com/RConsortium/S7>

-   Need a little process to finalise discussion. Proposal: original author reads discussion, summarises, and creates a pull request that closes the issue. Any participants in the discussion should be added as reviewers.

-   Once issues are resolved, we can start to move forward on next steps for syntax, implementation, ...

### Do you have a sense for what the system might look like? (HB)

-   Unfortunately don't have a lot of time, but reading and happy to review. how much of an implementation do you have in your head?
-   **ML**: Quite a bit; but wanted to make sure to step back and make sure we have all the requirements. But yes, have some vision in my head.
-   **HW**: Have some clear idea in my head; mostly building on top of S3

### Would it look more like S3, S4, or something completely new? (HB)

-   **ML**: one of the main restrictions is to build off existing system
-   **HW**: one of the advantages is NAMESPACE
-   **ML**: and that base uses
-   **LT**: want to be able to define new methods for "[", which means has to be maximally compatible with base.

### Double dispatch (HW/LT)

-   **LT**: no double dispatch in S3. S4 overly ambitious and v hard to maintain. CLOS written be v. smart people and still got things wrong.
-   **HW**: may need to carve double dispatch into v2.
-   **HO**: multiple inheritance is falling out of favour (diamond inheritance problem etc). Could we use interface based approach instead?

### Generic "interfaces" (LT)

-   **LT**: need to consider not just generics by themselves, but how they are related.
-   Related to contracts in Eiffel, concepts in C++20, \...

### Message passing OOP (HO)

-   **HO**: should we be considering this? (i.e. R6 and ref classes)
-   **ML**: currently out of scope

### What are the implications for compiling? (HB)

-   **LT:** compiling currently entirely within functions; one day might be nice to compile across functions/methods etc. Always thinking about how compilation might work. But generally features that are hard to compile are hard for users to understand.

## Action items

-   Continue discussion in issues
-   Start turning issues into PRs
-   Feel free to fix minor issues

---
title: "Classes and objects"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Classes and objects}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

This vignette dives into the details of S7 classes and objects, building on the basics discussed in `vignette("S7")`.
It will cover validators, the finer details of properties, and finally how to write your own constructors.

```{r setup}
library(S7)
```

## Validation

S7 classes can have an optional **validator** that checks that the values of the properties are OK.
A validator is a function that takes the object (called `self`) and returns `NULL` if it's valid or returns a character vector listing the problems.

### Basics

In the following example we create a `Range` class that enforces that `@start` and `@end` are single numbers, and that `@start` is less than `@end`:

```{r}
Range <- new_class("Range",
  properties = list(
    start = class_double,
    end = class_double
  ),
  validator = function(self) {
    if (length(self@start) != 1) {
      "@start must be length 1"
    } else if (length(self@end) != 1) {
      "@end must be length 1"
    } else if (self@end < self@start) {
      sprintf(
        "@end (%i) must be greater than or equal to @start (%i)",
        self@end,
        self@start
      )
    }
  }
)
```

You can typically write a validator as a series of `if`-`else` statements, but note that the order of the statements is important.
For example, in the code above, we can't check that `self@end < self@start` before we've checked that `@start` and `@end` are length 1.

As we'll discuss shortly, you can also perform validation on a per-property basis, so generally class validators should be reserved for interactions between properties.

### When is validation performed?

Objects are validated automatically when constructed and when any property is modified:

```{r, error = TRUE}
x <- Range(1, 2:3)
x <- Range(10, 1)

x <- Range(1, 10)
x@start <- 20
```

You can also manually `validate()` an object if you use a low-level R function to bypass the usual checks and balances of `@`:

```{r, error = TRUE}
x <- Range(1, 2)
attr(x, "start") <- 3
validate(x)
```

### Avoiding validation

Imagine you wanted to write a function that would shift a property to the left or the right:

```{r}
shift <- function(x, shift) {
  x@start <- x@start + shift
  x@end <- x@end + shift
  x
}
shift(Range(1, 10), 1)
```

There's a problem if `shift` is larger than `@end` - `@start`:

```{r, error = TRUE}
shift(Range(1, 10), 10)
```

While the end result of `shift()` will be valid, an intermediate state is not.
The easiest way to resolve this problem is to set the properties all at once:

```{r}
shift <- function(x, shift) {
  props(x) <- list(
    start = x@start + shift,
    end = x@end + shift
  )
  x
}
shift(Range(1, 10), 10)
```

The object is still validated, but it's only validated once, after all the properties have been modified.

## Properties

So far we've focused on the simplest form of property specification where you use a named list to supply the desired type for each property.
This is a convenient shorthand for a call to `new_property()`.
For example, the property definition of range above is shorthand for:

```{r}
Range <- new_class("Range",
  properties = list(
    start = new_property(class_double),
    end = new_property(class_double)
  )
)
```

Calling `new_property()` explicitly allows you to control aspects of the property other than its type.
The following sections show you how to add a validator, provide a default value, compute the property value on demand, or provide a fully dynamic property.

### Validation

You can optionally provide a validator for each property.
For example, instead of validating the length of `start` and `end` in the validator of our `Range` class, we could implement those at the property level:

```{r, error = TRUE}
prop_number <- new_property(
  class = class_double,
  validator = function(value) {
    if (length(value) != 1L) "must be length 1"
  }
)

Range <- new_class("Range",
  properties = list(
    start = prop_number,
    end = prop_number
  ),
  validator = function(self) {
    if (self@end < self@start) {
      sprintf(
        "@end (%i) must be greater than or equal to @start (%i)",
        self@end,
        self@start
      )
    }
  }
)

Range(start = c(1.5, 3.5))
Range(end = c(1.5, 3.5))
```

Note that property validators shouldn't include the name of the property in validation messages as S7 will add it automatically.
This makes it possible to use the same property definition for multiple properties of the same type, as above.

### Default value

The defaults of `new_class()` create a class that can be constructed with no arguments:

```{r}
Empty <- new_class("Empty",
  properties = list(
    x = class_double,
    y = class_character,
    z = class_logical
  ))
Empty()
```

The default values of the properties will be filled in with "empty" instances.
You can instead provide your own defaults by using the `default` argument:

```{r}
Empty <- new_class("Empty",
  properties = list(
    x = new_property(class_numeric, default = 0),
    y = new_property(class_character, default = ""),
    z = new_property(class_logical, default = NA)
  )
)
Empty()
```

A quoted call becomes a standard function promise in the default constructor, evaluated at the time the object is constructed.

```{r}
Stopwatch <- new_class("Stopwatch", properties = list(
  start_time = new_property(
    class = class_POSIXct,
    default = quote(Sys.time())
  ),
  elapsed = new_property(
    getter = function(self) {
      difftime(Sys.time(), self@start_time, units = "secs")
    }
  )
))
args(Stopwatch)
round(Stopwatch()@elapsed)
round(Stopwatch(Sys.time() - 1)@elapsed)
```

### Computed properties

It's sometimes useful to have a property that is computed on demand.
For example, it'd be convenient to pretend that our range has a length, which is just the distance between `@start` and `@end`.
You can dynamically compute the value of a property by defining a `getter`:

```{r}
Range <- new_class("Range",
  properties = list(
    start = class_double,
    end = class_double,
    length = new_property(
      getter = function(self) self@end - self@start
    )
  )
)

x <- Range(start = 1, end = 10)
x
```

Computed properties are read-only:

```{r, error = TRUE}
x@length <- 20
```

### Dynamic properties

You can make a computed property fully dynamic so that it can be read and written by also supplying a `setter`.

A `setter` is a function with arguments `self` and `value` that returns a modified object.

For example, we could extend the previous example to allow the `@length` to be set, by modifying the `@end` of the vector:

```{r}
Range <- new_class("Range",
  properties = list(
    start = class_double,
    end = class_double,
    length = new_property(
      class = class_double,
      getter = function(self) self@end - self@start,
      setter = function(self, value) {
        if (!length(value)) {
          # Do nothing if called with the constructor default
          # value for this property, a zero-length double vector.
          return(self)
        }
        self@end <- self@start + value
        self
      }
    )
  )
)

x <- Range(start = 1, end = 10)
x

x@length <- 5
x
```

### Common Patterns

`getter`, `setter`, `default`, and `validator` can be used to implement many common patterns of properties.

#### Deprecated properties

A `setter` + `getter` can be used to to deprecate a property:

```{r}
Person <- new_class("Person", properties = list(
 first_name = class_character,
 firstName = new_property(
    class_character,
    default = quote(first_name),
    getter = function(self) {
      warning("@firstName is deprecated; please use @first_name instead", call. = FALSE)
      self@first_name
    },
    setter = function(self, value) {
      if (identical(value, self@first_name)) {
        return(self)
      }
      warning("@firstName is deprecated; please use @first_name instead", call. = FALSE)
      self@first_name <- value
      self
    }
  )
))

args(Person)

hadley <- Person(firstName = "Hadley")

hadley <- Person(first_name = "Hadley") # no warning

hadley@firstName

hadley@firstName <- "John"

hadley@first_name  # no warning
```

#### Required properties

You can make a property required by the constructor either by:

-   relying on the validator to error with the default value, or by
-   setting the property default to a quoted error call.

```{r}
Person <- new_class("Person", properties = list(
 name = new_property(
   class_character,
   validator = function(value) {
     if (length(value) != 1 || is.na(value) || value == "")
       "must be a non-empty string"
   }
 )
))

try(Person())

try(Person(1)) # class_character$validator() is also checked.

Person("Alice")
```

```{r}
Person <- new_class("Person", properties = list(
 name = new_property(
   class_character,
   default = quote(stop("@name is required")))
))

try(Person())

Person("Alice")
```

#### Frozen properties

You can mark a property as read-only after construction by providing a custom `setter`.

```{r}
Person <- new_class("Person", properties = list(
 birth_date = new_property(
   class_Date,
   setter = function(self, value) {
     if(!is.null(self@birth_date)) {
       stop("@birth_date is read-only", call. = FALSE)
     }
     self@birth_date <- as.Date(value)
     self
   }
)))

person <- Person("1999-12-31")

try(person@birth_date <- "2000-01-01")
```

## Constructors

You can see the source code for a class's constructor by accessing the `constructor` property:

```{r}
Range@constructor
```

In most cases, S7's default constructor will be all you need.
However, in some cases you might want something custom.
For example, for our range class, maybe we'd like to construct it from a vector of numeric values, automatically computing the min and the max.
To implement this we could do:

```{r}
Range <- new_class("Range",
  properties = list(
    start = class_numeric,
    end = class_numeric
  ),
  constructor = function(x) {
    new_object(S7_object(),
               start = min(x, na.rm = TRUE),
               end = max(x, na.rm = TRUE))
  }
)

Range(c(10, 5, 0, 2, 5, 7))
```

A constructor must always end with a call to `new_object()`.
The first argument to `new_object()` should be an object of the `parent` class (if you haven't specified a `parent` argument to `new_class()`, then you should use `S7_object()` as the parent here).
That argument should be followed by one named argument for each property.

There's one drawback of custom constructors that you should be aware of: any subclass will also require a custom constructor.

---
title: "Generics and methods"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Generics and methods}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

This vignette dives into the details of S7 generics and method dispatch, building on the basics discussed in `vignette("S7")`.
We'll first introduce the concept of generic-method compatibility, then discuss some of the finer details of creating a generic with `new_generic()`.
This vignette first discusses generic-method compatibility, and you might want to customize the body of the generic, and generics that live in suggested packages.
We'll then pivot to talk more details of method dispatch including `super()` and multiple dispatch.

```{r setup}
library(S7)
```

## Generic-method compatibility

When you register a method, S7 checks that your method is compatible with the generic.

The formal arguments of the generic and methods must agree.
This means that:

-   Any arguments that the generic has, the method must have too. In particular, the arguments of the method start with the arguments that the generic dispatches on, and those arguments must not have default arguments.
-   The method can contain arguments that the generic does not, as long as the generic includes `…` in the argument list.

### Generic with dots; method without dots

The default generic includes `…` but generally the methods should not.
That ensures that misspelled arguments won't be silently swallowed by the method.
This is an important difference from S3.
Take a very simple implementation of `mean()`:

```{r}
mean <- new_generic("mean", "x")
method(mean, class_numeric) <- function(x) sum(x) / length(x)
```

If we pass an additional argument in, we'll get an error:

```{r, error = TRUE, eval = FALSE}
mean(100, na.rm = TRUE)
```

But we can still add additional arguments if we desired:

```{r}
method(mean, class_numeric) <- function(x, na.rm = TRUE) {
  if (na.rm) {
    x <- x[!is.na(x)]
  }

  sum(x) / length(x)
}
mean(c(100, NA), na.rm = TRUE)
```

(We'll come back to the case of requiring that all methods implement a `na.rm = TRUE` argument shortly.)

### Generic and method with dots

There are cases where you do need to take `…` in a method, which is particularly problematic if you need to re-call the generic recursively.
For example, imagine a simple print method like this:

```{r}
simple_print <- new_generic("simple_print", "x")
method(simple_print, class_double) <- function(x, digits = 3) {}
method(simple_print, class_character) <- function(x, max_length = 100) {}
```

What if you want to print a list?

```{r}
method(simple_print, class_list) <- function(x, ...) {
  for (el in x) {
    simple_print(el, ...)
  }
}
```

It's fine as long as all the elements of the list are numbers, but as soon as we add a character vector, we get an error:

```{r, error = TRUE, eval = FALSE}
simple_print(list(1, 2, 3), digits = 3)
simple_print(list(1, 2, "x"), digits = 3)
```

To solve this situation, methods generally need to ignore arguments that they haven't been specifically designed to handle, i.e. they need to use `…`:

```{r}
method(simple_print, class_double) <- function(x, ..., digits = 3) {}
method(simple_print, class_character) <- function(x, ..., max_length = 100) {}

simple_print(list(1, 2, "x"), digits = 3)
```

In this case we really do want to silently ignore unknown arguments because they might apply to other methods.
There's unfortunately no easy way to avoid this problem without relying on fairly esoteric technology (as done by `rlang::check_dots_used()`).

```{r}
simple_print(list(1, 2, "x"), diggits = 3)
```

### Generic and method without dots

Occasional it's useful to create a generic without `…` because such functions have a useful property: if a call succeeds for one type of input, it will succeed for any type of input.
To create such a generic, you'll need to use the third argument to `new_generic()`: an optional function that powers the generic.
This function has one key property: it must call `call_method()` to actually perform dispatch.

In general, this property is only needed for very low-level functions with precisely defined semantics.
A good example of such a function is `length()`:

```{r, eval = FALSE}
length <- new_generic("length", "x", function(x) {
  S7_dispatch()
})
```

Omitting `…` from the generic signature is a strong restriction as it prevents methods from adding extra arguments.
For this reason, it's should only be used in special situations.

## Customizing generics

In most cases, you'll supply the first two arguments to `new_generic()` and allow it to automatically generate the body of the generic:

```{r}
display <- new_generic("display", "x")
S7_data(display)
```

The most important part of the body is `S7_dispatch()`; this function finds the method the matches the arguments used for dispatch and calls it with the arguments supplied to the generic.

It can be useful to customize this body.
The previous section showed one case when you might want to supply the body yourself: dropping `…` from the formals of the generic.
There are three other useful cases:

-   To add required arguments.
-   To add optional arguments.
-   Perform some standard work.

A custom `fun` must always include a call to `call_method()`, which will usually be the last call.

### Add required arguments

To add required arguments that aren't dispatched upon, you just need to add additional arguments that lack default values:

```{r}
foo <- new_generic("foo", "x", function(x, y, ...) {
  S7_dispatch()
})
```

Now all methods will need to provide that `y` argument.
If not, you'll get a warning:

```{r}
method(foo, class_integer) <- function(x, ...) {
  10
}
```

This is a warning, not an error, because the generic might be defined in a different package and is in the process of changing interfaces.
You'll always want to address this warning when you see it.

### Add optional arguments

Adding an optional argument is similar, but it should generally come after `…`.
This ensures that the user must supply the full name of the argument when calling the function, which makes it easier to extend your function in the future.

```{r}
mean <- new_generic("mean", "x", function(x, ..., na.rm = TRUE) {
  S7_dispatch()
})
method(mean, class_integer) <- function(x, na.rm = TRUE) {
  if (na.rm) {
    x <- x[!is.na(x)]
  }
  sum(x) / length(x)
}
```

Forgetting the argument or using a different default value will again generate a warning.

```{r}
method(mean, class_double) <- function(x, na.rm = FALSE) {}
method(mean, class_logical) <- function(x) {}
```

### Do some work

If your generic has additional arguments, you might want to do some additional work to verify that they're of the expected type.
For example, our `mean()` function could verify that `na.rm` was correctly specified:

```{r}
mean <- new_generic("mean", "x", function(x, ..., na.rm = TRUE) {
  if (!identical(na.rm, TRUE) && !identical(na.rm = FALSE)) {
    stop("`na.rm` must be either TRUE or FALSE")
  }
  S7_dispatch()
})
```

The only downside to performing error checking is that you constraint the interface for all methods; if for some reason a method found it useful to allow `na.rm` to be a number or a string, it would have to provide an alternative argument.

## `super()`

Sometimes it's useful to define a method for in terms of its superclass.
A good example of this is computing the mean of a date --- since dates represent the number of days since 1970-01-01, computing the mean is just a matter of computing the mean of the underlying numeric vector and converting it back to a date.

To demonstrate this idea, I'll first define a mean generic with a method for numbers:

```{r}
mean <- new_generic("mean", "x")
method(mean, class_numeric) <- function(x) {
  sum(x) / length(x)
}
mean(1:10)
```

And a Date class:

```{r}
date <- new_class("date", parent = class_double)
# Cheat by using the existing base .Date class
method(print, date) <- function(x) print(.Date(x))
date(c(1, 10, 100))
```

Now to compute a mean we write:

```{r}
method(mean, date) <- function(x) {
  date(mean(super(x, to = class_double)))
}
mean(date(c(1, 10, 100)))
```

Let's unpack this method from the inside out:

1.  First we call `super(x, to = class_double)` --- this will make the call to next generic treat `x` like it's a double, rather than a date.
2.  Then we call `mean()` which because of `super()` will call the `mean()` method we defined above.
3.  Finally, we take the number returned by mean and convert it back to a date.

If you're very familiar with S3 or S4 you might recognize that `super()` fills a similar role to `NextMethod()` or `callNextMethod()`.
However, it's much more explicit: you need to supply the name of the parent class, the generic to use, and all the arguments to the generic.
This explicitness makes the code easier to understand and will eventually enable certain performance optimizations that would otherwise be very difficult.

## Multiple dispatch

So far we have focused primarily on single dispatch, i.e. generics where `dispatch_on` is a single string.
It is also possible to supply a length 2 (or more!) vector `dispatch_on` to create a generic that performs multiple dispatch, i.e. it uses the classes of more than one object to find the appropriate method.

Multiple dispatch is a feature primarily of S4, although S3 includes some limited special cases for arithmetic operators.
Multiple dispatch is heavily used in S4; we don't expect it to be heavily used in S7, but it is occasionally useful.

### A simple example

Let's take our speak example from `vignette("S7")` and extend it to teach our pets how to speak multiple languages:

```{r}
Pet <- new_class("Pet")
Dog <- new_class("Dog", Pet)
Cat <- new_class("Cat", Pet)

Language <- new_class("Language")
English <- new_class("English", Language)
French <- new_class("French", Language)

speak <- new_generic("speak", c("x", "y"))
method(speak, list(Dog, English)) <- function(x, y) "Woof"
method(speak, list(Cat, English)) <- function(x, y) "Meow"
method(speak, list(Dog, French)) <- function(x, y) "Ouaf Ouaf"
method(speak, list(Cat, French)) <- function(x, y) "Miaou"

speak(Cat(), English())
speak(Dog(), French())

# This example was originally inspired by blog.klipse.tech/javascript/2021/10/03/multimethod.html
# which has unfortunately since disappeared.
```

### Special "classes"

There are two special classes that become particularly useful with multiple dispatch:

-   `class_any()` will match any class
-   `class_missing()` will match a missing argument (i.e. not `NA`, but an argument that was not supplied)

---
title: "Minutes 2022-08-08"
---

## Updates from Hadley

* Talks at useR and rstudio::conf() appeared to go well
* Has resulted in some useful issues and PRs (esp. https://github.com/jamieRowen and https://github.com/dgkf).
* Interest from Merck via email

## Next steps

* HW will continue to work on smaller issues.

* R-core meeting in Vienna (Sept). ML to present S7 work and hopefully get some buy-in.

* Base patches? (https://github.com/RConsortium/S7/issues/222)

* Get to CRAN to get more exposure and figure out how to get into base R itself.

---
title: "Motivation for S7"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Motivation for S7}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

R already has two OO systems built-in (S3 and S4) and many additional OO systems are available in CRAN packages.
Why did we decide more work was needed?
This vignette will discuss some of the motivations behind S7, focussing on the aspects of S3 and S4 that have been found to be particularly challenging in practice.

```{r setup}
library(S7)
```

## Challenges with S3

-   S3 is very informal, meaning that there's no formal definition of a class.
    This makes it impossible to know exactly which properties an object should or could possess, or even what its parent class should be.
    S7 resolves this problem with a formal definition encoded in a class object produced by `new_class()`.
    This includes support for validation (and avoiding validation where needed) as inspired by S4.

-   When a new user encounter an S3 generic, they are often confused because the implementation of the function appears to be missing.
    S7 has a thoughtfully designed print method that makes it clear what methods are available and how to find their source code.

-   Properties of an S3 class are usually stored in attributes, but, by default, `attr()` does partial matching, which can lead to bugs that are hard to diagnose.
    Additionally, `attr()` returns `NULL` if an attribute doesn't exist, so misspelling an attribute can lead to subtle bugs.
    `@` fixes both of these problems.

-   S3 method dispatch is complicated for compatibility with S.
    This complexity affects relatively little code, but when you attempt to dive into the details it makes `UseMethod()` hard to understand.
    As much as possible, S7 avoids any "funny" business with environments or promises, so that there is no distinction between argument values and local values.

-   S3 is primarily designed for single dispatch and double dispatch is only provided for a handful of base generics.
    It's not possible to reuse the implementation for user generics.
    S7 provides a standard way of doing multiple dispatch (including double dispatch) that can be used for any generic.

-   `NextMethod()` is unpredictable since you can't tell exactly which method will be called by only reading the code; you instead need to know both the complete class hierarchy and what other methods are currently registered (and loading a package might change those methods).
    S7 takes a difference approach with `super()`, requiring explicit specification of the superclass to be used.

-   Conversion between S3 classes is only implemented via loose convention: if you implement a class `foo`, then you should also provide generic `as.foo()` to convert other objects to that type.
    S7 avoids this problem by providing the double-dispatch `convert()` generic so that you only need to provide the appropriate methods.

## Challenges with S4

-   Multiple inheritance seemed like a powerful idea at the time, but in practice it appears to generate more problems than it solves.
    S7 does not support multiple inheritance.

-   S4's method dispatch uses a principled but complex distance metric to pick the best method in the presence of ambiguity.
    Time has shown that this approach is hard for people to understand and makes it hard to predict what will happen when new methods are registered.
    S7 implements a much simpler, greedy, approach that trades some additional work on behalf of the class author for a system that is simpler and easier to understand.

-   S4 is a clean break from S3.
    This made it possible to make radical changes but it made it harder to switch from S3 to S4, leading to a general lack of adoption in the R community.
    S7 is designed to be drop-in compatible with S3, making it possible to convert existing packages to use S7 instead of S3 with only an hour or two of work.

<!-- -->

-   At least within Bioconductor, slots are generally thought of as implementation detail that should not be directly accessed by the end-user. This leads to two problems. Firstly, implementing an S4 Bioconductor class often also requires a plethora of accessor functions that are a thin wrapper around `@` or `@<-`. Secondly, users know about `@` and use it to access object internals even though they're not supposed to. S7 avoids these problems by accepting the fact that R is a data language, and that there's no way to stop users from pulling the data they need out of an object. To make it possible to change the internal implementation details of an object while preserving existing `@` usage, S7 provides dynamic properties.

---
title: "Minutes 2022-03-08"
---

## Changes

-   Website updates (<https://rconsortium.github.io/OOP-WG/>): refreshed readme, minutes as articles.
    Working on documentation overhaul in <https://github.com/RConsortium/S7/pull/187>.

-   `new_generic()` now requires `dispatch_args`.
    This means that `new_generic()` will typically be called without names:

    -   `new_generic("foo", "x")`

    -   `new_generic("foo", "x", function(x, y) call_method())`

-   New `class_any` (could already define methods for `S7_object`) and `class_missing` sentinels.

-   When creating an object, unspecified properties are initialized with their default value (#67).
    To achieve this, the constructor arguments default to `class_missing`, since `NULL` would prevent a default value of `NULL`, and `missing()` requires too many gymnastics.

    -   `new_class("foo", properties = list(x = integer, y = double))@constructor`

    -   <https://github.com/RConsortium/S7/blob/main/R/class.R#L209-L212>

-   See other minor changes in\
    <https://github.com/RConsortium/S7/blob/main/NEWS.md#feb-2022>

## Discussion

-   Rename `method_call()`? <https://github.com/RConsortium/S7/issues/200> --- `S7_dispatch()` sounds good.
-   Abstract classes? <https://github.com/RConsortium/S7/issues/199>. Easy to implement but is it worth it?
-   What should we call the S7 equivalent of inherits? <https://github.com/RConsortium/S7/issues/193> --- call it `S7_inherits()` for now; will eventually just be part of inherits. Propose generic extension mechanism for inherits.
-   Explicit S4 registration: <https://github.com/RConsortium/S7/pull/182>
-   New names for base types? <https://github.com/RConsortium/S7/issues/170> --- `class_` sounds good.
-   Convert and super: <https://github.com/RConsortium/S7/pull/181>
-   Should we offer encapsulated OO? <https://github.com/RConsortium/S7/issues/202>

---
title: "Proposal"
description: > 
  Proposal to RConsortium to create the working group.
---

## Executive summary
  
Object-oriented programming enables R developers to implement
abstractions, introduce domain-specific data models, and interface
with external systems, among other things. Unlike other modern
programming languages, R lacks a dominant approach to
object-oriented programming. The competition between existing
approaches is unproductive and contributes to social fragmentation of
the community and technical hurdles when integrating across
different systems.

We propose to form a working group that will develop a design
proposal for a system that will combine the most important elements
from the existing approaches while remaining compatible with
them. We will involve key technical experts and community
stakeholders, including R Core and the tidyverse. Upon publishing
the design proposal, we will invite the entire community to
contribute feedback. Finally, we will conclude the working group by
developing and releasing a strategy for implementing, maintaining,
and adopting the framework.

## Background
  
In R, everything is an object. That principle facilitates
interacting with data, because a dataset is modeled as a tangible,
real world object. The user can display the contents of an object,
introspect its structure and manipulate it in various ways.

R provides all of the basic types of objects necessary for
statistical computing. To more effectively reason about a domain,
like genomics, we need to specialize the data types to more richly
model the semantics particular to that domain. Once we have a
specialized set of data structures, we recognize the need for
/abstraction/, which models commonality across data
types. Abstraction is also useful for existing data types, where a
package could provide an alternative implementation, for example,
based on a database or distributed computing system. Abstraction
requires a system of classification, where each object corresponds
to a specific class, and each class derives from another. The
classification system transcends the class instances (the objects),
and it is helpful to explicitly refer to classes when programming.

Fundamentally, a class-based object-oriented system has two
requirements:
* There is a centrally defined class hierarchy, and
* Every object is an instance of a class.

A class is defined by the contract governing its structure and
contents. The contract extends the contract of the parent class in
order to add semantics through additional constraints while
remaining compatible with the parent contract. Code manipulating
objects will often make assumptions about the structure and content
of objects. To mitigate risk, such low-level code benefits from a
validation function, essentially a codification of the class
contract, to verify its assumptions.

While there is intrinsic value in formal modeling of data, for
software to fully take advantage of the richer semantics, it
requires /polymorphism/, where the behavior of the software
with respect to an object depends on the class of the object.

Most object-oriented languages implement message-passing OOP, where
classes define their own behavior by holding functions, called
methods, in addition to fields. When one class calls a method in
another class, it passes a message.

R has a few systems based on message-passing, most notably the R6
package and reference classes in the methods package. These rely on
message-passing in part because their objects are mutable and it is
easier to reason about code when we can typically assume that it is
the receiver being mutated. We exclude from our scope systems with
mutable objects, because immutable objects are generally preferable
for interactive data analysis, relegating mutable systems to niche
applications, such as GUIs and caching mechanisms.

As appropriate for a statistical computing language, R has
functional roots, and the most prevalent object-oriented approaches
in R are functional systems, namely S3 and S4, corresponding to the
third and fourth version of the S language, respectively. Objects
tend to be immutable, and top-level functions can be generic, which
means means they dispatch to another function, called a method,
based on the types of the passed arguments. The simplest type of
generic dispatches on a single argument. While single dispatch
supports most applications of polymorphism, there are many cases
where the behavior depends on the interaction of two or more
classes. Typical examples include arithmetic, converting an object
from one class to another and combining two different types of
object.

From these considerations, we conclude that a good object-oriented
system would support:
* An explicit class hierarchy (represented by reified objects) with
* Systematic instance construction and validation;
* Multiple, at least double, dispatch, and
* Objects with a transparent, introspectable structure.

## Problem statement
  
The two major OOP frameworks in R, S3 and S4, each have their own
limitations, with neither one being sufficiently applicable to gain
dominance. This had led to social fracturing in the community and
technical impediments to compatibility and interoperability. We
summarize those limitations in the table below.

  | S3 limitations                  | S4 limitations                                       | S4 implementation issues |
  |---------------------------------+------------------------------------------------------+--------------------------|
  | Classes are only implicit       | Multiple inheritance and dispatch hard to understand | Poor performance         |
  | No systematic object validation | Syntax is unusual (side effects) | Difficult to maintain    |
  | Single dispatch only            | Lack of transparency of object structure and methods |                          |

S3 defines classes implicitly at the instance level, so there is no
explicit class hierarchy.  While the S3 system supports tracking the
class of every object, there is no systematic means of constructing
and validating them to ensure correctness. S3 only supports single
dispatch, so it is difficult to write polymorphic code for
arithmetic, merging objects, converting objects, etc.

S4 has solutions to all of those problems, but it is quite
ambitious, introducing significant complexity, unusual syntax
and loss of transparency. Multiple inheritance, while expressive and
powerful, allows for multiple overlapping taxonomies, which is
difficult to reason about, and the difficulty increases
quadratically when combined with multiple dispatch, where method
selection uses a distance calculation in /n/ dimensions where /n/ is
the number of arguments. The syntax for defining classes and methods
is non-idiomatic and relies on side effects. Finally, the S4
convention (although not a requirement) is to hide slots behind an
API, which improves encapsulation but prevents the basic
introspection capabilities that are desirable when analyzing data
and that R users have come to expect.

Somewhat tangentionally, but still motivating, there are also
technical issues with the methods package, the only implementation
of the S4 system. Its incremental growth over the decades has led to
excessive complexity, as well as performance
issues. In the absence of a new system, we would need to reimplement
S4, so there will be implementation effort regardless.

Documentation limitations afflict both S3 and S4. It is difficult to
describe a programming interface when it consists of generic
functions not coupled to each other or any class. Any package can
define a method on a generic or extend a class, so the documentation
needs to adapt according to which packages are loaded.
  
## Proposal

We believe there may be a better way, but the solutions are not
obvious.  Across popular programming languages, with the notable
exception of Julia, functional OOP is much less common and less well
developed than message-passing, so there are few examples for R to
follow and any advances will likely require research. Therefore, we
propose to bring together a panel of experts to more formally assess
the situation and design a solution. Since we are aiming for this
solution to unify the community, we aim for widespread adoption,
which will require involvement by key community leaders. We will
invite the community to review the proposal and to contribute
feedback and ideas. The working group will integrate the feedback
and finalize the proposal. It will conclude after developing a
strategy for implementation, adoption and long-term maintenance, for
which it will not be directly responsible.

No funding is required nor requested for this effort.
  
## Objectives

* Release a finalized design specification for a unifying
 object-oriented programming system,
* Recommend to the ISC a strategy for implementing and maintaining
 the system, as well as driving its adoption.
  
##  Milestones

* Finalize membership,
* Agree upon and prioritize system requirements,
* Iterate through design proposals,
* Release a proposal for community review and contribution,
* Incorporate community contributions,
* Submit the finalized proposal,
* Develop and submit the implementation and adoption strategy.

## Membership

The founding members are:

* Michael Lawrence :: Representing R-core and (S4-based) Bioconductor,
    and a maintainer of the methods package;
* Hadley Wickham :: Representing RStudio and the tidyverse project,
    which relies heavily on S3;
* Martin Maechler :: Representing R-core, maintainer of the
    S4-based Matrix and Rmpfr packages, and a maintainer of the
    methods package.

We have also invited representatives from the R Ladies and ROpenSci
communities.  We will collaborate with others in R Core,
keeping them informed of our plans and incorporating any feedback.

# property retrieval / retrieves the properties that exist & errors otherwise

    Can't find property <foo>@x

---

    Can't find property <foo>@x

# prop setting / can't set read-only properties

    Code
      obj@x <- 1
    Condition
      Error:
      ! Can't set read-only property <foo>@x

# prop setting / errors if the property doesn't exist or is wrong class

    Code
      obj <- foo(123)
      obj@foo <- 10
    Condition
      Error:
      ! Can't find property <foo>@foo
    Code
      obj@x <- "x"
    Condition
      Error:
      ! <foo>@x must be <double>, not <character>

# prop setting / validates all attributes if custom setter

    Code
      obj <- foo(y = 123, x = 123)
      obj@x <- "x"
    Condition
      Error:
      ! <foo>@y must be <double>, not <character>

# props<- / `check = FALSE` skip validation

    Code
      validate(obj)
    Condition
      Error:
      ! <S7::foo> object is invalid:
      - bad

# props<- / set_props() skip validation with `.check = FALSE`

    Code
      validate(obj2)
    Condition
      Error:
      ! <S7::foo> object is invalid:
      - bad

# new_property() / validates getter and settor

    Code
      new_property(getter = function(x) { })
    Condition
      Error:
      ! `getter` must be function(self), not function(x)
    Code
      new_property(setter = function(x, y, z) { })
    Condition
      Error:
      ! `setter` must be function(self, value), not function(x, y, z)

# new_property() / validates default

    Code
      new_property(class_integer, default = "x")
    Condition
      Error in `new_property()`:
      ! `default` must be an instance of <integer>, not a <character>

# new_property() / displays nicely

    Code
      print(x)
    Output
      <S7_property> 
       $ name     : chr "foo"
       $ class    : <S7_base_class>: <integer>
       $ getter   : NULL
       $ setter   : NULL
       $ validator: NULL
       $ default  : NULL
    Code
      str(list(x))
    Output
      List of 1
       $ : <S7_property> 
        ..$ name     : chr "foo"
        ..$ class    : <S7_base_class>: <integer>
        ..$ getter   : NULL
        ..$ setter   : NULL
        ..$ validator: NULL
        ..$ default  : NULL

# properties can be base, S3, S4, S7, or S7 union

    Code
      my_class
    Output
      <my_class> class
      @ parent     : <S7_object>
      @ constructor: function(anything, null, base, S3, S4, S7, S7_union) {...}
      @ validator  : <NULL>
      @ properties :
       $ anything: <ANY>                 
       $ null    : <NULL>                
       $ base    : <integer>             
       $ S3      : S3<factor>            
       $ S4      : S4<class_S4>          
       $ S7      : <class_S7>            
       $ S7_union: <integer> or <logical>

---

    Code
      my_obj@null <- "x"
    Condition
      Error:
      ! <my_class>@null must be <NULL>, not <character>
    Code
      my_obj@base <- "x"
    Condition
      Error:
      ! <my_class>@base must be <integer>, not <character>
    Code
      my_obj@S3 <- "x"
    Condition
      Error:
      ! <my_class>@S3 must be S3<factor>, not <character>
    Code
      my_obj@S4 <- "x"
    Condition
      Error:
      ! <my_class>@S4 must be S4<class_S4>, not <character>
    Code
      my_obj@S7 <- "x"
    Condition
      Error:
      ! <my_class>@S7 must be <class_S7>, not <character>
    Code
      my_obj@S7_union <- "x"
    Condition
      Error:
      ! <my_class>@S7_union must be <integer> or <logical>, not <character>

# as_properties() gives useful error messages

    Code
      as_properties(1)
    Condition
      Error:
      ! `properties` must be a list
    Code
      as_properties(list(1))
    Condition
      Error:
      ! `properties[[1]]` must be named.
    Code
      as_properties(list(new_property(class_character)))
    Condition
      Error:
      ! `properties[[1]]` must have a name or be named.
    Code
      as_properties(list(x = 1))
    Condition
      Error:
      ! Can't convert `property$x` to a valid class. Class specification must be an S7 class object, the result of `new_S3_class()`, an S4 class object, or a base class, not a <double>.
    Code
      as_properties(list(x = class_character, x = class_character))
    Condition
      Error:
      ! `properties` names must be unique

# can validate with custom validator

    Code
      f <- foo(x = 1L)
      f@x <- 1:2
    Condition
      Error:
      ! <foo>@x must be length 1
    Code
      foo(x = 1:2)
    Condition
      Error:
      ! <foo> object properties are invalid:
      - @x must be length 1

# prop<- won't infinitly recurse on a custom setter

    Code
      obj <- foo()
    Output
      Starting syncup with value: 
      setting @a <- "a_"
      setting @b <- "b_"
      Starting syncup with value: b_ 
      setting @a <- "a_b_"
      setting @b <- "b_b_"
      Starting syncup with value: 
      setting @a <- "a_"
      Starting syncup with value: a_ 
      setting @a <- "a_a_"
      setting @b <- "b_a_"
      setting @b <- "b_"
    Code
      obj@a <- "val"
    Output
      Starting syncup with value: val 
      setting @a <- "a_val"
      setting @b <- "b_val"
      Starting syncup with value: b_val 
      setting @a <- "a_b_val"
      setting @b <- "b_b_val"

# custom setters can invoke setters on non-self objects

    Code
      receiver <- Receiver()
    Output
      [rx] receiving:  
      [rx] finished receiving.
    Code
      transmitter <- Transmitter()
    Output
      [tx] sending:  
      [rx] receiving:  
      [rx] finished receiving.
      [tx] saving last sent message.
      [tx] finished transmitting.
    Code
      transmitter@message <- "hello"
    Output
      [tx] sending:  hello 
      [rx] receiving:  hello 
      [rx] finished receiving.
      [tx] saving last sent message.
      [tx] finished transmitting.
    Code
      expect_equal(receiver@message, "hello")
      transmitter@message <- "goodbye"
    Output
      [tx] sending:  goodbye 
      [rx] receiving:  goodbye 
      [rx] finished receiving.
      [tx] saving last sent message.
      [tx] finished transmitting.
    Code
      expect_equal(receiver@message, "goodbye")

# super() / checks to

    Code
      foo <- new_class("foo", package = NULL)
      super(foo(), class_character)
    Condition
      Error in `super()`:
      ! <foo> doesn't inherit from <character>

# super() / displays nicely

    Code
      f1 <- super(foo2(), foo1)
      f1
    Output
      super(<foo2>, <foo1>)
    Code
      str(list(f1))
    Output
      List of 1
       $ : super(<foo2>, <foo1>)

---
title: "Dispatch"
description: Initial notes on dispatch design
---

```{r, include = FALSE}
knitr::opts_chunk$set(comment = "#>", collapse = TRUE)
```

## Single dispatch

### S3

The basic rules of S3 dispatch are simple.
If object has class attribute `c("a", "b", "c")` then generic `f()` looks for methods in the following order:

-   `f.a()`
-   `f.b()`
-   `f.c()`
-   `f.default()`

If no method is found, it errors.

### S7

S7 will behave the same as S3.

## Method lookup

### S3

Where precisely does `UseMethod()` look for the methods?
As of R 4.0.0, it looks in the following three places:

-   The method table is a special environment `.__S3MethodsTable__.` found in the environment where the generic is defined.

-   The chain of environments starting at the `parent.frame()` of the call to generic, ending at the global environment.

-   The base environment (i..e. skips the search).

### S7

S7 methods are defined using assignment:

```{r, eval = FALSE}
method("mean", "numeric") <- function(x) sum(x) / length(x)
```

Behind the scenes, this acts directly upon the method table, so method lookup for S7 generics never needs to look in the parent frame.

`method<-` is likely to start as a shim around `.S3method()` but we may want to consider a separate `.__S7MethodsTable__.`.
This could use a new data structure that resolves generic/class ambiguity (e.g. `all.equal.data.frame()`).
Methods for S7 classes defined on an S3 generics would still use the S3 method table.
Could consider attaching the method table to the generic, instead of its containing environment.

Method lookup would be cached for performance, so that it is only performed once per class.
Cached methods would be marked with a special attribute so that they could be flushed whenever a new method for the generic is added.

## Method call frame

### S3

Once the method has been found, it must be called.
`UseMethod()` does not work like a regular function call but instead:

-   Changes to arguments are ignored.

-   Method can access objects created in generic. (Changed in R 4.4.0.)

-   The parent frame of the method call is the parent frame of the generic.

These properties are summarised in the following example:

```{r}
foo <- function(x, y)  {
  y <- 2
  z <- 2
  UseMethod("foo")
}
foo.numeric <- function(x, y) {
  print(parent.frame())
  c(x = x, y = y, z = z)
}
```

```{r}
#| eval: false
# In R 4.3 and earlier
foo(1, 1)
#> x y z 
#> 1 1 2
```

```{r}
#| error: true
foo(1, 1)
```


### S7

-   Can we eliminate the special behaviour and make it just like a regular function call?
    Presumably easier than changing dispatch rules because we'll call a function other than `UseMethod()`.

-   Need to make precise how arguments are passed to the method.
    `plot()` at least assumes that this works:

    ```{r}
    foo <- function(x, y)  {
      UseMethod("foo")
    }
    foo.numeric <- function(x, y) {
      deparse(substitute(x))
    }
    x <- 10
    foo(x)
    ```

    How does that intersect with assignment within the generic?

## Inheritance

### S3

i.e. how does `NextMethod()` work: currently most state recorded in special variables like `.Generic`, etc.

Can we avoid this confusion:

```{r}
foo <- function(x)  {
  UseMethod("foo")
}
foo.a <- function(x) {
  x <- factor("x")
  NextMethod()
}
foo.b <- function(x) {
  print("In B")
  print(class(x))
}

foo(structure(1, class = c("a", "b")))
```

### S4

Want to avoid this sort of code, where we rely on magic from `callGeneric()` to pass on values from current call.

```{r, eval = FALSE}
method("mean", "foofy") <- function(x, ..., na.rm = TRUE) {
  x <- x@values
  callGeneric()
}
```

### S7

Can we require `generic` and `object` arguments to make code easier to reason about?

```{r, eval = FALSE}
method("mean", "POSIXct") <- function(x) {
  POSIXct(NextMethod(), tz = attr(x, "tz"))
}
# Explicit is nice:
method("mean", "POSIXct") <- function(x) {
  POSIXct(NextMethod("mean", x), tz = attr(x, "tz"))
}
# But what does this do? Is this just an error?
method("mean", "POSIXct") <- function(x) {
  POSIXct(NextMethod("sd", 10), tz = attr(x, "tz"))
}
```

## Group generics

### S3

Group generics (`Math`, `Ops`, `Summary`, `Complex`): exist for some internal generics.
Looked for before final fallback.

```{r}
sloop::s3_dispatch(sum(Sys.time()))
```

### S7

Keep as is.

## Double dispatch

### S3

Used by Ops group generic.
Basic process is find method for first and second arguments.
Then:

-   If same, ok
-   If one internal, use other
-   Otherwise, warn and use internal

### S7

Goal is to use iterated dispatch which implies asymmetry in dispatch order.
User responsible for ensuring that `x + y` equivalent to `y + x` (types should almost always be the same, but values are likely to be different).

```{r}
double_dispatch <- function(x, y, generic = "+") {
  grid <- rev(expand.grid(sloop::s3_class(y), sloop::s3_class(x)))
  writeLines(paste0("* ", generic, ".", grid[[1]], ".", grid[[2]]))
}

ab <- structure(list(), class = c("a", "b"))
cd <- structure(list(), class = c("c", "d"))

double_dispatch(ab, cd)
double_dispatch(cd, ab)

double_dispatch(1, 1L)
```

In vctrs, some question if we will remove inheritance from all double dispatch.
We have already done so for `vec_ptype2()` and `vec_cast()` because the coercion hierarchy often does not match the class hierarchy.
May also do for `vec_arith()`.

## Implicit class

### S3

When `UseMethod()` receives an object without a `class` attribute, it uses the **implicit** class, as provided by `.class2()`.
This is made up of four rough categories: dimension, type, language, numeric.

```{r}
# dimension class
.class2(matrix("a"))
.class2(array("a"))

# typeof(), with some renaming
.class2(sum)
.class2(quote(x))

# language class
.class2(quote({}))
# similarly for if, while, for, =, <-, (

# numeric
.class2(1)
```

Note that internal generics behave differently, instead immediately falling back to the default default case.

### S7

Suggest defining a new `r7class()` function that returns a simplified implicit class, dropping the language classes.

Dispatch should use the same rules in R and in C.
(But are there performance implications?)

## Multi-dispatch

### S3

Special dispatch?
`c()`, `cbind()`, `rbind()` (+ `cbind2()` and `rbind2()`) --- iterated double dispatch.
Need to describe in more detail so we have a more solid assessment of what S7 might need.ez

-   gitDot-dot-dot dispatch, assumes all have same class

-   vctrs used two pass approach (find type then coerce)

### S7

Initially, don't provide support for user generics that dispatch on `…`?
Instead suggest people use `Reduce` plus double-dispatch.

---
title: "Design specification"
description: >
  Design specification used to guide the implementation.
---

This document presents a broad overview of the S7 object-oriented programming toolkit.
(Please note that S7 is a working name and may change in the future.)

## Objects

We define an S7 object as any R object with:

-   A class object attribute, a reference to the **class object**, and retrieved with `classObject()`.
-   For S3 compatibility, a class attribute, a character vector of class names.
-   Additional attributes storing **properties** defined by the class, accessible with `@`/`prop()`.

## Classes

S7 classes are first class objects (Req2) with the following components:

-   **Name**, a human-meaningful descriptor for the class.
    This is used for the default print method and in error messages; it does not identify the class.

-   **Parent**, the class object of the parent class.
    This implies single inheritance (Req6).

-   A **constructor**, an user-facing function used to create new objects of this class.
    It always ends with a call to `newObject()` to initialize the class.
    This the function (wrapped appropriately) that represents the class.

-   **A validator**, a function that takes the object and returns `NULL` if the object is valid, otherwise a character vector of error messages (like the methods package).

-   **Properties**, a list of property objects (see below) that define the data that objects can possess.

Classes are constructed by supplying these components to a call to `newClass()`.
`newClass()` returns a class object that can be called to construct an object of that class.

``` r
newClass(
  name,
  parent = Object,
  constructor = function(...) newObject(...),
  validator = function(x) NULL,
  properties = list()
)
```

For example:

``` r
Range <- newClass("Range",
  Vector,
  constructor = function(start, end) {
    stopifnot(is.numeric(start), is.numeric(end), end >= start)
    newObject(start = start, end = end)
  },
  validator = function(x) {
    if (x@end < x@start) {
      "end must be greater than or equal to start"
    }
  },
  properties = c(start = "numeric", end = "numeric")
)

Range(start = 1, end = 10)
```

### Initialization

The constructor uses `newObject()` to **initialize** a new object.
This:

1.  Inspects the enclosing scope to find the "current" class.
2.  Creates the prototype, by either by calling the parent constructor or by creating a base type and adding `class` and `classObject` attributes to it.
3.  Validates properties then adds to prototype.
4.  Validates the complete object.

Steps 2 and 3 are similar to calling `structure()`, except that property values are initialized and validated through the property system.

### Shortcuts

By convention, any argument that takes a class object can instead take the name of a class object as a string.
The name will be used to find a class object in the calling frame.

Similarly, instead of providing a list of property objects, you can instead provide a named character vector.
For example, `c(name = "character", age = "integer")` is shorthand for `list(newProperty("name", "character"), newProperty("age", "integer"))`.

### Validation

Objects will be validated on initialization and every time a property is modified.
To temporarily opt-out of validation (e.g. in order to transition through a temporarily invalid state), S7 provides `eventuallyValid()`:

``` r
eventuallyValid <- function(object, fun) {
  object$internal_validation_flag <- FALSE
  out <- fun(object)
  out$internal_validation_flag <- TRUE
  validate(out)
}
```

For example, if you wanted to move a Range object to the right, you could write:

``` r
move_right <- function(x, y) {
  eventuallyValid(x, function(x) {
    x@start <- x@start + y
    x@end <- x@end + y
    x
  })
}
```

This ensures that the validation will not trigger if `x@start + y` is greater than `x@end`.

S7 also provides `implicitlyValid()` for expert use.
This is similar to `eventuallyValid()` but does not check for validity at the end.
This can be used in performance critical code where you can ascertain that a sequence of operations can never make a valid object invalid.

(This can be quite hard: for example, in the `move_right()` example above, you might think that that if `x@start < x@end` is true at the beginning, then `x@start + y < x@end + y` will still be true at the end, and you don't need to re-validate the object.
But that's not necessarily true: if `x@start == 1`, `x@end == 2`, and `abs(y) > 2e16` then `x@start + y == x@end + y`!)

### Unions

A class union represents a list of possible classes.
It is used in properties to allow a property to be one of a set of classes, and in method dispatch as a convenience for defining a method for multiple classes.

``` r
ClassUnion <- defineClass("ClassUnion",
  properties = list(classes = "list"),
  validator = function(x) {
    # Checks that all elements of classes are Class object
  },
  constructor = function(...) {
    classes <- list(...)
    # look up Class object from any class vectors
    newObject(classes = classes)
  }
)

ClassUnion("character", "NULL")
ClassUnion(Range, NULL)
```

## Properties

Properties store the data needed by an object.
Properties of an object can be accessed using `@`/`@<-` or `prop()`/`prop<-`.
Setting the properties of an object always triggers validation.

Properties are less encapsulated than their equivalents in most languages because R users expect transparency and want to get to the actual data inside an object and directly manipulate it to get their work done.
Properties this support typical usage while still providing some ability to encapsulate data and hide implementation details.

Every property definition has a:

-   A **name**, used to label output for humans.
-   An optional **class** (or class union).
-   An optional **accessor** function that overrides getting and setting, much like an active binding (by default, the value is stored as attribute, like S3/S4).

Property objects are created by `newProperty()`:

``` r
newProperty(
  name,
  class = NULL,
  accessor = NULL
)
```

Compared to S3 attributes, properties are considerably stricter: a class defines the names and types of its properties.
Compared to S4 slots, properties enable an object to change its internals without breaking existing usage because it can provides a custom accessor that redirects to the new representation.
There will be built-in support for emitting deprecation messages.

While it would be tempting to support public vs. private scoping on properties, it is not obvious how to do so, because no code is more privileged than any another.
Nor is it clear whether the package should define the boundary, when packages sometimes define methods on classes defined in other packages and want to take advantage of their internal representations.
We believe that the encapsulation afforded by properties is a good compromise.

## Generics

A generic separates function interface from implementation: the generic defines the interface, and methods provide the implementation.
For introspection purposes, it knows its name and the names of the arguments in its signature (the arguments considered during dispatch).

Calling `newGeneric()` defines a new generic.
It has the signature:

``` r
newGeneric(name, FUN, signature)
```

The `signature` would default to the first argument, i.e. `formals(FUN)[1]`.
The body of `FUN` would resemble S3 and S4 generics.
It might just call `UseMethod()`.

By convention, any argument that takes a generic function, can instead take the name of a generic function supplied as a string.
The name will be used to find the class object in the calling frame.

## Methods

### Creation

Methods are defined by calling `method<-(generic, signature, method)`:

``` r
method(generic, signature) <- function(x, ...) {}
```

-   `generic` is a generic function.

-   `signature` is a single class object, a class union, list of class objects/unions, or a character vector.

-   `method` is a compatible function, i.e. all arguments before `...` have the same names in the same order; if the generic doesn't have `...` all arguments must be same.

Documentation will discuss the risks of defining a method when you don't own either the generic or the class.

`method<-` is designed to work at run-time (not just package build-time) so that methods can be defined when packages that define classes or generics are loaded after the package that defines the methods.
This typically occurs when providing methods for generics or classes in suggested packages.

``` r
whenLoaded("pkg", {
  method(mean, pkg::A) <- function() 10
  method(sum, pkg::A) <- function() 5
})
```

### Dispatch

Dispatch is nested, meaning that if there are multiple arguments in the generic signature, it will dispatch on the first argument, then the second.
Nested dispatch is likely easier to predict and understand compared to treating all arguments with equal precedence.
Nested dispatch is also easier to implement efficiently, because classes would effectively inherit methods, and we could implement that inheritance using environments.

For example, a `plot()` generic dispatching on `x` could be implemented like this:

``` r
plot <- function(x) {
  method(plot, classObject(x))(x)
}
```

While a `publish()` that publishes an object `x` to a destination `y`, dispatching on both arguments, could be implemented as:

``` r
publish <- function(x, y, ...) {
  sig <- list(classObject(x), classObject(y))
  method(publish, sig)(x, y, ...)
}
```

Because method dispatch is nested, this is presumably equivalent to something like:

``` r
publish <- function(x, y, ...) {
  publish_x <- method(publish, classObject(x))
  publish_xy <- method(publish_x, classObject(y))

  publish_xy(x, y, ...)
}
```

Alternatively, the generics could just call `UseMethod()`, which would gain support for nested dispatch.

## Compatibility

### S3

Since the class attribute has the same semantics as S3, S3 dispatch should be fully compatible.
The new generics should also be able to handle legacy S3 objects.

### S4

In principle, we could modify the methods package so that S4 generics can operate on the new class definitions.
Since the new generics will fallback to S3 dispatch, they should support S4 objects just as S3 generics support them now.

## Documentation

The primary challenge is that the availability of methods and classes depends on which packages are installed, so we will need to generate index pages that list the methods for a generic or the methods with a particular class in their signature.
The documentation blurbs could be lazily scraped at runtime to build an index, similar to how the help search index is created now.
We would then generate help pages from the index.

The index of installed methods could provide additional benefits, including introspection.
A generic could prompt the user to load a package if it fails to find an applicable method, while there is an installed, unloaded method available.
This case would arise when a method is defined outside of the packages that define the class and generic.

# S7 classes / print nicely

    Code
      foo2
    Output
      <foo2> class
      @ parent     : <foo1>
      @ constructor: function(x, y) {...}
      @ validator  : <NULL>
      @ properties :
       $ x: <integer>
       $ y: <integer>
    Code
      str(foo2)
    Output
      <foo2/foo1/S7_object> constructor
       @ name       : chr "foo2"
       @ parent     : <foo1/S7_object> constructor
       @ package    : NULL
       @ properties :List of 2
       .. $ x: <S7_property> 
       ..  ..$ name     : chr "x"
       ..  ..$ class    : <S7_base_class>: <integer>
       ..  ..$ getter   : NULL
       ..  ..$ setter   : NULL
       ..  ..$ validator: NULL
       ..  ..$ default  : NULL
       .. $ y: <S7_property> 
       ..  ..$ name     : chr "y"
       ..  ..$ class    : <S7_base_class>: <integer>
       ..  ..$ getter   : NULL
       ..  ..$ setter   : NULL
       ..  ..$ validator: NULL
       ..  ..$ default  : NULL
       @ abstract   : logi FALSE
       @ constructor: function (x = integer(0), y = integer(0))  
       @ validator  : NULL
    Code
      str(list(foo2))
    Output
      List of 1
       $ : <foo2/foo1/S7_object> constructor

# S7 classes / prints @package and @abstract details

    Code
      foo
    Output
      <S7::foo> abstract class
      @ parent     : <S7_object>
      @ constructor: function() {...}
      @ validator  : <NULL>
      @ properties :

# S7 classes / checks inputs

    Code
      new_class(1)
    Condition
      Error:
      ! `name` must be a single string
    Code
      new_class("foo", 1)
    Condition
      Error:
      ! Can't convert `parent` to a valid class. Class specification must be an S7 class object, the result of `new_S3_class()`, an S4 class object, or a base class, not a <double>.
    Code
      new_class("foo", package = 1)
    Condition
      Error:
      ! `package` must be a single string
    Code
      new_class("foo", constructor = 1)
    Condition
      Error:
      ! `constructor` must be a function
    Code
      new_class("foo", constructor = function() { })
    Condition
      Error:
      ! `constructor` must contain a call to `new_object()`
    Code
      new_class("foo", validator = function() { })
    Condition
      Error:
      ! `validator` must be function(self), not function()

# S7 classes / can't inherit from S4 or class unions

    Code
      new_class("test", parent = parentS4)
    Condition
      Error:
      ! `parent` must be an S7 class, S3 class, or base type, not an S4 class.
    Code
      new_class("test", parent = new_union("character"))
    Condition
      Error:
      ! Can't convert `X[[i]]` to a valid class. Class specification must be an S7 class object, the result of `new_S3_class()`, an S4 class object, or a base class, not a <character>.

# S7 classes / can't inherit from an environment

    Code
      new_class("test", parent = class_environment)
    Condition
      Error:
      ! Can't inherit from an environment.

# abstract classes / can't be instantiated

    Code
      foo <- new_class("foo", abstract = TRUE)
      foo()
    Condition
      Error in `S7::new_object()`:
      ! Can't construct an object from abstract class <foo>

# abstract classes / can't inherit from concrete class

    Code
      foo1 <- new_class("foo1")
      new_class("foo2", parent = foo1, abstract = TRUE)
    Condition
      Error in `new_class()`:
      ! Abstract classes must have abstract parents

# abstract classes / can use inherited validator from abstract class

    Code
      foo2(x = 2)
    Condition
      Error:
      ! <foo2> object is invalid:
      - @x has bad value

# new_object() / gives useful error if called directly

    Code
      new_object()
    Condition
      Error in `new_object()`:
      ! `new_object()` must be called from within a constructor

# new_object() / validates object

    Code
      foo("x")
    Condition
      Error:
      ! <foo> object properties are invalid:
      - @x must be <double>, not <character>
    Code
      foo(-1)
    Condition
      Error:
      ! <foo> object is invalid:
      - x must be positive

# new_object() / runs each parent validator exactly once

    Code
      . <- A()
    Output
      A 
    Code
      . <- B()
    Output
      A B 
    Code
      . <- C()
    Output
      A B C 

# S7 object / displays nicely

    Code
      foo <- new_class("foo", properties = list(x = class_double, y = class_double),
      package = NULL)
      foo()
    Output
      <foo>
       @ x: num(0) 
       @ y: num(0) 
    Code
      str(list(foo()))
    Output
      List of 1
       $ : <foo>
        ..@ x: num(0) 
        ..@ y: num(0) 

# S7 object / displays objects with data nicely

    Code
      text <- new_class("text", class_character, package = NULL)
      text("x")
    Output
      <text> chr "x"
    Code
      str(list(text("x")))
    Output
      List of 1
       $ : <text> chr "x"

# S7 object / displays list objects nicely

    Code
      foo1(list(x = 1, y = list(a = 21, b = 22)), x = 3, y = list(a = 41, b = 42))
    Output
      <foo1> List of 2
       $ x: num 1
       $ y:List of 2
        ..$ a: num 21
        ..$ b: num 22
       @ x: num 3
       @ y:List of 2
       .. $ a: num 41
       .. $ b: num 42

# c(<S7_class>, ...) gives error

    Code
      c(foo1, foo1)
    Condition
      Error:
      ! Can not combine S7 class objects

# can't create class with reserved property names

    Code
      new_class("foo", properties = list(names = class_character))
    Condition
      Error in `new_class()`:
      ! property can't be named: names
    Code
      new_class("foo", properties = list(dim = NULL | class_integer))
    Condition
      Error in `new_class()`:
      ! property can't be named: dim
    Code
      new_class("foo", properties = list(dim = NULL | class_integer, dimnames = class_list))
    Condition
      Error in `new_class()`:
      ! property can't be named: dim, dimnames

# method introspection / errors on invalid inputs

    Code
      method(print, 1)
    Condition
      Error:
      ! `generic` must be a <S7_generic>, not a <closure>
    Code
      foo <- new_generic("foo", "x")
      method(foo)
    Condition
      Error:
      ! Must supply exactly one of `class` and `object`
    Code
      method(foo, 1)
    Condition
      Error:
      ! Can't convert `signature` to a valid class. Class specification must be an S7 class object, the result of `new_S3_class()`, an S4 class object, or a base class, not a <double>.
    Code
      method(foo, new_union(class_integer, class_double))
    Condition
      Error in `as_dispatch()`:
      ! Can't dispatch on unions; must be a concrete type
    Code
      foo2 <- new_generic("foo2", c("x", "y"))
      method(foo2, object = list(class_character))
    Condition
      Error:
      ! `object` must be length 2

# method introspection / errors if no method found

    Code
      method(foo, class = class_integer)
    Condition
      Error:
      ! Can't find method for `foo(<integer>)`.
    Code
      method(foo, object = 1L)
    Condition
      Error:
      ! Can't find method for `foo(<integer>)`.
    Code
      method(foo2, class = list(class_integer, class_double))
    Condition
      Error:
      ! Can't find method for generic `foo(x, y)`:
      - x: <integer>
      - y: <double>
    Code
      method(foo2, object = list(1L, 2))
    Condition
      Error:
      ! Can't find method for generic `foo(x, y)`:
      - x: <integer>
      - y: <double>

# method explanation / shows all possible methods along with matches

       add([foo2], [foo2])
    -> add([foo2], [foo1])
       add([foo2], [S7_object])
       add([foo2], [ANY])
       add([foo1], [foo2])
    *  add([foo1], [foo1])
       add([foo1], [S7_object])
       add([foo1], [ANY])
       add([S7_object], [foo2])
       add([S7_object], [foo1])
       add([S7_object], [S7_object])
       add([S7_object], [ANY])
       add([ANY], [foo2])
       add([ANY], [foo1])
       add([ANY], [S7_object])
       add([ANY], [ANY])

# method registration / adds messages when overwriting

    Code
      method(foo, class_character) <- (function(x) "c")
      method(foo, class_character) <- (function(x) "c")
    Message
      Overwriting method foo(<character>)

# method registration / S3 registration requires a S7 class

    Code
      method(sum, new_S3_class("foo")) <- (function(x, ...) "foo")
    Condition
      Error:
      ! When registering methods for S3 generic sum(), signature must be an S7 class, not an S3 class.

# method registration / can register S7 method for S4 generic

    Class has not been registered with S4; please call S4_register(S4foo)

# method registration / checks argument types

    Code
      x <- 10
      method(x, class_character) <- (function(x) ...)
    Condition
      Error:
      ! `generic` must be a function, not a <double>
    Code
      method(foo, 1) <- (function(x) ...)
    Condition
      Error:
      ! Can't convert `signature` to a valid class. Class specification must be an S7 class object, the result of `new_S3_class()`, an S4 class object, or a base class, not a <double>.

# as_signature() / forbids list for single dispatch

    Code
      as_signature(list(1), foo)
    Condition
      Error:
      ! Can't convert `signature` to a valid class. Class specification must be an S7 class object, the result of `new_S3_class()`, an S4 class object, or a base class, not a <list>.

# as_signature() / requires a list of the correct length for multiple dispatch

    Code
      as_signature(class_character, foo)
    Condition
      Error:
      ! `signature` must be a list for multidispatch generics
    Code
      as_signature(list(class_character), foo)
    Condition
      Error:
      ! `signature` must be length 2

# check_method complains if the functions are not compatible

    Code
      foo <- new_generic("foo", "x")
      check_method(1, foo)
    Condition
      Error:
      ! foo(???) must be a function
    Code
      check_method(function(y) { }, foo)
    Condition
      Error:
      ! foo() dispatches on `x`, but foo(???) has arguments `y`
    Code
      check_method(function(x = "foo") { }, foo)
    Condition
      Error:
      ! In foo(???), dispatch arguments (`x`) must not have default values
    Code
      check_method(function(x, y, ...) { }, foo)

---

    Code
      foo <- new_generic("foo", "x", function(x) S7_dispatch())
      check_method(function(x, y) { }, foo)
    Condition
      Error:
      ! foo() generic lacks `...` so method formals must match generic formals exactly.
      - generic formals: foo(x)
      - method formals:  foo(x, y)

# check_method warn if default arguments don't match

    Code
      foo <- new_generic("foo", "x", function(x, ..., z = 2, y = 1) S7_dispatch())
      check_method(function(x, ..., y = 1) { }, foo)
    Condition
      Warning:
      foo(???) doesn't have argument `z`
    Code
      check_method(function(x, ..., y = 1, z = 1) { }, foo)
    Condition
      Warning:
      In foo(???), default value of `z` is not the same as the generic
      - Generic: 2
      - Method:  1

# S7_method printing

    Code
      method(foo, list(class_integer, class_integer))
    Output
      <S7_method> method(foo, list(class_integer, class_integer))
      function (x, y, ...) 
      paste0("bar:", x, y)
      <environment: 0x0>

---
title: "Requirements"
description: >
  Initial technical requirements brainstorming.
---


This page is for brainstorming on the technical requirements for solving our [problem](https://github.com/RConsortium/S7/wiki/Problem-Statement).
Once we align on the requirements, we can start the design process.

## List of requirements

1.  The system should be as compatible as possible with existing systems, particularly S3
2.  Classes should be first class objects, extrinsic from instances
3.  The system should support formal construction, casting, and coercion to create new instances of classes.
4.  It should be convenient to systematically validate an instance
5.  Double dispatch, and possibly general multiple dispatch, should be supported
6.  Inheritance should be as simple as possible, ideally single (other features might compensate for the lack of multiple inheritance)
7.  Syntax should be intuitive and idiomatic, and should not rely on side effects nor loose conventions
8.  Namespace management should not be any more complicated than S3 currently
9.  Performance should be competitive with existing solutions
10. The design should be simple to implement
11. It should be possible for a package to define a method where the generic and classes are defined outside of the package
12. We should aim to facilitate API evolution, particularly as it relates to inter-package dependencies
13. Methods must include all formal arguments from their generic (not like Julia)
14. Generics should support `...` in their formal argument lists and methods can append arguments to those lists
15. Fields should have "public" visibility, and should support encapsulation (implicit getters and setters)
16. The system should support reflection
17. The system should support lazy and dynamic registration of classes and methods.

## Compatibility

Ideally the new system will be an extension of S3, because S3 is already at the bottom of the stack and many of the other systems have some compatibility with S3.

## Classes as first class objects

It is important for classes to be defined extrinsically from instances, because it makes the data contract more obvious to both developers (reading the code) and users (interacting with objects).
S4 represents classes as proper objects; however, typically developers will only refer to the classes by name (string literal) when interacting with the S4 API. Interacting directly with objects instead would likely simplify the API (syntax) and its implementation.

## Generics as extended function objects

Generic functions should be represented by a special class of function object that tracks its own method table.
This puts generic functions at the same level as classes, which is the essence of functional OOP, and will likely enable more natural syntax in method registration.

## Formal instantiation and type conversion

Class instantiation should happen through a formal constructor.
Once created, an object should keep its original class unless subjected to formal casting or formal coercion.
The class of an object should be robust and predictable, and direct class assignment (e.g. `class<-()`) should generally be avoided.

## Systematic validation

Class contracts are often more complicated than a simple list of typed fields.
Having a formally supported convention around validating objects is important so that code can make the necessary assumptions about data structures and their content.
Otherwise, developers trying to be defensive will resort to ad hoc checks scattered throughout the code.

## Multiple dispatch

The system will at least need to support double dispatch, so that code can be polymorphic on the interaction of two arguments.
There are many obvious examples: arithmetic, serialization (object, target), coercion, etc.
It is less likely that we will require dispatch beyond two arguments, and any advantages are probably outweighed by the increase in complexity.
In many cases of triple dispatch or higher in the wild, developers are abusing dispatch to implement type checks, instead of polymorphism.
Almost always, we can deconstruct multiple dispatch into a series of double dispatch calls.
General multiple dispatch makes software harder to understand and is more difficult to implement.

## Inheritance

Inheritance lets us define a data taxonomy, and it is often natural to organize a set of data structures into multiple, orthogonal taxonomies.
Multiple inheritance enables that; however, it also adds a lot of complexity, both to the software relying on it and the underlying system.
It is often possible and beneficial (in the long term) to rely on techniques like composition and delegation instead.
We should consider how single inheritance languages like Java have been so successful, although they are not directly comparable to our functional system.

## Syntax

The entire API should be free of side effects and odd conventions, like making the `.` character significant in method names.
Whereas S3 supports implicit method registration based on the name of the method, the new system should require methods to be registered explicitly.
Direct manipulation of class and generic objects should enable this.

## Namespaces

The system should support exporting generics and classes.
If classes are objects, they can be treated like any other object when exporting and importing symbols.
If generics are objects, then it should be simple to export all methods on a generic.
It is not clear whether selective method export is important.
One use case would be to hide a method with an internal class in its signature to avoid unnecessary documentation.
Perhaps `R CMD check` could ignore methods for unexported classes.
There should be no need for explicit method registration.

## Third party methods

To fully realize the potential of interoperability afforded by functional OOP, with its treating of generics and classes as orthogonal, we should allow packages to extend an externally defined API so that it supports externally defined classes.
In most cases, a method should only be defined by either the owner of the generic or the owner of the class, but "ownership" is a somewhat nebulous concept.
We acknowledge the potential for conflicts arising from multiple packages defining methods on the same generic and with overlapping signatures, as well as the danger of injecting new behaviors that violate the assumptions of existing method definitions.

## Formal arguments

The formal arguments of a generic must be present in every method for that generic.
This is in contrast to Julia, where methods can have completely different sets of arguments.
We favor a fixed set of formal arguments for the sake of consistency and to enable calling code to depend on a minimal set of arguments that are always present.
If the generic formal argument list includes `...`, then methods can add their own arguments.
The extra arguments are useful for controlling specialized behaviors, as long as the calling code can assume that calling the generic will always dispatch to a method that handles them in accordance with the documentation.
In accordance with the Liskov Substitution Principle, we could explore enforcing that a method only adds arguments to those of a method dispatching on a parent class.
This is easiest to conceptualize and would be most useful in the single dispatch case, but we should also be able to develop a set of rules for nested multiple dispatch.

## Field visibility

Functional OOP is incompatible with the notion of private fields, because code does not run in the context of a class, and thus there is no way to accept or deny access to a field.
R users also expect and appreciate object transparency.
We will consider enabling encapsulation of field access and modification similar to how reference classes allow for defining fields as active bindings.

## Reflection and dynamism

Given a class and a generic, you should be able to find the appropriate method without calling it.
This is important for building tooling around the system.

## Lazy and dynamic registration

On the flip side, you should also be able to register a method lazily/dynamically at run-time.
This is important for:

-   Generics and classes in suggested packages, so that method registration can occur when the dependency is loaded.

-   Testing, since you may want to define a method only within a test.
    This is particularly useful when used to eliminate the need for mocking.

-   Interface evolution, so you can provide a method for a generic or class that does not yet exist, anticipating a future release of a dependency.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/S3.R
\name{new_S3_class}
\alias{new_S3_class}
\title{Declare an S3 class}
\usage{
new_S3_class(class, constructor = NULL, validator = NULL)
}
\arguments{
\item{class}{S3 class vector (i.e. what \code{class()} returns). For method
registration, you can abbreviate this to a single string, the S3 class
name.}

\item{constructor}{An optional constructor that can be used to create
objects of the specified class. This is only needed if you wish to
have an S7 class inherit from an S3 class or to use the S3 class as a
property without a default. It must be specified in the
same way as a S7 constructor: the first argument should be \code{.data}
(the base type whose attributes will be modified).

All arguments to the constructor should have default values so that
when the constructor is called with no arguments, it returns returns
an "empty", but valid, object.}

\item{validator}{An optional validator used by \code{\link[=validate]{validate()}} to check that
the S7 object adheres to the constraints of the S3 class.

A validator is a single argument function that takes the object to
validate and returns \code{NULL} if the object is valid. If the object is
invalid, it returns a character vector of problems.}
}
\value{
An S7 definition of an S3 class, i.e. a list with class
\code{S7_S3_class}.
}
\description{
To use an S3 class with S7, you must explicitly declare it using
\code{new_S3_class()} because S3 lacks a formal class definition.
(Unless it's an important base class already defined in \link{base_s3_classes}.)
}
\section{Method dispatch, properties, and unions}{
There are three ways of using S3 with S7 that only require the S3 class
vector:
\itemize{
\item Registering a S3 method for an S7 generic.
\item Restricting an S7 property to an S3 class.
\item Using an S3 class in an S7 union.
}

This is easy, and you can usually include the \code{new_S3_class()}
call inline:

\if{html}{\out{<div class="sourceCode R">}}\preformatted{method(my_generic, new_S3_class("factor")) <- function(x) "A factor"
new_class("MyClass", properties = list(types = new_S3_class("factor")))
new_union("character", new_S3_class("factor"))
}\if{html}{\out{</div>}}
}

\section{Extending an S3 class}{
Creating an S7 class that extends an S3 class requires more work. You'll
also need to provide a constructor for the S3 class that follows S7
conventions. This means the first argument to the constructor should be
\code{.data}, and it should be followed by one argument for each attribute used
by the class.

This can be awkward because base S3 classes are usually heavily wrapped for user
convenience and no low level constructor is available. For example, the
factor class is an integer vector with a character vector of \code{levels}, but
there's no base R function that takes an integer vector of values and
character vector of levels, verifies that they are consistent, then
creates a factor object.

You may optionally want to also provide a \code{validator} function which will
ensure that \code{\link[=validate]{validate()}} confirms the validity of any S7 classes that build
on this class. Unlike an S7 validator, you are responsible for validating
the types of the attributes.

The following code shows how you might wrap the base Date class.
A Date is a numeric vector with class \code{Date} that can be constructed with
\code{.Date()}.

\if{html}{\out{<div class="sourceCode R">}}\preformatted{S3_Date <- new_S3_class("Date",
  function(.data = integer()) \{
    .Date(.data)
  \},
  function(self) \{
    if (!is.numeric(self)) \{
      "Underlying data must be numeric"
    \}
  \}
)
}\if{html}{\out{</div>}}
}

\examples{
# No checking, just used for dispatch
Date <- new_S3_class("Date")

my_generic <- new_generic("my_generic", "x")
method(my_generic, Date) <- function(x) "This is a date"

my_generic(Sys.Date())
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method-introspect.R
\name{method}
\alias{method}
\title{Find a method for an S7 generic}
\usage{
method(generic, class = NULL, object = NULL)
}
\arguments{
\item{generic}{A generic function, i.e. an \link[=new_generic]{S7 generic},
an \link[=new_external_generic]{external generic}, an \link[=UseMethod]{S3 generic},
or an \link[methods:setGeneric]{S4 generic}.}

\item{class, object}{Perform introspection either with a \code{class}
(processed with \code{\link[=as_class]{as_class()}}) or a concrete \code{object}. If \code{generic} uses
multiple dispatch then both \code{object} and \code{class} must be a list of
classes/objects.}
}
\value{
Either a function with class \code{S7_method} or an error if no
matching method is found.
}
\description{
\code{method()} takes a generic and class signature and performs method dispatch
to find the corresponding method implementation. This is rarely needed
because you'll usually rely on the the generic to do dispatch for you (via
\code{\link[=S7_dispatch]{S7_dispatch()}}). However, this introspection is useful if you want to see
the implementation of a specific method.
}
\examples{
# Create a generic and register some methods
bizarro <- new_generic("bizarro", "x")
method(bizarro, class_numeric) <- function(x) rev(x)
method(bizarro, class_factor) <- function(x) {
  levels(x) <- rev(levels(x))
  x
}

# Printing the generic shows the registered method
bizarro

# And you can use method() to inspect specific implementations
method(bizarro, class = class_integer)
method(bizarro, object = 1)
method(bizarro, class = class_factor)

# errors if method not found
try(method(bizarro, class = class_data.frame))
try(method(bizarro, object = "x"))
}
\seealso{
\code{\link[=method_explain]{method_explain()}} to explain why a specific method was picked.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generic.R, R/method-dispatch.R
\name{new_generic}
\alias{new_generic}
\alias{S7_dispatch}
\title{Define a new generic}
\usage{
new_generic(name, dispatch_args, fun = NULL)

S7_dispatch()
}
\arguments{
\item{name}{The name of the generic. This should be the same as the object
that you assign it to.}

\item{dispatch_args}{A character vector giving the names of one or more
arguments used to find the method.}

\item{fun}{An optional specification of the generic, which must call
\code{S7_dispatch()} to dispatch to methods. This is usually generated
automatically from the \code{dispatch_args}, but you may want to supply it if
you want to add additional required arguments, omit \code{...}, or perform
some standardised computation in the generic.

The \code{dispatch_args} must be the first arguments to \code{fun}, and, if present,
\code{...} must immediately follow them.}
}
\value{
An S7 generic, i.e. a function with class \code{S7_generic}.
}
\description{
A generic function uses different implementations (\emph{methods}) depending on
the class of one or more arguments (the \emph{signature}). Create a new generic
with \code{new_generic()} then use \link{method<-} to add methods to it.

Method dispatch is performed by \code{S7_dispatch()}, which must always be
included in the body of the generic, but in most cases \code{new_generic()} will
generate this for you.

Learn more in \code{vignette("generics-methods")}
}
\section{Dispatch arguments}{

The arguments that are used to pick the method are called the \strong{dispatch
arguments}. In most cases, this will be one argument, in which case the
generic is said to use \strong{single dispatch}. If it consists of more than
one argument, it's said to use \strong{multiple dispatch}.

There are two restrictions on the dispatch arguments: they must be the first
arguments to the generic and if the generic uses \code{...}, it must occur
immediately after the dispatch arguments.
}

\examples{
# A simple generic with methods for some base types and S3 classes
type_of <- new_generic("type_of", dispatch_args = "x")
method(type_of, class_character) <- function(x, ...) "A character vector"
method(type_of, new_S3_class("data.frame")) <- function(x, ...) "A data frame"
method(type_of, class_function) <- function(x, ...) "A function"

type_of(mtcars)
type_of(letters)
type_of(mean)

# If you want to require that methods implement additional arguments,
# you can use a custom function:
mean2 <- new_generic("mean2", "x", function(x, ..., na.rm = FALSE) {
   S7_dispatch()
})

method(mean2, class_numeric) <- function(x, ..., na.rm = FALSE) {
  if (na.rm) {
    x <- x[!is.na(x)]
  }
  sum(x) / length(x)
}

# You'll be warned if you forget the argument:
method(mean2, class_character) <- function(x, ...) {
  stop("Not supported")
}
}
\seealso{
\code{\link[=new_external_generic]{new_external_generic()}} to define a method for a generic
in another package without taking a strong dependency on it.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/property.R
\name{prop_names}
\alias{prop_names}
\alias{prop_exists}
\title{Property introspection}
\usage{
prop_names(object)

prop_exists(object, name)
}
\arguments{
\item{object}{An object from a S7 class}

\item{name}{The name of the parameter as a character. Partial matching
is not performed.}
}
\value{
\code{prop_names()} returns a character vector; \code{prop_exists()} returns
a single \code{TRUE} or \code{FALSE}.
}
\description{
\itemize{
\item \code{prop_names(x)} returns the names of the properties
\item \code{prop_exists(x, "prop")} returns \code{TRUE} iif \code{x} has property \code{prop}.
}
}
\examples{
Foo <- new_class("Foo", properties = list(a = class_character, b = class_integer))
f <- Foo()

prop_names(f)
prop_exists(f, "a")
prop_exists(f, "c")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/union.R
\name{new_union}
\alias{new_union}
\title{Define a class union}
\usage{
new_union(...)
}
\arguments{
\item{...}{The classes to include in the union. See \code{\link[=as_class]{as_class()}} for
details.}
}
\value{
An S7 union, i.e. a list with class \code{S7_union}.
}
\description{
A class union represents a list of possible classes. You can create it
with \code{new_union(a, b, c)} or \code{a | b | c}. Unions can be used in two
places:
\itemize{
\item To allow a property to be one of a set of classes,
\code{new_property(class_integer | Range)}. The default \code{default} value for the
property will be the constructor of the first object in the union.
This means if you want to create an "optional" property (i.e. one that
can be \code{NULL} or of a specified type), you'll need to write (e.g.)
\code{NULL | class_integer}.
\item As a convenient short-hand to define methods for multiple classes.
\code{method(foo, X | Y) <- f} is short-hand for
\verb{method(foo, X) <- f; method(foo, Y) <- foo}
}

S7 includes built-in unions for "numeric" (integer and double vectors),
"atomic" (logical, numeric, complex, character, and raw vectors) and
"vector" (atomic vectors, lists, and expressions).
}
\examples{
logical_or_character <- new_union(class_logical, class_character)
logical_or_character
# or with shortcut syntax
logical_or_character <- class_logical | class_character

Foo <- new_class("Foo", properties = list(x = logical_or_character))
Foo(x = TRUE)
Foo(x = letters[1:5])
try(Foo(1:3))

bar <- new_generic("bar", "x")
# Use built-in union
method(bar, class_atomic) <- function(x) "Hi!"
bar
bar(TRUE)
bar(letters)
try(bar(NULL))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convert.R
\name{convert}
\alias{convert}
\title{Convert an object from one type to another}
\usage{
convert(from, to, ...)
}
\arguments{
\item{from}{An S7 object to convert.}

\item{to}{An S7 class specification, passed to \code{\link[=as_class]{as_class()}}.}

\item{...}{Other arguments passed to custom \code{convert()} methods. For upcasting,
these can be used to override existing properties or set new ones.}
}
\value{
Either \code{from} coerced to class \code{to}, or an error if the coercion
is not possible.
}
\description{
\code{convert(from, to)} is a built-in generic for converting an object from
one type to another. It is special in three ways:
\itemize{
\item It uses double-dispatch, because conversion depends on both \code{from} and
\code{to}.
\item It uses non-standard dispatch because \code{to} is a class, not an object.
\item It doesn't use inheritance for the \code{to} argument. To understand
why, imagine you have written methods to objects of various types to
\code{classParent}. If you then create a new \code{classChild} that inherits from
\code{classParent}, you can't expect the methods written for \code{classParent}
to work because those methods will return \code{classParent} objects, not
\code{classChild} objects.
}

\code{convert()} provides two default implementations:
\enumerate{
\item When \code{from} inherits from \code{to}, it strips any properties that \code{from}
possesses that \code{to} does not (downcasting).
\item When \code{to} is a subclass of \code{from}'s class, it creates a new object of
class \code{to}, copying over existing properties from \code{from} and initializing
new properties of \code{to} (upcasting).
}

If you are converting an object solely for the purposes of accessing a method
on a superclass, you probably want \code{\link[=super]{super()}} instead. See its docs for more
details.
\subsection{S3 & S4}{

\code{convert()} plays a similar role to the convention of defining \code{as.foo()}
functions/generics in S3, and to \code{as()}/\code{setAs()} in S4.
}
}
\examples{
Foo1 <- new_class("Foo1", properties = list(x = class_integer))
Foo2 <- new_class("Foo2", Foo1, properties = list(y = class_double))

# Downcasting: S7 provides a default implementation for coercing an object
# to one of its parent classes:
convert(Foo2(x = 1L, y = 2), to = Foo1)

# Upcasting: S7 also provides a default implementation for coercing an object
# to one of its child classes:
convert(Foo1(x = 1L), to = Foo2)
convert(Foo1(x = 1L), to = Foo2, y = 2.5)  # Set new property
convert(Foo1(x = 1L), to = Foo2, x = 2L, y = 2.5)  # Override existing and set new

# For all other cases, you'll need to provide your own.
try(convert(Foo1(x = 1L), to = class_integer))

method(convert, list(Foo1, class_integer)) <- function(from, to) {
  from@x
}
convert(Foo1(x = 1L), to = class_integer)

# Note that conversion does not respect inheritance so if we define a
# convert method for integer to foo1
method(convert, list(class_integer, Foo1)) <- function(from, to) {
  Foo1(x = from)
}
convert(1L, to = Foo1)

# Converting to Foo2 will still error
try(convert(1L, to = Foo2))
# This is probably not surprising because foo2 also needs some value
# for `@y`, but it definitely makes dispatch for convert() special
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{S7_class}
\alias{S7_class}
\title{Retrieve the S7 class of an object}
\usage{
S7_class(object)
}
\arguments{
\item{object}{The S7 object}
}
\value{
An \link[=new_class]{S7 class}.
}
\description{
Given an S7 object, find it's class.
}
\examples{
Foo <- new_class("Foo")
S7_class(Foo())
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/external-generic.R
\name{new_external_generic}
\alias{new_external_generic}
\title{Generics in other packages}
\usage{
new_external_generic(package, name, dispatch_args, version = NULL)
}
\arguments{
\item{package}{Package the generic is defined in.}

\item{name}{Name of generic, as a string.}

\item{dispatch_args}{Character vector giving arguments used for dispatch.}

\item{version}{An optional version the package must meet for the method to
be registered.}
}
\value{
An S7 external generic, i.e. a list with class
\code{S7_external_generic}.
}
\description{
You need an explicit external generic when you want to provide methods
for a generic (S3, S4, or S7) that is defined in another package, and you
don't want to take a hard dependency on that package.

The easiest way to provide methods for generics in other packages is
import the generic into your \code{NAMESPACE}. This, however, creates a hard
dependency, and sometimes you want a soft dependency, only registering the
method if the package is already installed. \code{new_external_generic()} allows
you to provide the minimal needed information about a generic so that methods
can be registered at run time, as needed, using \code{\link[=methods_register]{methods_register()}}.

Note that in tests, you'll need to explicitly call the generic from the
external package with \code{pkg::generic()}.
}
\examples{
MyClass <- new_class("MyClass")

your_generic <- new_external_generic("stats", "median", "x")
method(your_generic, MyClass) <- function(x) "Hi!"
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/property.R
\name{new_property}
\alias{new_property}
\title{Define a new property}
\usage{
new_property(
  class = class_any,
  getter = NULL,
  setter = NULL,
  validator = NULL,
  default = NULL,
  name = NULL
)
}
\arguments{
\item{class}{Class that the property must be an instance of.
See \code{\link[=as_class]{as_class()}} for details.}

\item{getter}{An optional function used to get the value. The function
should take \code{self} as its sole argument and return the value. If you
supply a \code{getter}, you are responsible for ensuring that it returns
an object of the correct \code{class}; it will not be validated automatically.

If a property has a getter but doesn't have a setter, it is read only.}

\item{setter}{An optional function used to set the value. The function
should take \code{self} and \code{value} and return a modified object.}

\item{validator}{A function taking a single argument, \code{value}, the value
to validate.

The job of a validator is to determine whether the property value is valid.
It should return \code{NULL} if the object is valid, or if it's not valid,
a single string describing the problem. The message should not include the
name of the property as this will be automatically appended to the
beginning of the message.

The validator will be called after the \code{class} has been verified, so
your code can assume that \code{value} has known type.}

\item{default}{When an object is created and the property is not supplied,
what should it default to? If \code{NULL}, it defaults to the "empty" instance
of \code{class}. This can also be a quoted call, which then becomes a standard
function promise in the default constructor, evaluated at the time the
object is constructed.}

\item{name}{Property name, primarily used for error messages. Generally
don't need to set this here, as it's more convenient to supply as
the element name when defining a list of properties. If both \code{name}
and a list-name are supplied, the list-name will be used.}
}
\value{
An S7 property, i.e. a list with class \code{S7_property}.
}
\description{
A property defines a named component of an object. Properties are
typically used to store (meta) data about an object, and are often
limited to a data of a specific \code{class}.

By specifying a \code{getter} and/or \code{setter}, you can make the property
"dynamic" so that it's computed when accessed or has some non-standard
behaviour when modified. Dynamic properties are not included as an argument
to the default class constructor.

See the "Properties: Common Patterns" section in \code{vignette("class-objects")}
for more examples.
}
\examples{
# Simple properties store data inside an object
Pizza <- new_class("Pizza", properties = list(
  slices = new_property(class_numeric, default = 10)
))
my_pizza <- Pizza(slices = 6)
my_pizza@slices
my_pizza@slices <- 5
my_pizza@slices

your_pizza <- Pizza()
your_pizza@slices

# Dynamic properties can compute on demand
Clock <- new_class("Clock", properties = list(
  now = new_property(getter = function(self) Sys.time())
))
my_clock <- Clock()
my_clock@now; Sys.sleep(1)
my_clock@now
# This property is read only, because there is a 'getter' but not a 'setter'
try(my_clock@now <- 10)

# Because the property is dynamic, it is not included as an
# argument to the default constructor
try(Clock(now = 10))
args(Clock)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/valid.R
\name{validate}
\alias{validate}
\alias{valid_eventually}
\alias{valid_implicitly}
\title{Validate an S7 object}
\usage{
validate(object, recursive = TRUE, properties = TRUE)

valid_eventually(object, fun)

valid_implicitly(object, fun)
}
\arguments{
\item{object}{An S7 object}

\item{recursive}{If \code{TRUE}, calls validator of parent classes recursively.}

\item{properties}{If \code{TRUE}, the default, checks property types before
executing the validator.}

\item{fun}{A function to call on the object before validation.}
}
\value{
Either \code{object} invisibly if valid, otherwise an error.
}
\description{
\code{validate()} ensures that an S7 object is valid by calling the \code{validator}
provided in \code{\link[=new_class]{new_class()}}. This is done automatically when constructing new
objects and when modifying properties.

\code{valid_eventually()} disables validation, modifies the object, then
revalidates. This is useful when a sequence of operations would otherwise
lead an object to be temporarily invalid, or when repeated property
modification causes a performance bottleneck because the validator is
relatively expensive.

\code{valid_implicitly()} does the same but does not validate the object at the
end. It should only be used rarely, and in performance critical code where
you are certain a sequence of operations cannot produce an invalid object.
}
\examples{
# A range class might validate that the start is less than the end
Range <- new_class("Range",
  properties = list(start = class_double, end = class_double),
  validator = function(self) {
    if (self@start >= self@end) "start must be smaller than end"
  }
)
# You can't construct an invalid object:
try(Range(1, 1))

# And you can't create an invalid object with @<-
r <- Range(1, 2)
try(r@end <- 1)

# But what if you want to move a range to the right?
rightwards <- function(r, x) {
  r@start <- r@start + x
  r@end <- r@end + x
  r
}
# This function doesn't work because it creates a temporarily invalid state
try(rightwards(r, 10))

# This is the perfect use case for valid_eventually():
rightwards <- function(r, x) {
  valid_eventually(r, function(object) {
    object@start <- object@start + x
    object@end <- object@end + x
    object
  })
}
rightwards(r, 10)

# Alternatively, you can set multiple properties at once using props<-,
# which validates once at the end
rightwards <- function(r, x) {
  props(r) <- list(start = r@start + x, end = r@end + x)
  r
}
rightwards(r, 20)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method-register.R
\name{method<-}
\alias{method<-}
\title{Register an S7 method for a generic}
\usage{
method(generic, signature) <- value
}
\arguments{
\item{generic}{A generic function, i.e. an \link[=new_generic]{S7 generic},
an \link[=new_external_generic]{external generic}, an \link[=UseMethod]{S3 generic},
or an \link[methods:setGeneric]{S4 generic}.}

\item{signature}{A method signature.

For S7 generics that use single dispatch, this must be one of the
following:
\itemize{
\item An S7 class (created by \code{\link[=new_class]{new_class()}}).
\item An S7 union (created by \code{\link[=new_union]{new_union()}}).
\item An S3 class (created by \code{\link[=new_S3_class]{new_S3_class()}}).
\item An S4 class (created by \code{\link[methods:getClass]{methods::getClass()}} or \code{\link[methods:new]{methods::new()}}).
\item A base type like \link{class_logical}, \link{class_integer}, or \link{class_numeric}.
\item A special type like \link{class_missing} or \link{class_any}.
}

For S7 generics that use multiple dispatch, this must be a list of any of
the above types.

For S3 generics, this must be a single S7 class.

For S4 generics, this must either be an S7 class, or a list that includes
at least one S7 class.}

\item{value}{A function that implements the generic specification for the
given \code{signature}.}
}
\value{
The \code{generic}, invisibly.
}
\description{
A generic defines the interface of a function. Once you have created a
generic with \code{\link[=new_generic]{new_generic()}}, you provide implementations for specific
signatures by registering methods with \verb{method<-}.

The goal is for \verb{method<-} to be the single function you need when working
with S7 generics or S7 classes. This means that as well as registering
methods for S7 classes on S7 generics, you can also register methods for
S7 classes on S3 or S4 generics, and S3 or S4 classes on S7 generics.
But this is not a general method registration function: at least one of
\code{generic} and \code{signature} needs to be from S7.

Note that if you are writing a package, you must call \code{\link[=methods_register]{methods_register()}}
in your \code{.onLoad}. This ensures that all methods are dynamically registered
when needed.
}
\examples{
# Create a generic
bizarro <- new_generic("bizarro", "x")
# Register some methods
method(bizarro, class_numeric) <- function(x) rev(x)
method(bizarro, new_S3_class("data.frame")) <- function(x) {
  x[] <- lapply(x, bizarro)
  rev(x)
}

# Using a generic calls the methods automatically
bizarro(head(mtcars))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{S7_data}
\alias{S7_data}
\alias{S7_data<-}
\title{Get/set underlying "base" data}
\usage{
S7_data(object)

S7_data(object, check = TRUE) <- value
}
\arguments{
\item{object}{An object from a S7 class}

\item{check}{If \code{TRUE}, check that \code{value} is of the correct type and run
\code{\link[=validate]{validate()}} on the object before returning.}

\item{value}{Object used to replace the underlying data.}
}
\value{
\code{S7_data()} returns the data stored in the base object;
\verb{S7_data<-()} is called for its side-effects and returns \code{object}
invisibly.
}
\description{
When an S7 class inherits from an existing base type, it can be useful
to work with the underlying object, i.e. the S7 object stripped of class
and properties.
}
\examples{
Text <- new_class("Text", parent = class_character)
y <- Text(c(foo = "bar"))
y
S7_data(y)

S7_data(y) <- c("a", "b")
y
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compatibility.R, R/property.R
\name{prop}
\alias{prop}
\alias{@}
\alias{prop<-}
\alias{@.S7_object}
\title{Get/set a property}
\usage{
prop(object, name)

prop(object, name, check = TRUE) <- value

object@name
}
\arguments{
\item{object}{An object from a S7 class}

\item{name}{The name of the parameter as a character. Partial matching
is not performed.}

\item{check}{If \code{TRUE}, check that \code{value} is of the correct type and run
\code{\link[=validate]{validate()}} on the object before returning.}

\item{value}{A new value for the property. The object is automatically
checked for validity after the replacement is done.}
}
\value{
\code{prop()} and \code{@} return the value of the property.
\verb{prop<-()} and \verb{@<-} are called for their side-effects and return
the modified object, invisibly.
}
\description{
\itemize{
\item \code{prop(x, "name")} / \code{prop@name} get the value of the a property,
erroring if it the property doesn't exist.
\item \code{prop(x, "name") <- value} / \code{prop@name <- value} set the value of
a property.
}
}
\examples{
Horse <- new_class("Horse", properties = list(
  name = class_character,
  colour = class_character,
  height = class_numeric
))
lexington <- Horse(colour = "bay", height = 15, name = "Lex")
lexington@colour
prop(lexington, "colour")

lexington@height <- 14
prop(lexington, "height") <- 15
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/super.R
\name{super}
\alias{super}
\title{Force method dispatch to use a superclass}
\usage{
super(from, to)
}
\arguments{
\item{from}{An S7 object to cast.}

\item{to}{An S7 class specification, passed to \code{\link[=as_class]{as_class()}}. Must be a
superclass of \code{object}.}
}
\value{
An \code{S7_super} object which should always be passed
immediately to a generic. It has no other special behavior.
}
\description{
\code{super(from, to)} causes the dispatch for the next generic to use the method
for the superclass \code{to} instead of the actual class of \code{from}. It's needed
when you want to implement a method in terms of the implementation of its
superclass.
\subsection{S3 & S4}{

\code{super()} performs a similar role to \code{\link[=NextMethod]{NextMethod()}} in S3 or
\code{\link[methods:NextMethod]{methods::callNextMethod()}} in S4, but is much more explicit:
\itemize{
\item The super class that \code{super()} will use is known when write \code{super()}
(i.e. statically) as opposed to when the generic is called
(i.e. dynamically).
\item All arguments to the generic are explicit; they are not automatically
passed along.
}

This makes \code{super()} more verbose, but substantially easier to
understand and reason about.
}

\subsection{\code{super()} in S3 generics}{

Note that you can't use \code{super()} in methods for an S3 generic.
For example, imagine that you have made a subclass of "integer":

\if{html}{\out{<div class="sourceCode r">}}\preformatted{MyInt <- new_class("MyInt", parent = class_integer, package = NULL)
}\if{html}{\out{</div>}}

Now you go to write a custom print method:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{method(print, MyInt) <- function(x, ...) \{
   cat("<MyInt>")
   print(super(x, to = class_integer))
\}

MyInt(10L)
#> <MyInt>super(<MyInt>, <integer>)
}\if{html}{\out{</div>}}

This doesn't work because \code{print()} isn't an S7 generic so doesn't
understand how to interpret the special object that \code{super()} produces.
While you could resolve this problem with \code{\link[=NextMethod]{NextMethod()}} (because S7 is
implemented on top of S3), we instead recommend using \code{\link[=S7_data]{S7_data()}} to extract
the underlying base object:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{method(print, MyInt) <- function(x, ...) \{
   cat("<MyInt>")
   print(S7_data(x))
\}

MyInt(10L)
#> <MyInt>[1] 10
}\if{html}{\out{</div>}}
}
}
\examples{
Foo1 <- new_class("Foo1", properties = list(x = class_numeric, y = class_numeric))
Foo2 <- new_class("Foo2", Foo1, properties = list(z = class_numeric))

total <- new_generic("total", "x")
method(total, Foo1) <- function(x) x@x + x@y

# This won't work because it'll be stuck in an infinite loop:
method(total, Foo2) <- function(x) total(x) + x@z

# We could write
method(total, Foo2) <- function(x) x@x + x@y + x@z
# but then we'd need to remember to update it if the implementation
# for total(<Foo1>) ever changed.

# So instead we use `super()` to call the method for the parent class:
method(total, Foo2) <- function(x) total(super(x, to = Foo1)) + x@z
total(Foo2(1, 2, 3))

# To see the difference between convert() and super() we need a
# method that calls another generic

bar1 <- new_generic("bar1", "x")
method(bar1, Foo1) <- function(x) 1
method(bar1, Foo2) <- function(x) 2

bar2 <- new_generic("bar2", "x")
method(bar2, Foo1) <- function(x) c(1, bar1(x))
method(bar2, Foo2) <- function(x) c(2, bar1(x))

obj <- Foo2(1, 2, 3)
bar2(obj)
# convert() affects every generic:
bar2(convert(obj, to = Foo1))
# super() only affects the _next_ call to a generic:
bar2(super(obj, to = Foo1))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class-spec.R
\name{as_class}
\alias{as_class}
\title{Standard class specifications}
\usage{
as_class(x, arg = deparse(substitute(x)))
}
\arguments{
\item{x}{A class specification. One of the following:
\itemize{
\item An S7 class (created by \code{\link[=new_class]{new_class()}}).
\item An S7 union (created by \code{\link[=new_union]{new_union()}}).
\item An S3 class (created by \code{\link[=new_S3_class]{new_S3_class()}}).
\item An S4 class (created by \code{\link[methods:getClass]{methods::getClass()}} or \code{\link[methods:new]{methods::new()}}).
\item A base class, like \link{class_logical}, \link{class_integer}, or \link{class_double}.
\item A "special", either \link{class_missing} or \link{class_any}.
}}

\item{arg}{Argument name used when generating errors.}
}
\value{
A standardised class: either \code{NULL}, an S7 class, an S7 union,
as \link{new_S3_class}, or a S4 class.
}
\description{
This is used as the interface between S7 and R's other OO systems, allowing
you to use S7 classes and methods with base types, informal S3 classes, and
formal S4 classes.
}
\examples{
as_class(class_logical)
as_class(new_S3_class("factor"))
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\name{S7_object}
\alias{S7_object}
\title{Base S7 class}
\usage{
S7_object()
}
\value{
The base S7 object.
}
\description{
The base class from which all S7 classes eventually inherit from.
}
\examples{

S7_object
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/S3.R
\docType{data}
\name{base_s3_classes}
\alias{base_s3_classes}
\alias{class_factor}
\alias{class_Date}
\alias{class_POSIXct}
\alias{class_POSIXlt}
\alias{class_POSIXt}
\alias{class_data.frame}
\alias{class_formula}
\title{S7 wrappers for key S3 classes}
\usage{
class_factor

class_Date

class_POSIXct

class_POSIXlt

class_POSIXt

class_data.frame

class_formula
}
\description{
S7 bundles \link[=new_S3_class]{S3 definitions} for key S3 classes provided by
the base packages:
\itemize{
\item \code{class_data.frame} for data frames.
\item \code{class_Date} for dates.
\item \code{class_factor} for factors.
\item \code{class_POSIXct}, \code{class_POSIXlt} and \code{class_POSIXt} for date-times.
\item \code{class_formula} for formulas.
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/external-generic.R
\name{methods_register}
\alias{methods_register}
\title{Register methods in a package}
\usage{
methods_register()
}
\value{
Nothing; called for its side-effects.
}
\description{
When using S7 in a package you should always call \code{methods_register()} when
your package is loaded. This ensures that methods are registered as needed
when you implement methods for generics (S3, S4, and S7) in other packages.
(This is not strictly necessary if you only register methods for generics
in your package, but it's better to include it and not need it than forget
to include it and hit weird errors.)
}
\examples{
.onLoad <- function(...) {
  S7::methods_register()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/special.R
\docType{data}
\name{class_any}
\alias{class_any}
\title{Dispatch on any class}
\usage{
class_any
}
\description{
Use \code{class_any} to register a default method that is called when no other
methods are matched.
}
\examples{
foo <- new_generic("foo", "x")
method(foo, class_numeric) <- function(x) "number"
method(foo, class_any) <- function(x) "fallback"

foo(1)
foo("x")
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/base.R
\docType{data}
\name{base_classes}
\alias{base_classes}
\alias{class_logical}
\alias{class_integer}
\alias{class_double}
\alias{class_complex}
\alias{class_character}
\alias{class_raw}
\alias{class_list}
\alias{class_expression}
\alias{class_name}
\alias{class_call}
\alias{class_function}
\alias{class_environment}
\alias{class_numeric}
\alias{class_atomic}
\alias{class_vector}
\alias{class_language}
\title{S7 wrappers for base types}
\usage{
class_logical

class_integer

class_double

class_complex

class_character

class_raw

class_list

class_expression

class_name

class_call

class_function

class_environment

class_numeric

class_atomic

class_vector

class_language
}
\value{
S7 classes wrapping around common base types and S3 classes.
}
\description{
The following S7 classes represent base types allowing them to be used
within S7:
\itemize{
\item \code{class_logical}
\item \code{class_integer}
\item \code{class_double}
\item \code{class_complex}
\item \code{class_character}
\item \code{class_raw}
\item \code{class_list}
\item \code{class_expression}
\item \code{class_name}
\item \code{class_call}
\item \code{class_function}
\item \code{class_environment} (can only be used for properties)
}

We also include three union types to model numerics, atomics, and vectors
respectively:
\itemize{
\item \code{class_numeric} is a union of \code{class_integer} and \code{class_double}.
\item \code{class_atomic} is a union of \code{class_logical}, \code{class_numeric},
\code{class_complex}, \code{class_character}, and \code{class_raw}.
\item \code{class_vector} is a union of \code{class_atomic}, \code{class_list}, and
\code{class_expression}.
\item \code{class_language} is a union of \code{class_name} and \code{class_call}.
}
}
\examples{

class_integer
class_numeric
class_factor
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/S4.R
\name{S4_register}
\alias{S4_register}
\title{Register an S7 class with S4}
\usage{
S4_register(class, env = parent.frame())
}
\arguments{
\item{class}{An S7 class created with \code{\link[=new_class]{new_class()}}.}

\item{env}{Expert use only. Environment where S4 class will be registered.}
}
\value{
Nothing; the function is called for its side-effect.
}
\description{
If you want to use \link{method<-} to register an method for an S4 generic with
an S7 class, you need to call \code{S4_register()} once.
}
\examples{
methods::setGeneric("S4_generic", function(x) {
  standardGeneric("S4_generic")
})

Foo <- new_class("Foo")
S4_register(Foo)
method(S4_generic, Foo) <- function(x) "Hello"

S4_generic(Foo())
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/property.R
\name{props}
\alias{props}
\alias{props<-}
\alias{set_props}
\title{Get/set multiple properties}
\usage{
props(object, names = prop_names(object))

props(object, check = TRUE) <- value

set_props(object, ..., .check = TRUE)
}
\arguments{
\item{object}{An object from a S7 class}

\item{names}{A character vector of property names to retrieve. Default is all
properties.}

\item{check, .check}{If \code{TRUE}, run \code{\link[=validate]{validate()}} on the object
before returning.}

\item{value}{A named list of values. The object is checked for validity
only after all replacements are performed.}

\item{...}{Name-value pairs given property to modify and new value.}
}
\value{
A named list of property values.
}
\description{
\itemize{
\item \code{props(x)} returns all properties.
\item \code{props(x) <- list(name1 = val1, name2 = val2)} modifies an existing object
by setting multiple properties simultaneously.
\item \code{set_props(x, name1 = val1, name2 = val2)} creates a copy of an existing
object with new values for the specified properties.
}
}
\examples{
Horse <- new_class("Horse", properties = list(
  name = class_character,
  colour = class_character,
  height = class_numeric
))
lexington <- Horse(colour = "bay", height = 15, name = "Lex")

props(lexington)
props(lexington) <- list(height = 14, name = "Lexington")
lexington
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method-introspect.R
\name{method_explain}
\alias{method_explain}
\title{Explain method dispatch}
\usage{
method_explain(generic, class = NULL, object = NULL)
}
\arguments{
\item{generic}{A generic function, i.e. an \link[=new_generic]{S7 generic},
an \link[=new_external_generic]{external generic}, an \link[=UseMethod]{S3 generic},
or an \link[methods:setGeneric]{S4 generic}.}

\item{class, object}{Perform introspection either with a \code{class}
(processed with \code{\link[=as_class]{as_class()}}) or a concrete \code{object}. If \code{generic} uses
multiple dispatch then both \code{object} and \code{class} must be a list of
classes/objects.}
}
\value{
Nothing; this function is called for it's side effects.
}
\description{
\code{method_explain()} shows all possible methods that a call to a generic
might use, which ones exist, and which one will actually be called.

Note that method dispatch uses a string representation of each class in
the class hierarchy. Each class system uses a slightly different convention
to avoid ambiguity.
\itemize{
\item S7: \code{pkg::class} or \code{class}
\item S4: \code{S4/pkg::class} or \code{S4/class}
\item S3: \code{class}
}
}
\examples{
Foo1 <- new_class("Foo1")
Foo2 <- new_class("Foo2", Foo1)

add <- new_generic("add", c("x", "y"))
method(add, list(Foo2, Foo1)) <- function(x, y) c(2, 1)
method(add, list(Foo1, Foo1)) <- function(x, y) c(1, 1)

method_explain(add, list(Foo2, Foo2))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/inherits.R
\name{S7_inherits}
\alias{S7_inherits}
\alias{check_is_S7}
\title{Does this object inherit from an S7 class?}
\usage{
S7_inherits(x, class = NULL)

check_is_S7(x, class = NULL, arg = deparse(substitute(x)))
}
\arguments{
\item{x}{An object}

\item{class}{An S7 class or \code{NULL}. If \code{NULL}, tests whether \code{x} is an
S7 object without testing for a specific class.}

\item{arg}{Argument name used in error message.}
}
\value{
\itemize{
\item \code{S7_inherits()} returns a single \code{TRUE} or \code{FALSE}.
\item \code{check_is_S7()} returns nothing; it's called for its side-effects.
}
}
\description{
\itemize{
\item \code{S7_inherits()} returns \code{TRUE} or \code{FALSE}.
\item \code{check_is_S7()} throws an error if \code{x} isn't the specified \code{class}.
}
}
\note{
Starting with \R 4.3.0, \code{base::inherits()} can accept an S7 class as
the second argument, supporting usage like \code{inherits(x, Foo)}.
}
\examples{
Foo1 <- new_class("Foo1")
Foo2 <- new_class("Foo2")

S7_inherits(Foo1(), Foo1)
check_is_S7(Foo1())
check_is_S7(Foo1(), Foo1)

S7_inherits(Foo1(), Foo2)
try(check_is_S7(Foo1(), Foo2))

if (getRversion() >= "4.3.0")
  inherits(Foo1(), Foo1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/special.R
\docType{data}
\name{class_missing}
\alias{class_missing}
\title{Dispatch on a missing argument}
\usage{
class_missing
}
\value{
Sentinel objects used for special types of dispatch.
}
\description{
Use \code{class_missing} to dispatch when the user has not supplied an argument,
i.e. it's missing in the sense of \code{\link[=missing]{missing()}}, not in the sense of
\code{\link[=is.na]{is.na()}}.
}
\examples{
foo <- new_generic("foo", "x")
method(foo, class_numeric) <- function(x) "number"
method(foo, class_missing) <- function(x) "missing"
method(foo, class_any) <- function(x) "fallback"

foo(1)
foo()
foo("")
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{new_class}
\alias{new_class}
\alias{new_object}
\title{Define a new S7 class}
\usage{
new_class(
  name,
  parent = S7_object,
  package = topNamespaceName(parent.frame()),
  properties = list(),
  abstract = FALSE,
  constructor = NULL,
  validator = NULL
)

new_object(.parent, ...)
}
\arguments{
\item{name}{The name of the class, as a string. The result of calling
\code{new_class()} should always be assigned to a variable with this name,
i.e. \code{Foo <- new_class("Foo")}.}

\item{parent}{The parent class to inherit behavior from.
There are three options:
\itemize{
\item An S7 class, like \link{S7_object}.
\item An S3 class wrapped by \code{\link[=new_S3_class]{new_S3_class()}}.
\item A base type, like \link{class_logical}, \link{class_integer}, etc.
}}

\item{package}{Package name. This is automatically resolved if the class is
defined in a package, and \code{NULL} otherwise.

Note, if the class is intended for external use, the constructor should be
exported. Learn more in \code{vignette("packages")}.}

\item{properties}{A named list specifying the properties (data) that
belong to each instance of the class. Each element of the list can
either be a type specification (processed by \code{\link[=as_class]{as_class()}}) or a
full property specification created \code{\link[=new_property]{new_property()}}.}

\item{abstract}{Is this an abstract class? An abstract class can not be
instantiated.}

\item{constructor}{The constructor function. In most cases, you can rely
on the default constructor, which will generate a function with one
argument for each property.

A custom constructor should call \code{new_object()} to create the S7 object.
The first argument, \code{.data}, should be an instance of the parent class
(if used). The subsequent arguments are used to set the properties.}

\item{validator}{A function taking a single argument, \code{self}, the object
to validate.

The job of a validator is to determine whether the object is valid,
i.e. if the current property values form an allowed combination. The
types of the properties are always automatically validated so the job of
the validator is to verify that the \emph{values} of individual properties are
ok (i.e. maybe a property should have length 1, or should always be
positive), or that the \emph{combination} of values of multiple properties is ok.
It is called after construction and whenever any property is set.

The validator should return \code{NULL} if the object is valid. If not, it
should return a character vector where each element describes a single
problem, using \verb{@prop_name} to describe where the problem lies.

See \code{validate()} for more details, examples, and how to temporarily
suppress validation when needed.}

\item{.parent, ...}{Parent object and named properties used to construct the
object.}
}
\value{
A object constructor, a function that can be used to create objects
of the given class.
}
\description{
A class specifies the properties (data) that each of its objects will
possess. The class, and its parent, determines which method will be used
when an object is passed to a generic.

Learn more in \code{vignette("classes-objects")}
}
\examples{
# Create an class that represents a range using a numeric start and end
Range <- new_class("Range",
  properties = list(
    start = class_numeric,
    end = class_numeric
  )
)
r <- Range(start = 10, end = 20)
r
# get and set properties with @
r@start
r@end <- 40
r@end

# S7 automatically ensures that properties are of the declared types:
try(Range(start = "hello", end = 20))

# But we might also want to use a validator to ensure that start and end
# are length 1, and that start is < end
Range <- new_class("Range",
  properties = list(
    start = class_numeric,
    end = class_numeric
  ),
  validator = function(self) {
    if (length(self@start) != 1) {
      "@start must be a single number"
    } else if (length(self@end) != 1) {
      "@end must be a single number"
    } else if (self@end < self@start) {
      "@end must be great than or equal to @start"
    }
  }
)
try(Range(start = c(10, 15), end = 20))
try(Range(start = 20, end = 10))

r <- Range(start = 10, end = 20)
try(r@start <- 25)
}
